Thu Nov 13 22:36:17 2014  CHIKANAGA Tomoyuki  <nagachika@ruby-lang.org>

	* lib/rexml/document.rb: add REXML::Document#document.
	  reported by Tomas Hoger <thoger@redhat.com> and patched by nahi.

Mon Oct 27 20:23:27 2014  NAKAMURA Usaku  <usa@ruby-lang.org>

	* lib/rexml/entity.rb: keep the entity size within the limitation.
	  reported by Willis Vandevanter <will@silentrobots.com> and
	  patched by nahi.

Thu Oct 24 12:00:55 2014  CHIKANAGA Tomoyuki  <nagachika@ruby-lang.org>

	* ext/openssl/lib/openssl/ssl-internal.rb (DEFAULT_PARAMS): override
	  options even if OpenSSL::SSL::OP_NO_SSLv3 is not defined.
	  this is pointed out by Stephen Touset. [ruby-core:65711] [Bug #9424]

Thu Oct 24 12:00:55 2014  Martin Bosslet  <Martin.Bosslet@gmail.com>

	* test/openssl/test_ssl.rb: Reuse TLS default options from
	  OpenSSL::SSL::SSLContext::DEFAULT_PARAMS.

Thu Oct 24 12:00:55 2014  Martin Bosslet  <Martin.Bosslet@gmail.com>

	* lib/openssl/ssl-internal.rb: Explicitly whitelist the default
	  SSL/TLS ciphers. Forbid SSLv2 and SSLv3, disable
	  compression by default.
	  Reported by Jeff Hodges.
	  [ruby-core:59829] [Bug #9424]

Sat Sep  6 09:13:55 2014  Zachary Scott  <e@zzak.io>

	* lib/rdoc/generator/template/darkfish/js/jquery.js: Backport
	  rdoc/rdoc@74f60fcb04fee1778fe2694d1a0ea6513f8e67b7

Wed May 14 17:35:32 2014  NAKAMURA Usaku  <usa@ruby-lang.org>

	* common.mk: need to quote $BASERUBY because it may includes options.
	  this change is only for release management, not bug fix.
	  [Backport #9837] [ruby-dev:48218]

Mon Mar 31 15:38:07 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/openssl/ossl.c (ossl_make_error): check NULL for unknown
	  error reasons with old OpenSSL, and insert a colon iff formatted
	  message is not empty.

Mon Feb 24 12:42:01 2014  Zachary Scott  <e@zzak.io>

	* lib/open-uri.rb: [DOC] use lower case version of core classes, same
	  as commit r44878, based on patch by Jonathan Jackson [Bug #9483]

Mon Feb 24 12:42:01 2014  Zachary Scott  <e@zzak.io>

	* ext/ripper/lib/ripper/lexer.rb: [DOC] use lower case version of core
	  classes when referring to return value, since we aren't directly
	  talking about the class. Patch by Jonathan Jackson [Bug #9483]

Mon Feb 24 12:39:11 2014  Zachary Scott  <e@zzak.io>

	* ext/openssl/ossl_pkey_dh.c: Fixed typo by Sandor Szuecs [Bug #9243]

Mon Feb 24 12:33:38 2014  Zachary Scott  <e@zzak.io>

	* lib/net/smtp.rb: [DOC] Remove dead link to RAA by Giorgos Tsiftsis
	  Fixes the following bugs: [Bug #9152] [Bug #9268] [Bug #9394]
	* lib/open-uri.rb: ditto

Sat Feb 22 19:14:25 2014  NAKAMURA Usaku  <usa@ruby-lang.org>

	* ext/io/console/console.c (console_dev): need read access for conout$
	  because some functions need it.  [Bug#9554]

Sat Feb 22 10:09:42 2014  Eric Wong  <e@80x24.org>

	* ext/socket/ancdata.c (bsock_sendmsg_internal): only retry on error
	  (bsock_recvmsg_internal): ditto
	* test/socket/test_unix.rb: test above for infinite loop

Sat Feb 22 09:51:53 2014  Shugo Maeda  <shugo@ruby-lang.org>

	* ext/socket/init.c (wait_connectable): break if the socket is
	  writable to avoid infinite loops on FreeBSD and other platforms
	  which conforms to SUSv3.  This problem cannot be reproduced with
	  loopback interfaces, so it's hard to write test code.
	  rsock_connect() and wait_connectable() are overly complicated, so
	  they should be refactored, but I commit this fix as a workaround
	  for the release of Ruby 1.9.3 scheduled on Feb 24.
	  [ruby-core:60940] [Bug #9547]

Sat Feb 22 09:26:05 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* class.c (rb_mod_init_copy): do nothing if copying self.
	  [ruby-dev:47989] [Bug #9535]

Tue Feb 18 22:53:34 2014  NAKAMURA Usaku  <usa@ruby-lang.org>

	* ruby_atomic.h: fixed merge mistake of r44946.  reported by ngoto at
	  [ruby-dev:47980] [Backport #9530]

Mon Feb 17 18:04:40 2014  Aaron Pfeifer  <aaron.pfeifer@gmail.com>

	* thread.c (terminate_atfork_i): fix locking mutexes not unlocked in
	  forks when not tracked in thread.  [ruby-core:55102] [Bug #8433]

Fri Feb 14 21:01:12 2014  NAKAMURA Usaku  <usa@ruby-lang.org>

	* ext/socket: revert r44943 because it causes errors on some linux
	  platforms.

Fri Feb 14 20:52:31 2014  NAKAMURA Usaku  <usa@ruby-lang.org>

	* configure.in (ARCH_FLAG): __sync_val_compare_and_swap_4 needs
	  -march=i486 on at least linux gcc 4.1.

Fri Feb 14 19:07:13 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ruby_atomic.h (ATOMIC_PTR_EXCHANGE): atomic exchange function for
	  a generic pointer.

Fri Feb 14 19:07:13 2014  Masaki Matsushita  <glass.saga@gmail.com>

	* ruby_atomic.h: define ATOMIC_SIZE_CAS() with
	  __atomic_compare_exchange_n() and refactoring.

Fri Feb 14 19:07:13 2014  Masaki Matsushita  <glass.saga@gmail.com>

	* ruby_atomic.h: use __atomic builtin functions supported by GCC.
	  __sync family are legacy functions now and it is recommended
	  that new code use the __atomic functions.
	  http://gcc.gnu.org/onlinedocs/gcc/_005f_005fatomic-Builtins.html

	* configure.in: check existence of __atomic functions.

Fri Feb 14 16:21:28 2014  NAKAMURA Usaku  <usa@ruby-lang.org>

	* ruby_atomic.h (ATOMIC_CAS): added.

	* signal.c (ruby_atomic_compare_and_swap): ATOMIC_CAS implementation
	  for non-VC/gcc platform.

Fri Feb 14 15:56:27 2014  Tanaka Akira  <akr@fsij.org>

	* lib/resolv.rb: Ignore name servers which cause EAFNOSUPPORT on
	  socket creation.
	  Reported by Bjoern Rennhak.  [ruby-core:60442] [Bug #9477]

Fri Feb 14 15:54:57 2014  Tanaka Akira  <akr@fsij.org>

	* lib/resolv.rb (Resolv::DNS::Message::MessageDecoder): Raise
	  DecodeError if no data before the limit.
	  Reported by Will Bryant.  [ruby-core:60557] [Bug #9498]

Fri Feb 14 15:49:55 2014  Eric Wong <e@80x24.org>

	* ext/json/generator/depend: add build dependencies for json extension
	  [Bug #9374] [ruby-core:59609]
	* ext/json/parser/depend: ditto

Fri Feb 14 15:40:32 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* iseq.c (iseq_load): keep type_map to get rid of memory leak.
	  based on a patch by Eric Wong at [ruby-core:59699].  [Bug #9399]

Fri Feb 14 15:25:23 2014  Tanaka Akira  <akr@fsij.org>

	* lib/resolv.rb (Resolv::DNS::Resource::TXT#data): Return concatenated
	  string.
	  Patch by Ryan Brunner.  [ruby-core:58220] [Bug #9093]

Fri Feb 14 15:23:43 2014  Tanaka Akira  <akr@fsij.org>

	* ext/socket: Avoid unnecessary ppoll/select on Linux.
	  Patch by Eric Wong.  [ruby-core:57950] [Bug #9039]

Fri Feb 14 15:21:21 2014  Eric Wong <e@80x24.org>

	* benchmark/driver: avoid large alloc in driver process
	  [ruby-core:59869] [Bug #9430]

Fri Feb 14 15:17:17 2014  Yusuke Endoh  <mame@tsg.ne.jp>

	* ext/fiddle/closure.c: use sizeof(*pcl) for correct sizeof value.
	  [ruby-core:57599] [Bug #8978].

Fri Feb 14 15:17:17 2014  Aaron Patterson <aaron@tenderlovemaking.com>

	* ext/fiddle/closure.c: use sizeof(*pcl) for correct sizeof value.
	  [ruby-core:57599] [Bug #8978].  Thanks mame!

Fri Feb 14 15:04:36 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* thread_pthread.c (rb_thread_create_timer_thread): fix for platforms
	  where PTHREAD_STACK_MIN is a dynamic value and not a compile-time
	  constant.  [ruby-dev:47911] [Bug #9436]

Fri Feb 14 15:04:36 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* thread_pthread.c (rb_thread_create_timer_thread): expand timer
	  thread stack size to get rid of segfault on FreeBSD/powerpc64.
	  based on the patch by Steve Wills at [ruby-core:59923].
	  [ruby-core:56590] [Bug #8783]

Fri Feb 14 14:58:19 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* eval.c (rb_mod_s_constants): return its own constants for other
	  than Module itself.  [ruby-core:59763] [Bug #9413]

Fri Feb 14 14:40:27 2014  Masaki Matsushita  <glass.saga@gmail.com>

	* array.c (rb_hash_rehash): use hash_alloc() instead of rb_hash_new().
	  [Bug #9187]

Fri Feb 14 14:40:27 2014  Masaki Matsushita  <glass.saga@gmail.com>

	* hash.c (rb_hash_rehash): make temporary st_table under the control
	  of GC. [Bug #9187]

	* test/ruby/test_hash.rb: add a test for above.

Fri Feb 14 14:40:27 2014  Masaki Matsushita  <glass.saga@gmail.com>

	* hash.c (rb_hash_rehash): fix to free new st_table when exception
	  is raised in do_hash(). [Bug #9187]

Fri Feb 14 13:51:45 2014  Eric Hodel  <drbrain@segment7.net>

	* lib/optparse.rb:  The Integer acceptable now allows binary and
	  hexadecimal numbers per the documentation.  [ruby-trunk - Bug #8865]

	  DecimalInteger, OctalInteger, DecimalNumeric now validate their input
	  before converting to a number.  [ruby-trunk - Bug #8865]

	* test/optparse/test_acceptable.rb:  Tests for the above, tests for all
	  numeric acceptables for existing behavior.

Fri Feb 14 12:52:50 2014  Kouhei Sutou  <kou@cozmixng.org>

	* ext/socket/raddrinfo.c (nogvl_getaddrinfo): Fix indent.

Fri Feb 14 12:52:50 2014  Kouhei Sutou  <kou@cozmixng.org>

	* ext/socket/raddrinfo.c (nogvl_getaddrinfo): Add missing return
	  value assignment.

Fri Feb 14 12:52:50 2014  NARUSE, Yui  <naruse@ruby-lang.org>

	* ext/socket/raddrinfo.c (nogvl_getaddrinfo): work around for Ubuntu
	  13.04's getaddrinfo issue with mdns4. [ruby-list:49420]

Fri Feb 14 12:45:07 2014  NAKAMURA Usaku  <usa@ruby-lang.org>

	* lib/thread.rb (SizedQueue#clear): wake waiting threads when called.
	  [Bug #9342] [ruby-core:59462]

	* test/thread/test_queue.rb: add a test for above.

	patched by Justin Collins.

Thu Feb  6 09:06:00 2014  Kenta Murata  <mrkn@cookpad.com>

	* configure.in (POSTLINK): sign built program using RUBY_CODESIGN
	  identity.
	  [Backport #9491]

	* Makefile.in (PROGRAM): ditto.

	* Makefile.in (LIBRUBY_SO): ditto.

	* lib/mkmf.rb (LINK_SO): sign extensions too.  replace empty line with
	  default command.

	* enc/depend (link_so): prefix $(Q) for each commands.

	* tool/mkconfig.rb: restore embedded newlines.

Wed Feb  5 13:43:02 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* string.c (rb_str_modify_expand): enable capacity and disable
	  assocation with packed objects when setting capa, so that
	  pack("p") string fails to unpack properly after modified.

Sun Feb 2 05:48:42 2014  Eric Wong <e@80x24.org>

	* io.c (rb_io_syswrite): add RB_GC_GUARD
	  [Bug #9472][ruby-core:60407]

Wed Feb  5 11:36:30 2014  NARUSE, Yui  <naruse@ruby-lang.org>

	* configure.in (opt-dir): don't use non portable flag -E of sed.

Thu Jan 30 20:53:42 2014  Tanaka Akira  <akr@fsij.org>

	* ext/socket/lib/socket.rb: Don't test $! in "ensure" clause because
	  it may be set before the body.
	  Reported by ko1 and mrkn.  [ruby-core:59088] [Bug #9247]

	* lib/cgi/core.rb: Ditto.

	* lib/drb/ssl.rb: Ditto.

Thu Jan 30 20:31:32 2014  NARUSE, Yui  <naruse@ruby-lang.org>

	* process.c (rb_daemon): daemon(3) is implemented with fork(2).
	  Therefore it needs rb_thread_atfork(). (and revert r41903)

Thu Jan 30 20:31:32 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* process.c (fork_daemon): kill the other threads all and abandon the
	  kept mutexes.

Thu Jan 30 20:31:32 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* process.c (fork_daemon): kill the other threads all and abandon the
	  kept mutexes.

Thu Jan 30 19:54:16 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* gc.c (finalize_deferred): flush all deferred finalizers while other
	  finalizers can get ready to run newly by lazy sweep.
	  [ruby-core:58833] [Bug #9205]

Thu Jan 30 19:08:00 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* gc.c (rb_gc_finalize_deferred, rb_objspace_call_finalizer):
	  should use ATOMIC_EXCHANGE() to check the previous value.
	  [ruby-dev:44596] [Bug #5439]

Thu Jan 30 19:08:00 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* gc.c (slot_sweep, rb_gc_finalize_deferred)
	  (rb_objspace_call_finalizer, rb_gc): run finalizers
	  sequencially.  [ruby-dev:44562]

Thu Jan 30 11:07:09 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/bigdecimal/bigdecimal.c (CLASS_NAME): macro to wrap
	  depending on PRIsVALUE for 1.9.  [Backport #9406]

	* ext/bigdecimal/bigdecimal.c (DECIMAL_SIZE_OF_BITS): fallback
	  definition for 2.1 or older.  [ruby-core:59750] [Backport #9406]

Wed Jan 29 19:22:45 2014  NAKAMURA Usaku  <usa@ruby-lang.org>

	* enumerator.c: include internal.h instead of declaring the external
	  function there.

Wed Jan 29 18:52:09 2014  NAKAMURA Usaku  <usa@ruby-lang.org>

	* enumerator.c (enumerator_with_index_i): add the declaration of
	  rb_int_succ().  this fixes test failure on OS X introduced at r44745.

Wed Jan 29 14:44:44 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/date/date_strptime.c (date__strptime_internal): unset
	  case-insensitive flag for [:alpha:], which already implies both
	  cases, to get rid of backtrack explosion.  [ruby-core:58984]
	  [Bug #9221]

Wed Jan 29 14:44:44 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/date/date_parse.c (parse_time): unset case-insensitive flag
	  for [:alpha:], which already implies both cases, to get rid of
	  backtrack explosion.  [ruby-core:58876] [Bug #9221]

Wed Jan 29 14:26:10 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* enumerator.c (enumerator_with_index): should not store local variable
	  address to memoise the arguments.  it is invalidated after the return.
	  [ruby-core:58692] [Bug #9178]

Wed Jan 29 14:26:10 2014  NARUSE, Yui  <naruse@ruby-lang.org>

	* enumerator.c (enumerator_with_index): try to convert given offset to
	  integer. fix bug introduced in r39594.

Wed Jan 29 14:20:11 2014  Eric Hodel  <drbrain@segment7.net>

	* enumerator.c (enumerator_with_index):  Restore handling of a nil memo
	  from r39594.

Wed Jan 29 14:08:54 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* include/ruby/win32.h (rb_infinity_float): suppress overflow in
	  constant arithmetic warnings.  [ruby-core:57981] [Bug #9044]

Wed Jan 29 14:08:54 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* win32/Makefile.sub (config.h): VC 2013 supports C99 mathematics
	  functions.  [ruby-core:57981] [Bug #9044]

Wed Jan 29 14:00:15 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* compar.c (cmp_eq): fail if recursion.  [ruby-core:57736] [Bug #9003]

	* thread.c (rb_exec_recursive_paired_outer): new function which is
	  combinnation of paired and outer variants.

Wed Jan 29 13:40:48 2014  Eric Hodel  <drbrain@segment7.net>

	* lib/net/smtp.rb (Net::SMTP#critical):  Always return a
	  Net::SMTP::Response.  Patch by Pawel Veselov.
	  [ruby-trunk - Bug #9125]
	* test/net/smtp/test_smtp.rb:  Test for the above.

Wed Jan 29 13:32:53 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* eval_jump.c (rb_exec_end_proc): unlink and free procs data before
	  calling for each procs.  [Bug #9110]

Wed Jan 29 13:32:53 2014  Masaki Matsushita  <glass.saga@gmail.com>

	* eval_jump.c (rb_exec_end_proc): fix double free or corruption error
	  when reentering by callcc. [ruby-core:58329] [Bug #9110]

	* test/ruby/test_beginendblock.rb: test for above.

Wed Jan 29 13:25:32 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* lib/resolv.rb (Resolv::Hosts#lazy_initialize): should not
	  consider encodings in hosts file.  [ruby-core:59239] [Bug #9273]

	* lib/resolv.rb (Resolv::Config.parse_resolv_conf): ditto.

Wed Jan 29 13:00:17 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* util.c (ruby_qsort): fix potential stack overflow on a large
	  machine.  based on the patch by Conrad Irwin <conrad.irwin AT
	  gmail.com> at [ruby-core:51816].  [Bug #7772]

Wed Jan 29 12:54:13 2014  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* parse.y (local_push_gen, local_pop_gen): save cmdarg_stack to
	  isolate command argument state from outer scope.
	  [ruby-core:59342] [Bug #9308]

Wed Jan 29 12:37:33 2014  Koichi Sasada  <ko1@atdot.net>

	* vm.c (rb_thread_mark): mark a working Proc of bmethod
	  (a method defined by define_method) even if the method was removed.
	  We could not trace working Proc object which represents the body
	  of bmethod if the method was removed (alias/undef/overridden).
	  Simply, it was mark miss.
	  This patch by Kazuki Tsujimoto. [Bug #7825]

	  NOTE: We can brush up this marking because we do not need to mark
	  `me' on each living control frame. We need to mark `me's
	  only if `me' was free'ed. This is future work after Ruby 2.0.0.

	* test/ruby/test_method.rb: add a test.

Wed Jan 29 12:35:37 2014  CHIKANAGA Tomoyuki  <nagachika@ruby-lang.org>

	* lib/rexml/document.rb (REXML::Document.entity_expansion_text_limit):
	  fix a typo in comment in r39384.

Thu Jan  9 14:27:25 2014  Aman Gupta <ruby@tmm1.net>

	* test/net/imap/cacert.pem: generate new CA cert, since the last one
	  expired. [Bug #9341] [ruby-core:59459]
	* test/net/imap/server.crt: new server cert signed with updated CA.
	* test/net/imap/Makefile: add `make regen_certs` to automate this
	  process.

Sun Dec 22 14:25:54 2013  NAKAMURA Usaku  <usa@ruby-lang.org>

	* process.c (redirect_dup2): set standard handles when new fd is stdio,
	  because if there is no allocated console at the moment Windows does
	  not automatically associate it for child process's standard handle.
	  this is adhoc workaround.
	  reported by Martin Thiede at [ruby-core:48542] [Bug #7239].

Tue Dec  3 18:36:42 2013  Narihiro Nakamura  <authornari@gmail.com>

	* object.c (rb_obj_clone): protect FL_MARK of a dest object. A lazy
	  sweeper free up a dest object if a marker is invoked immediately
	  following allocate a dest object in rb_obj_alloc().
	  [Backport #9206]

Sun Dec 22 13:35:58 2013  NAKAMURA Usaku  <usa@ruby-lang.org>

	* lib/rubygems.rb: 1.8.23.2.
	  [ruby-core:58757] [Backport#9193] reported by Jeremy Evans and patched
	  by Eric Hodel.

Fri Nov 22 12:44:56 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* util.c (ruby_strtod): ignore too long fraction part, which does not
	  affect the result.

Fri Nov  1 00:08:21 2013  Martin Bosslet  <Martin.Bosslet@gmail.com>

	* test/openssl/test_pkey_ec.rb: Skip tests for "Oakley" curves as
	  they are not suitable for ECDSA.
	  [ruby-core:54881] [Bug #8384]

Fri Nov  1 00:04:17 2013  Marc-Andre Lafortune  <ruby-core@marc-andre.ca>

	* parse.y: Remove +(binary) and -(binary) special cases
	  [Feature #9048]

Thu Oct 31 23:57:22 2013  Benoit Daloze  <eregontp@gmail.com>

	* test/ruby/test_array.rb (test_count): add a test case for #count
	  with an argument. See Bug #8654.

Thu Oct 31 23:57:22 2013  Benoit Daloze  <eregontp@gmail.com>

	* array.c (rb_ary_count): check length to avoid SEGV
	  while iterating. Remove other pointer loop when arg is given.

	* test/ruby/test_array.rb (test_count): add test for bug.
	  [ruby-core:56072] [Bug #8654]

Thu Oct 31 23:57:22 2013  Masaki Matsushita  <glass.saga@gmail.com>

	* array.c (rb_ary_count): iterate items appropriately.
	  [Bug #8654]

Thu Oct 31 23:42:39 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* lib/tempfile.rb (Tempfile#unlink): finalizer is no longer needed
	  after unlinking.  patched by by normalperson (Eric Wong) at
	  [ruby-core:56521] [Bug #8768]

Thu Oct 31 23:40:43 2013  Zachary Scott  <e@zzak.io>

	* lib/gserver.rb: [DOC] correct gserver.rb license [Bug #8913]

Thu Oct 31 23:35:12 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* vsnprintf.c (MAXEXP, MAXFRACT): calculate depending on constants in
	  float.h.

	* vsnprintf.c (BSD_vfprintf): limit length for cvt() to get rid of
	  buffer overflow.  [ruby-core:57023] [Bug #8864]

	* vsnprintf.c (exponent): make expbuf size more precise.

Thu Oct 31 23:32:41 2013  Michal Rokos  <michal@rokos.cz>

	* configure.in (sys/pstat.h): fix missing header check for
	  missing/setproctitle.c on HP-UX.  [ruby-core:56644] [Bug #8792]

Thu Oct 31 23:25:25 2013  Martin Bosslet  <Martin.Bosslet@gmail.com>

	* ext/openssl/ossl_pkey_ec.c: Ensure compatibility to builds of
	  OpenSSL with OPENSSL_NO_EC2M defined, but OPENSSL_NO_EC not
	  defined.
	* test/openssl/test_pkey_ec.rb: Iterate over built-in curves
	  (and assert their non-emptiness!) instead of hard-coding them, as
	  this may cause problems with respect to the different availability
	  of individual curves in individual OpenSSL builds.
	  [ruby-core:54881] [Bug #8384]

	  Thanks to Vit Ondruch for providing the patch!

Thu Oct 31 23:22:35 2013  NAKAMURA Usaku  <usa@ruby-lang.org>

	* object.c (rb_obj_cmp): [DOC] patched by Keith Bennett
	  <kbennett AT verisign.com>.  [ruby-core:57887] [Backport #9024]

Thu Oct 31 23:10:30 2013  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* test/dl/test_base.rb: {libc, libm} detection now handle GNU/Hurd
	  correctly. Patch by Gabriele Giacone (1o5g4r8o@gmail.com).
	  [Bug #8937][ruby-core:57311]
	* test/fiddle/helper.rb: ditto.

Thu Oct 31 23:05:33 2013  Tanaka Akira  <akr@fsij.org>

	* lib/time.rb (Time.strptime): Time.strptime('0', '%s') returns local
	  time Time object as Ruby 2.0 and before.

Thu Oct 31 23:05:33 2013  Tanaka Akira  <akr@fsij.org>

	* lib/time.rb (Time.strptime): Use :offset.
	  Patch by Felipe Contreras.  [ruby-core:57694]

Thu Oct 31 22:49:56 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* io.c (rb_io_close_read): duplex IO should wait its child process
	  even after close_read.

Thu Oct 31 22:49:56 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* io.c (rb_io_close_read): keep fptr in write_io to be discarded, to
	  fix freed pointer access when it is in use by other threads, and get
	  rid of potential memory/fd leak.

Mon Sep  2 17:21:47 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/date/date_parse.c (rfc2822_cb): check if wday is given, since it
	  can be omitted.

Mon Aug 19 18:36:37 2013  NAKAMURA Usaku  <usa@ruby-lang.org>

	* test/webrick/test_cgi.rb (TestWEBrickCGI#{start_cgi_server,test_cgi}):
	  mswin is not only mswin32 but also mswin64. [Bug #8746]

Mon Aug 19 18:34:31 2013  Charlie Somerville  <charliesome@ruby-lang.org>

	* test/openssl/test_ssl.rb: Fix test for CVE-2013-4073.
	  Patch by Antonio Terceiro. [Bug #8750] [ruby-core:56437]

Mon Aug 19 18:31:26 2013  Kazuhiro NISHIYAMA  <zn@mbf.nifty.com>

	* parse.y: fix build error with bison-3.0.

Fri Aug 16 15:35:10 2013  Tadayoshi Funaba  <tadf@dotrb.org>

	* ext/date/date_{core,strftime}.c: [ruby-core:46990].

Wed Aug 14 09:56:55 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* lib/mkmf.rb (have_framework): allow header file to check.
	  [ruby-core:55745] [Bug #8593]

Fri Aug  9 16:29:22 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* lib/mkmf.rb (xsystem): expand environment variable in all macros not
	  expanded with RbConfig.  [Bug #8702]

	* test/mkmf/test_framework.rb (create_framework): replace all $@ not
	  only once.

Fri Aug  9 15:59:22 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* parse.y (parser_peek_variable_name): treat invalid global, class,
	  and instance variable names as mere strings rather than errors.
	  [ruby-core:54885] [Bug #8375]

Fri Aug  9 15:59:22 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* parse.y (parser_yylex): fail if $, @, @@ are not followed by a valid
	  name character.  [ruby-core:54846] [Bug #8375].

Fri Aug  9 15:56:05 2013  NAKAMURA Usaku  <usa@ruby-lang.org>

	* lib/net/http.rb (Net::HTTP#send_request_with_body_stream): use
	  String#bytesize instead of String#length.
	  reported by shekhei (shek hei wong) at [ruby-core:53775]
	  [Backport #8176].

Fri Aug  9 15:50:11 2013  NAKAMURA Usaku  <usa@ruby-lang.org>

	* win32/win32.c (wrename): use MoveFileExW instead of MoveFileW,
	  because the latter fails on cross device file move of some
	  environments.
	  fix [ruby-core:53492] [Bug #8109]
	  reported by mitchellh (Mitchell Hashimoto)

Thu Aug  8 16:09:26 2013  NAKAMURA Usaku  <usa@ruby-lang.org>

	* test/coverage/test_coverage.rb (TestCoverage#test_big_code): use `1'
	  instead of `p' to get rid of a side effect.
	  Kernel#p without any argument seems to do nothing, but flushes stdout.
	  and, if stdout is redirected to file, fsync() will be called on
	  Windows.  so, when running test-all on Windows with redirection, such
	  as CI environment, this test took a lot of time.

Fri Aug  2 20:41:15 2013  Eric Hodel  <drbrain@segment7.net>

	* ext/openssl/ossl_asn1.c (asn1time_to_time):  Implement YYMMDDhhmmZ
	  format for ASN.1 UTCTime.  [ruby-trunk - Bug #8664]
	* test/openssl/test_asn1.rb:  Test for the above.

Fri Aug  2 20:34:06 2013  Masaki Matsushita  <glass.saga@gmail.com>

	* io.c (io_getpartial): use rb_str_locktmp_ensure().
	  [ruby-core:56121] [Bug #8669]

	* io.c (rb_io_sysread): ditto.

	* test/ruby/test_io.rb: add tests for above.

Fri Aug  2 20:34:06 2013  Masaki Matsushita  <glass.saga@gmail.com>

	* string.c: add internal API rb_str_locktmp_ensure().

	* io.c (io_fread): use rb_str_locktmp_ensure().
	  [ruby-core:56121] [Bug #8669]

	* test/ruby/test_io.rb: add a test for above.

Fri Aug  2 20:03:39 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* rational.c (f_round_common): Rational is expected to be returned by
	  Rational#*, but mathn.rb breaks that assumption.  [ruby-core:56177]
	  [Bug #8687]

Wed Jul 17 11:00:21 2013  Tadayoshi Funaba  <tadf@dotrb.org>

	* ext/date/date_core.c: [ruby-core:46058].

Wed Jul 17 10:14:37 2013  Martin Bosslet  <Martin.Bosslet@gmail.com>

	* lib/openssl/ssl-internal.rb: Fix SSL client connection crash for SAN
	  marked critical.
	  The patch for CVE-2013-4073 caused SSL crash when a SSL server returns
	  the certificate that has critical SAN value.  X509 extension could
	  include 2 or 3 elements in it:

	  [id, criticality, octet_string] if critical,
	  [id, octet_string] if not.

	  Making sure to pick the last element of X509 extension and use it as
	  SAN value.
	  [ruby-core:55685] [Bug #8575]

	  Thank you @nahi for providing the patch!

Wed Jul 17 09:59:33 2013  Tadayoshi Funaba  <tadf@dotrb.org>

	* ext/date/date_core.c: fixed coding error [ruby-core:55337].
	  reported by Riley Lynch.

Wed Jul 17 09:59:33 2013  Tadayoshi Funaba  <tadf@dotrb.org>

	* ext/date/date_core.c: fixed a bug [ruby-core:55295].  reported
	  by Riley Lynch.

Thu Jul 11 10:07:15 2013  Kenta Murata  <mrkn@mrkn.jp>

	* ext/bigdecimal/bigdecimal.c (BigMath_s_exp): Fix for the cases when
	  the argument x is not a BigDecimal.
	  This change is based on the patch made by Heesob Park and Garth Snyder.
	  [Bug #6862] [ruby-core:47145]
	  [Fix GH-332] https://github.com/ruby/ruby/pull/332

Wed Jul 10 10:27:12 2013  NAKAMURA Usaku  <usa@ruby-lang.org>

	* include/ruby/intern.h (rb_path_next, rb_path_skip_prefix,
	  rb_path_last_separator, rb_path_end, ruby_find_basename,
	  ruby_find_extname): restore the declarations of these functions for
	  backword compatibility.

	* filc.c (rb_path_next, rb_path_skip_prefix, rb_path_last_separator,
	  rb_path_end, ruby_find_basename, ruby_find_extname): implements
	  these functions as the wrapper of rb_enc_*().

Wed Jul 10 10:05:40 2013  NAKAMURA Usaku  <usa@ruby-lang.org>

	* include/ruby/intern.h (rb_f_lambda): restore the declaration of
	  rb_f_lambda() for backword compatibility.

Thu Jun 27 20:11:52 2013  NAKAMURA Usaku  <usa@ruby-lang.org>

	* ext/openssl/lib/openssl/ssl-inernal.rb (verify_certificate_identity):
	  fix hostname verification. Patched by nahi.

	* test/openssl/test_ssl.rb (test_verify_certificate_identity): test for
	  above.

Wed Jun 26 18:28:29 2013  NAKAMURA Usaku  <usa@ruby-lang.org>

	* test/ruby/test_m17n.rb: assert_predicate and assert_not_predicate
	  is not available on 1.9.3.

Wed Jun 26 17:08:13 2013  Kazuki Tsujimoto  <kazuki@callcc.net>

	* include/ruby/ruby.h, vm_eval.c (rb_funcall_with_block):
	  new function to invoke a method with a block passed
	  as an argument.

	* string.c (sym_call): use the above function to avoid
	  a block sharing. [ruby-dev:47438] [Bug #8531]

	* vm_insnhelper.c (vm_yield_with_cfunc): don't set block
	  in the frame.

	* test/ruby/test_symbol.rb (TestSymbol#test_block_given_to_proc):
	  run related tests.

Wed Jun 26 17:01:22 2013  NAKAMURA Usaku  <usa@ruby-lang.org>

	* benchmark/bm_hash_shift.rb: add benchmark for Hash#shift

	* hash.c (rb_hash_shift): use st_shift if hash is not being iterated to
	  delete element without iterating the whole hash.

	* hash.c (shift_i): remove function

	* include/ruby/st.h (st_shift): add st_shift function

	* st.c (st_shift): ditto

	[Backport #8328] [ruby-core:55250] Patch by funny-falcon

Wed Jun 26 16:52:57 2013  Kazuki Tsujimoto  <kazuki@callcc.net>

	* test/ruby/test_proc.rb (TestProc#test_block_given_method_to_proc):
	  run test for r41359.

Wed Jun 26 16:52:57 2013  Kazuki Tsujimoto  <kazuki@callcc.net>

	* include/ruby/intern.h, proc.c (rb_method_call_with_block):
	  new function to invoke a Method object with a block passed
	  as an argument.

	* proc.c (bmcall): use the above function to avoid a block sharing.
	  [ruby-core:54626] [Bug #8341]

	* test/ruby/test_proc.rb (TestProc#test_block_persist_between_calls):
	  run related tests.

Wed Jun 26 16:36:39 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* defs/id.def (predefined): add "idProc".

	* proc.c (mnew, mproc, mlambda): use predefined IDs.

	* vm.c (Init_VM): ditto.

Wed Jun 26 16:36:39 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* include/ruby/intern.h (rb_block_lambda): add declaration instead of
	  deprecated rb_f_lambda.

Wed Jun 26 16:31:49 2013  Shugo Maeda  <shugo@ruby-lang.org>

	* lib/net/imap.rb (capability_response): should ignore trailing
	  spaces.  Thanks, Peter Kovacs.  [ruby-core:55024] [Bug #8415]

	* test/net/imap/test_imap_response_parser.rb: related test.

Wed Jun 26 16:29:41 2013  Charlie Somerville  <charliesome@ruby-lang.org>

	* intern.h: remove dangling rb_class_init_copy declaration
	  [ruby-core:55120] [Bug #8434]

Wed Jun 26 16:22:12 2013  Charlie Somerville  <charliesome@ruby-lang.org>

	* class.c (include_modules_at): invalidate method cache if included
	  module contains constants

	* test/ruby/test_module.rb: add test

Wed Jun 26 16:13:25 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* io.c (io_getc): fix 7bit coderange condition, check if ascii read
	  data instead of read length. [ruby-core:55444] [Bug #8516]

Wed Jun 26 16:10:01 2013  Eric Hodel  <drbrain@segment7.net>

	* ext/socket/extconf.rb:  Enable RFC 3542 IPV6 socket options for OS X
	  10.7+.  [ruby-trunk - Bug #8517]

Wed Jun  5 12:38:14 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* win32/win32.c (setup_overlapped, finish_overlapped): extract from
	  rb_w32_read() and rb_w32_write().

Wed May 29 21:03:08 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* configure.in (POSTLINK): default to : command to get rid of flag
	  only command, since BSD make does not work with it.

Wed May 29 20:59:38 2013  NAKAMURA Usaku  <usa@ruby-lang.org>

	* lib/yaml.rb: documentation updates, patched by zzak.
	  [ruby-core:54735] [Backport #8356]

Wed May 15 14:04:39 2013  NAKAMURA Usaku  <usa@ruby-lang.org>

	* Makefile.in (miniruby): 1.9.3 doesn't have POSTLINK macro.
	  reported by Takahiro Kambe at [ruby-list:49362].

Wed May 15 01:06:26 2013  NAKAMURA Usaku  <usa@ruby-lang.org>

	* include/ruby/intern.h: should include sys/time.h for struct timeval
	  if it exists.

Wed May 15 00:23:07 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* configure.in (warnflags): disable -Werror by default unless
	  development.  [ruby-core:52131] [Bug #7830]

Wed May 15 00:21:31 2013  NAKAMURA Usaku  <usa@ruby-lang.org>

	* signal.c: need to include unistd.h for write(2).

Tue May 14 20:25:58 2013  CHIKANAGA Tomoyuki  <nagachika@ruby-lang.org>

	* ext/dl/lib/dl/func.rb (DL::Function#call): check tainted when
	  $SAFE > 0.
	* ext/fiddle/function.c (function_call): check tainted when $SAFE > 0.
	* test/fiddle/test_func.rb (module Fiddle): add test for above.


Tue May 14 11:36:22 2013  Shugo Maeda  <shugo@ruby-lang.org>

	* lib/net/imap.rb (getacl_response): parse the mailbox of an ACL
	  response correctly.  [ruby-core:54365] [Bug #8281]

Tue May 14 11:24:22 2013  Martin Bosslet  <Martin.Bosslet@gmail.com>

	* ext/openssl/ossl_ssl.c: Correct shutdown behavior w.r.t GC.

	* test/openssl/test_ssl.rb: Add tests to verify correct behavior.

	[Bug #8240] Patch provided by Shugo Maeda. Thanks!

Tue May 14 11:22:33 2013  Naohisa Goto  <ngotogenome@gmail.com>

	* configure.in (AC_CHECK_HEADERS): atomic.h for Solaris atomic_ops.

	* ruby_atomic.h: Skip using Solaris10 atomic_ops on Solaris 9 or
	  earlier if atomic.h is not available. [ruby-dev:47229] [Bug #8228]

Tue May 14 10:42:23 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* lib/mkmf.rb (MAIN_DOES_NOTHING): ensure symbols for tests to be
	  preserved.  [ruby-core:53745] [Bug #8169]

Tue May 14 10:42:23 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* lib/mkmf.rb (MAIN_DOES_NOTHING): force to refer symbols for tests
	  to be preserved.  [ruby-core:53745] [Bug #8169]

Tue May 14 10:39:33 2013  NAKAMURA Usaku  <usa@ruby-lang.org>

	* regexec.c (onig_search): fix problem with optimization of \z.
	  [Backport #8210]
	  patched by k_takata at [ruby-core:54251].

Tue May 14 09:36:14 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* time.c (GetTimeval): check if already initialized instance.

	* time.c (GetNewTimeval): check if newly created instance.

	* time.c (time_init_0, time_init_1, time_init_copy, time_mload): must
	  be newly created instance.  [ruby-core:53436] [Bug #8099]

Thu Apr 11 11:24:42 2013  Akinori MUSHA  <knu@iDaemons.org>

	* lib/ipaddr.rb (IPAddr#in6_addr): Fix a typo with the closing
	  parenthesis.

Thu Apr 11 11:24:42 2013  Akinori MUSHA  <knu@iDaemons.org>

	* lib/ipaddr.rb (IPAddr#in6_addr): Fix the parser so that it can
	  recognize IPv6 addresses with only one edge 16-bit piece
	  compressed, like [::2:3:4:5:6:7:8] or [1:2:3:4:5:6:7::].
	  [Bug #7477]

Thu Apr 11 11:22:32 2013  Naohisa Goto  <ngoto@gen-info.osaka-u.ac.jp>

	* string.c (rb_str_concat): set array element after definition
	  to fix compile error with Fujitsu C Compiler 5.6 on Solaris 10
	  on Sparc.  [Bug #5878] [ruby-dev:45123]

Thu Apr 11 11:21:25 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* parse.y (parser_magic_comment): should pass the proper value.
	  [ruby-dev:44984][Bug #5753]

Thu Apr 11 11:18:57 2013  Tadayoshi Funaba  <tadf@dotrb.org>

	* ext/date/date_core.c: [ruby-core:52303]

Thu Apr  4 16:21:39 2013  NAKAMURA Usaku  <usa@ruby-lang.org>

	* ext/objspace/objspace.c (count_nodes): fix key for unknown node.
	  based on a patch by tmm1 (Aman Gupta) in [ruby-core:53130] [Bug #8014]

Thu Apr  4 16:17:14 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* Makefile.in (miniruby, ruby): move MAINLIBC because linker arguments
	  must appear after object files with newer versions of gcc.  patch by
	  tmm1 (Aman Gupta) in [ruby-core:53121] [Bug #8009]

Thu Apr  4 09:44:10 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* configure.in (DLDFLAGS): use TARGET_ENTRY to specify an entry point
	  instead of TARGET which may contain non-identifer characters.

	* lib/mkmf.rb (create_makefile): add TARGET_NAME which is the first
	  part consists of only word characters.  [ruby-core:46248][Bug #6709]

Tue Apr  2 13:13:19 2013  Martin Duerst  <duerst@it.aoyama.ac.jp>

	* transcode.c (documentation for str_encode): Explain
	  that transcoding to the same encoding is a no-op
	  (i.e. no exceptions, no replacements,...).
	  [ruby-core:43557][Bug #6190]

Tue Apr  2 13:13:19 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* transcode.c (str_encode_bang, encoded_dup): if nothing was
	  transcoded, just set encoding but leave coderange unchanged as
	  forcee_encoding.  [ruby-core:43557][Bug #6190]

Tue Apr  2 13:07:29 2013  Tanaka Akira  <akr@fsij.org>

	* time.c (num_exact): use to_r method only if to_int method is
	  available.
	  [ruby-core:53764] [Bug #8173] reported by Hiro Asari.

Tue Apr  2 13:01:55 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* configure.in (EXTDLDFLAGS): split options for each extension
	  libraries, and unused in ruby.pc.  [Bug #6734]

	* lib/mkmf.rb (MakeMakefile#configuration): add EXTDLDFLAGS.

Tue Apr  2 12:59:35 2013  NAKAMURA Usaku  <usa@ruby-lang.org>

	* win32/win32.c (rb_w32_read): Windows 8 fixed one of a bug of console
	  API.
	  based on the patch by Heesob Park at [ruby-core:49479] [Bug #7379]

Tue Apr  2 12:56:15 2013  Naohisa Goto  <ngotogenome@gmail.com>

	* signal.c (ruby_abort): fix typo in r39354 [Bug #5014]

Tue Apr  2 12:56:15 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* signal.c (check_stack_overflow): extract duplicated code and get rid
	  of declaration-after-statement.  [Bug #5014]

Tue Apr  2 12:56:15 2013  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* signal.c (sigsegv): avoid to use async signal unsafe functions
	  when nested sigsegv is happen.
	  [Bug #5014] [ruby-dev:44082]

Fri Mar 29 13:22:15 2013  NAKAMURA Usaku  <usa@ruby-lang.org>

	* include/ruby/missing.h: fixed merge mistake of r39985.
	  [Backport #8080]

Thu Mar 28 19:01:54 2013  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* include/ruby/missing.h: removed __linux__. it's unnecessary.

Thu Mar 28 19:01:54 2013  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* thread.c: disabled _FORTIFY_SOURCE for avoid to hit glibc bug.
	  [Bug #8080] [ruby-core:53349]
	* test/ruby/test_io.rb (TestIO#test_io_select_with_many_files):
	  test for the above.

Thu Mar 28 19:01:54 2013  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* include/ruby/missing.h (__syscall): moved to...
	* io.c: here. because __syscall() is only used from io.c.

	* include/ruby/missing.h: move "#include <sys/type.h>" to ....
	* include/ruby/intern.h: here. because it was introduced for
	  fixing NFDBITS issue. [ruby-core:05179].

Thu Mar 28 19:01:54 2013  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* include/ruby/missing.h (struct timespec): include <sys/time.h>

Thu Mar 28 19:01:54 2013  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* configure.in: check struct timeval exist or not.
	* include/ruby/missing.h (struct timeval): check HAVE_STRUCT_TIMEVAL
	  properly. and don't include sys/time.h if struct timeval exist.

	* file.c: include sys/time.h explicitly.
	* random.c: ditto.
	* thread_pthread.c: ditto.
	* time.c: ditto.
	* ext/date/date_strftime.c: ditto.

Thu Mar 28 18:54:31 2013  NAKAMURA Usaku  <usa@ruby-lang.org>

	* regcomp.c (optimize_node_left, set_optimize_info_from_tree): right
	  handling for look behind anchor.

	* regexec.c (onig_search): ditto.
	  [Backport #8076]

	this patch is derived from Onigmo base tree.

Thu Mar 28 18:35:01 2013  Luis Lavena  <luislavena@gmail.com>

	* win32/file.c (get_user_from_path):  add internal function that retrieves
	  username from supplied path (refactored).
	* win32/file.c (rb_file_expand_path_internal):  refactor expansion of user
	  home to use get_user_from_path and cover dir_string corner cases.
	  [ruby-core:53168] [Bug #8034]

Thu Mar 28 18:35:01 2013  Luis Lavena  <luislavena@gmail.com>

	* win32/file.c (rb_file_expand_path_internal):  Expand home directory when
	  used as second parameter (dir_string).  [ruby-core:53168] [Bug #8034]
	* test/ruby/test_file_exhaustive.rb: add test to verify.

Thu Mar 28 18:18:49 2013  Martin Bosslet  <Martin.Bosslet@googlemail.com>

	* ext/openssl/ossl_asn1.c: raise TypeError when trying to encode nil
	  values for Primitive instances.
	* test/openssl/test_asn1.rb: Assert consistent behavior when
	  encoding nil values: Primitives raise TypeError, Constructives
	  raise NoMethodError.
	  Fixes [ruby-core:43009][Bug #6102]

Thu Mar 28 18:14:41 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* tool/mkconfig.rb: reconstruct comma separated list values.  a
	  command line to Windows batch file is split not only by spaces
	  and equal signs but also by commas and semicolons.

Thu Mar 28 18:13:38 2013  NARUSE, Yui  <naruse@ruby-lang.org>

	* string.c (str_byte_substr): don't set coderange if it's not known.
	  [Bug #7954] [ruby-dev:47108]

Thu Mar 28 18:12:19 2013  Kouhei Sutou  <kou@cozmixng.org>

	* lib/rexml/document.rb: move entity_expansion_text_limit accessor to ...
	* lib/rexml/rexml.rb: ... here to make rexml/text independent from
	  REXML::Document. It causes circular require.
	* lib/rexml/document.rb (REXML::Document.entity_expansion_text_limit):
	  deprecated.
	* lib/rexml/document.rb (REXML::Document.entity_expansion_text_limit=):
	  deprecated.
	* lib/rexml/text.rb: add missing require "rexml/rexml" for
	  REXML.entity_expansion_text_limit.
	  Reported by Robert Ulejczyk. Thanks!!! [ruby-core:52895] [Bug #7961]

Thu Mar 21 20:34:52 2013  NAKAMURA Usaku  <usa@ruby-lang.org>

	* test/win32ole/test_err_in_callback.rb (TestErrInCallBack#setup):
	  allow using different root for source and build directories.
	  this may fixes a minor problem of r39834.

Thu Mar 21 20:34:52 2013  NAKAMURA Usaku  <usa@ruby-lang.org>

	* test/win32ole/test_err_in_callback.rb (TestErrInCallBack#setup): use
	  relative path to get rid of "too long commandline" error.

Thu Mar 21 20:34:52 2013  NAKAMURA Usaku  <usa@ruby-lang.org>

	* test/win32ole/test_err_in_callback.rb
	  (TestErrInCallBack#test_err_in_callback): shouldn't create a file in
	  the top of build directory.

Tue Feb 26 09:53:59 2013  NARUSE, Yui  <naruse@ruby-lang.org>

	* st.c (st_add_direct): int is not always same with st_index_t.  some
	  version of clang reports error.

	* thread.c (vm_living_thread_num): ditto.
	  reported by d6rkaiz (Isao Sugimoto) at [ruby-dev:47096]
	  [Backport #7946]

Fri Feb 22 18:36:51 2013  Aaron Patterson <aaron@tenderlovemaking.com>

	* lib/rexml/document.rb (REXML::Document.entity_expansion_text_limit):
	  new attribute to read/write entity expansion text limit.  the default
	  limit is 10Kb.

	* lib/rexml/text.rb (REXML::Text.unnormalize): check above attribute.

Fri Feb 22 14:48:15 2013  NARUSE, Yui  <naruse@ruby-lang.org>

	* vm.c (vm_exec): get rid of a SEGV when calling rb_iter_break() from
	  some extention libraries. [Backport #7896] [ruby-core:52607]

Fri Feb 22 14:40:57 2013  Narihiro Nakamura  <authornari@gmail.com>

	* gc.c : remove a unused function.

Fri Feb 22 14:40:57 2013  NARUSE, Yui  <naruse@ruby-lang.org>

	* regparse.c (onig_number_of_names): suppress a warning.

Fri Feb 22 14:40:57 2013  NARUSE, Yui  <naruse@ruby-lang.org>

	* vm_insnhelper.c (vm_call_cfunc): remove useless hack.

Fri Feb 22 14:40:57 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* vm_insnhelper.c (vm_call_cfunc): suppress a warning.  note that
	  `volatile type *var' doesn't make var itself volatile.

Fri Feb 22 14:28:17 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* eval_jump.c (rb_exec_end_proc): remember the latest exit status.
	  [ruby-core:43173][Bug #5218]

Fri Feb 22 14:25:57 2013  NARUSE, Yui  <naruse@ruby-lang.org>

	* ext/readline/readline.c (Init_readline): don't set 0 to
	  rl_catch_signals and rl_catch_sigwinch. [Bug #5423]

Wed Feb 13 16:18:22 2013  NAKAMURA Usaku  <usa@ruby-lang.org>

	* ext/json: Import JSON 1.5.5.

Wed Feb  6 17:39:19 2013  Eric Hodel  <drbrain@segment7.net>

	* lib/rdoc: Import RDoc 3.9.5.

Wed Feb  6 14:27:25 2013  Shugo Maeda  <shugo@ruby-lang.org>

	* ext/socket/raddrinfo.c (rsock_unix_sockaddr_len): return
	  sizeof(sa_familiy_t) if path is empty.  see "Autobind Feature" in
	  unix(7) for details.

	* ext/socket/lib/socket.rb (unix_socket_abstract_name?): treat an
	  empty path as an abstract name.

	* test/socket/test_unix.rb: related test.

	* ext/socket/unixsocket.c (rsock_init_unixsock): use rb_inspect()
	  because rb_sys_fail_str() fails if its argument contains NUL.

	* test/socket/test_unix.rb: related test.

	* ext/socket/socket.c (sock_s_pack_sockaddr_un): calculate the
	  correct address length of an abstract socket.

	* test/socket/test_unix.rb: related test.

	* ext/socket/raddrinfo (rsock_unix_sockaddr_len): renamed from
	  rsock_unixpath_len, because it returns not the length of the path,
	  but the length of a socket address for the path.

	* ext/socket/raddrinfo.c (rsock_unixpath_len, init_unix_addrinfo),
	  ext/socket/unixsocket.c (unixsock_connect_internal,
	  rsock_init_unixsock): calculate the correct address length of
	  an abstract socket.  Without this fix, sizeof(struct sockaddr_un)
	  is specified as the length of an abstract socket for bind(2) or
	  connect(2), so the address of the socket is filled with extra NUL
	  characters.  See unix(7) for details.

	* ext/socket/lib/socket.rb (unix_server_socket): don't access the
	  file system if the platform is Linux and path starts with NUL,
	  which means that the socket is an abstract socket.

	* test/socket/test_unix.rb: related test.

	* ext/socket/socket.c (sock_s_pack_sockaddr_un): support the longest
	  path in sockaddr_un, really.
	  reported by nagachika.
	  http://d.hatena.ne.jp/nagachika/20120426/ruby_trunk_changes_35474_35476

	* ext/socket/raddrinfo.c (init_unix_addrinfo): support the longest
	  path in sockaddr_un.
	  (inspect_sockaddr): ditto.
	  (addrinfo_mdump): ditto.
	  (addrinfo_mload): ditto.
	  (rsock_unixpath_str): new function.
	  (rsock_unixpath): removed.
	  (rsock_unixaddr): use rsock_unixpath_str.

	* ext/socket/socket.c (sock_s_pack_sockaddr_un): support the longest
	  path in sockaddr_un.
	  (sock_s_unpack_sockaddr_un): ditto.
	  (sock_s_gethostbyaddr): unused variable removed.

	* ext/socket/unixsocket.c (rsock_init_unixsock): support the longest
	  path in sockaddr_un.

	* ext/socket/rubysocket.h (rsock_unixpath_str): declared.
	  (rsock_unixpath): removed.

	* test/socket/test_unix.rb: comment out test_nul because abstract unix
	  sockets may contain NULs.

Wed Feb  6 14:20:12 2013  Tanaka Akira  <akr@fsij.org>

	* ext/socket/basicsocket.c (bsock_getsockname): ignore truncated
	  part of socket address.
	  (bsock_getpeername): ditto.
	  (bsock_local_address): ditto.
	  (bsock_remote_address): ditto.

	* ext/socket/unixsocket.c (unix_path): ditto.
	  (unix_addr): ditto.
	  (unix_peeraddr): ditto.

	* ext/socket/init.c (cloexec_accept): ditto.

Wed Feb  6 14:19:07 2013  Kouhei Sutou  <kou@cozmixng.org>

	* lib/rexml/parsers/baseparser.rb, test/rexml/test_comment.rb:
	  allow a single hyphen in comment. [Bug #5278] [ruby-core:39289]
	  Reported by Thomas Fritzsche. Thanks!!!

Wed Feb  6 14:14:38 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* file.c (realpath_rec): prevent link from GC while link_names refers
	  the content.

Wed Feb  6 14:13:25 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* missing/setproctitle.c (environ): use (*_NSGetEnviron()) instead of
	  environ on Darwin for namespace cleanness, same as [ruby-core:00537].
	  [ruby-core:45615] [Bug #6576]

Wed Feb  6 14:05:09 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* dir.c (glob_make_pattern): names under recursive need to be single
	  basenames to match for each name.  [ruby-core:47418] [Bug #6977]

Tue Jan 15 16:30:29 2013  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* thread_pthread.c (gvl_init): Reset gvl.wait_yield explicitly when
	  fork()ing. Patch by Apollon Oikonomopoulos. Thanks!
	  [Bug #7693][ruby-core:51424]

Tue Jan 15 16:25:35 2013  Narihiro Nakamura  <authornari@gmail.com>

	* gc.c (rb_objspace_call_finalizer): finalize_deferred may free up
	  a object which is reachable from a part after this function,
	  e.g. ruby_vm_destruct(). [ruby-dev:46647] [Bug #7452]

	* test/ruby/test_gc.rb (test_finalizing_main_thread): add a test
	  for above.

Tue Jan 15 16:23:30 2013  NARUSE, Yui  <naruse@ruby-lang.org>

	* lib/net/protocol.rb (Net::InternetMessageIO#each_crlf_line):
	  treat \r as newline as mame pointed. [ruby-dev:46425] [Bug #7278]

Tue Jan 15 16:23:30 2013  NARUSE, Yui  <naruse@ruby-lang.org>

	* lib/net/protocol.rb (Net::InternetMessageIO#each_crlf_line):
	  don't use /n in universal regexp. [ruby-dev:46394] [Bug #7278]

Tue Jan 15 16:13:47 2013  Kenta Murata  <mrkn@mrkn.jp>

	* ext/bigdecimal/bigdecimal.c (BigDecimal_to_s): use CRuby style.

Tue Jan 15 16:13:47 2013  Kenta Murata  <mrkn@mrkn.jp>

	* ext/bigdecimal/bigdecimal.c: use `RB_TYPE_P(x, t)` instead of
	  `TYPE(x) == t`.

Tue Jan 15 16:13:47 2013  Kenta Murata  <mrkn@mrkn.jp>

	* ext/bigdecimal/bigdecimal.c (BigDecimal_sub):
	  need to specify precision for converting Rational and Float.
	  [ruby-dev:46544] [Bug #7404]

	* ext/bigdecimal/bigdecimal.c (BigDecimal_mult): ditto.

	* ext/bigdecimal/bigdecimal.c (BigDecimal_divide): ditto.

	* ext/bigdecimal/bigdecimal.c (BigDecimal_DoDivmod): ditto.

	* ext/bigdecimal/bigdecimal.c (BigDecimal_divremain): ditto.

	* test/bigdecimal/test_bigdecimal.rb: add tests for the above fixes.

Tue Jan 15 16:03:30 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* tool/mkconfig.rb: use configured libdir value to fix
	  --enable-load-relative on systems where libdir is not default value,
	  overridden in config.site files.  [ruby-core:47267] [Bug #6903]

Tue Jan 15 15:55:09 2013  Eric Hodel  <drbrain@segment7.net>

	* object.c (Init_Object):  Added RDoc location pointers for
	  Kernel#methods, Kernel#protected_methods, Kernel#private_methods and
	  Kernel#public_methods.  [Bug #6666]

Fri Jan 11 17:12:44 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* vm_core.h (rb_iseq_t): move flip_cnt from struct iseq_compile_data,
	  because it has same life span as enclosing iseq.  [Bug #7671]
	  [ruby-core:51296]

Fri Jan 11 17:11:26 2013  NARUSE, Yui  <naruse@ruby-lang.org>

	* lib/mkmf.rb: add dummy clean-static target to prevent errors for the
	  case real clean-static target doesn't exist.

Fri Jan 11 17:02:59 2013  Koichi Sasada  <ko1@atdot.net>

	* vm_exec.h (GENTRY): GENTRY should be pointer size.
	  A patch by yoshidam (Yoshida Masato) [Bug #7332].

Fri Jan 11 16:57:31 2013  NAKAMURA Usaku  <usa@ruby-lang.org>

	* vm_trace.c (rb_threadptr_exec_event_hooks): added a parameter to pop
	  a frame before JUMP_TAG() if exception occurred. This change fix bug
	  of Ruby 1.9. [ruby-core:51128] [ruby-trunk - Bug #7624]

	* vm_core.h (EXEC_EVENT_HOOK_AND_POP_FRAME): add to use
	  `rb_threadptr_exec_event_hooks()' with the pop flag.

	* vm.c (vm_exec): use EXEC_EVENT_HOOK_AND_POP_FRAME() while exception
	  handling. While exception hadnling, if an exception is raised in
	  hooks, need to pop current frame and raise this raised exception by
	  hook.

	* bootstraptest/test_flow.rb: add a test.

Mon Jan  7 15:50:25 2013  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* vm.c (rb_vm_make_proc): save the proc made from the given block so
	  that it will not get collected.  [ruby-core:50545] [Bug #7507]

Tue Dec 25 23:35:09 2012  NARUSE, Yui  <naruse@ruby-lang.org>

	* lib/mkmf.rb: fix for if config["libdir"] is nil.

Tue Dec 25 20:40:47 2012  NAKAMURA Usaku  <usa@ruby-lang.org>

	* bignum.c, include/ruby/intern.h (rb_big_eql): exported.

	* thread.c (recursive_check): object_id maybe a Bignum, not Fixnum on
	  LLP64.  see also r38493 and r38548.
	  reported by Heesob Park at [ruby-core:51083] [Bug #7607], and patched
	  by shirosaki at [ruby-core:51095]

Tue Dec 25 09:54:31 2012  Hiroshi Shirosaki  <h.shirosaki@gmail.com>

	* gc.c (obj_id_to_ref): add a macro to treat Bignum object id.
	  This follows the change r38493.

	* gc.c (id2ref): fix for working fine with Bignum object id on x64
	  Windows.
	* gc.c (wmap_finalize): ditto.

Sat Dec 22 00:33:28 2012  NAKAMURA Usaku  <usa@ruby-lang.org>

	* object.c (rb_obj_hash): shouldn't assume object_id can be long.
	  based on a patch by Heesob Park at [ruby-core:51060].
	  cf. [Backport #7454]

Sat Dec 22 00:33:28 2012  NAKAMURA Usaku  <usa@ruby-lang.org>

	* gc.c (nonspecial_obj_id): VALUE is not compatible with Fixnum on
	  LLP64 platform, such as 64bit Windows.
	  reporeted by Heesob Park at [ruby-core:50255] [Bug #7454], and the
	  fix is suggested by akr.

Fri Dec 21 16:03:54 2012  NAKAMURA Usaku  <usa@ruby-lang.org>

	* test/ruby/test_argf.rb (TestArgf#test_chars): since marshal data is
	  binary, shouldn't pass via text mode.  use base64 encoded data.

Thu Dec 13 23:10:52  Charlie Somerville  <charlie@charliesomerville.com>
	* object.c (Init_Object): use rb_mod_init_copy for Class#initialize_copy
	* class.c (rb_class_init_copy): rename to class_init_copy_check, performs type
	  checks on arguments to prevent reinitialization of initialized class
	  [ruby-core:50869] [Bug #7557]
	* class.c (rb_mod_init_copy): use class_init_copy_check if receiver is T_CLASS
	* test/ruby/test_class.rb (class TestClass): related test


Thu Dec 20 18:46:17 2012  Naohisa Goto  <ngotogenome@gmail.com>

	* test/dl/test_func.rb (test_name_with_block, test_bind, test_qsort1):
	  call unbind to release the callback closure because maximum number
	  of callbacks is limited to DL::MAX_CALLBACK (== 5) with pure DL
	  without Fiddle.

Thu Dec 20 18:46:17 2012  Naohisa Goto  <ngotogenome@gmail.com>

	* ext/dl/lib/dl/func.rb (DL::Function#unbind, #bound?): suppress
	  NoMethodError when Fiddle is available. [ruby-core:50756] [Bug #7543]
	* test/dl/test_func.rb (test_bound*, test_unbind*): tests for the above.

Thu Dec 20 18:46:17 2012  Naohisa Goto  <ngotogenome@gmail.com>

	* ext/dl/lib/dl/func.rb (DL::Function#initialize, DL::Function#bind):
	  ABI should be set by using CFunc#calltype even when Fiddle is used.
	  When Fiddle is used and a block is given, name shoud not be ignored.
	  [ruby-core:50562] [Bug #7514]

	* ext/dl/lib/dl/import.rb (DL::Importer#bind_function): should respect
	  abi and name when Fiddle is used.

	* test/dl/test_func.rb (test_name_with_block): test for "name" method
	  with giving a block.

Thu Dec 20 18:43:00 2012  Naohisa Goto  <ngotogenome@gmail.com>

	* ext/fiddle/extconf.rb, ext/fiddle/function.c
	  (Fiddle::Function::STDCALL): FFI_STDCALL is not a macro, but an
	  enumeration. [ruby-core:50398] [Bug #7483]

Thu Dec 20 18:40:25 2012  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* thread.c (exec_event_hooks): exceptions in event hooks should not
	  propagate outside.

Thu Dec 20 18:37:45 2012  NARUSE, Yui  <naruse@ruby-lang.org>

	* test/ruby/test_m17n_comb.rb (test_str_crypt): Use RbConfig to get
	  libc's directory. Patched by Vit Ondruch [ruby-core:49763] [Bug #7312]

Thu Dec 20 18:37:45 2012  NARUSE, Yui  <naruse@ruby-lang.org>

	* string.c (rb_str_crypt): crypt(3) may return NULL.
	  Latest glibc (2.16?) crypt(3) actually returns NULL. [Bug #7312]

Thu Dec 20 18:36:19 2012  Naohisa Goto  <ngotogenome@gmail.com>

	* ext/dl/lib/dl/func.rb (DL::Function#bind): When Fiddle is used,
	  @ptr should be updated. This fixes SEGV raised in DL::Function#call
	  after calling DL::Function#bind. [Bug #7516] [ruby-dev:46708]

	* test/dl/test_func.rb (test_bind): test for the above

Thu Dec 20 18:35:36 2012  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* gc.h (SET_MACHINE_STACK_END): add volatile for preventing
	  harmful optimization.  [ruby-dev:46665] [Bug #7468]

Thu Dec 20 18:34:38 2012  Hiroshi Shirosaki  <h.shirosaki@gmail.com>

	* compile.c (ADD_CATCH_ENTRY): add a cast to fix SEGV with x64 mingw
	  on Windows 8. Without cast, 0 might be non zero value at higher bits
	  in rb_ary_new3().
	  [ruby-core:50258] [Bug #7456]

Wed Dec 19 21:24:40 2012  NARUSE, Yui  <naruse@ruby-lang.org>

	* io.c (argf_each_codepoint): add missing ARGF#codepoints [Bug #7438]

Wed Dec 19 21:20:23 2012  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* file.c (file_expand_path): use wcscasecmp().

Wed Dec 19 21:15:29 2012  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* parse.y (parser_yylex): fix false usage of local variable, it cannot
	  appear in fname state [ruby-core:49659] [Bug #7408]

Wed Dec 19 21:14:28 2012  Narihiro Nakamura  <authornari@gmail.com>

	* gc.c: return true or false. Patch by Dirkjan Bussink. [Bug #6821]

	* test/ruby/test_gc.rb: add test-case for this bug.

Wed Dec 19 21:12:49 2012  Shugo Maeda  <shugo@ruby-lang.org>

	* marshal.c (r_entry0): don't taint classes and modules because
	  Marshal.load just returns the dumped classes and modules.
	  [Bug #7325] [ruby-core:49198]

	* test/ruby/test_marshal.rb: related test.

Tue Dec 11 19:19:33 2012  Luis Lavena <luislavena@gmail.com>

	* win32/file.c (replace_to_long_name): correct logic around wildcard
	  characters detection and ensure wide-chars are used as pattern.
	  [ruby-core:49451] [Bug #7374]

Sat Nov 17 21:45:12  Luis Lavena  <luislavena@gmail.com>

	* win32/file.c (replace_to_long_name): skip expansion for all wildcard
	  characters.
	  [ruby-core:49451] [Bug #7374]

	* test/ruby/test_file_exhaustive.rb: add more assertions to test.

Tue Dec 11 19:19:33 2012  Luis Lavena  <luislavena@gmail.com>

	* win32/file.c (replace_to_long_name): skip automatic path expansion
	  when wildcard character is used.  [ruby-core:49451] [Bug #7374]

	* test/ruby/test_file_exhaustive.rb: add a test for above.

Tue Dec 11 19:18:12 2012  NAKAMURA Usaku  <usa@ruby-lang.org>

	* win32/mkexports.rb (each_export): skip garbages generated by VS2012's
	  nmake.
	  reported and patched by Yoshida Masato at [Bug #7333] [ruby-dev:46484]

Tue Dec 11 19:15:51 2012  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* parse.y (parser_here_document): flush string content between new
	  line and :string_embexpr.  [ruby-core:48703] [Bug #7255]

Tue Dec 11 17:53:55 2012  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* compile.c (iseq_compile_each): count flip-flop state in local iseq
	  not in each iseqs, so that the keys can be other than hidden
	  strings.  [ruby-core:47253] [Bug #6899]

	* vm_insnhelper.c (lep_svar_get, lep_svar_set, vm_getspecial): store
	  flip-flop states in an array instead of a hash.

	* iseq.c (set_relation): main iseq also can has local scope.

Tue Dec 11 17:52:30 2012  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* include/ruby/backward/rubysig.h: fix visibility.  [Bug #6607]

Tue Dec 11 17:49:45 2012  Koichi Sasada  <ko1@atdot.net>

	* vm.c (rb_vm_make_env_object): make Proc object if Env is possible
	  to point block. [ruby-core:41038] [ruby-trunk - Bug #5634]

	* vm.c (rb_vm_make_proc): No need to make Proc object here.

	* bootstraptest/test_proc.rb: add tests.

Tue Dec 11 17:47:01 2012  Narihiro Nakamura  <authornari@gmail.com>

	* lib/irb/magic-file.rb: set a encoding, which is detected from
	  the file to read, to the internal encoding.
	  [Bug #4281][ruby-dev:43036]

Thu Nov 15 15:17:11 2012  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* gc.c (free_method_entry_i): method entry may be in
	  unlinked_method_entry_list.  [ruby-core:43383][Bug #6171]

Wed Nov 14 20:20:46 2012  Naohisa Goto  <ngotogenome@gmail.com>

	* ruby_atomic.h: renamed from atomic.h to avoid header file name
	  conflict on Solaris 10. [ruby-dev:46414] [Bug #7287]

	* gc.c, signal.c, vm_core.h, common.mk: reflect the rename from
	  atomic.h to ruby_atomic.h.

Tue Nov 13 18:13:10 2012  Narihiro Nakamura  <authornari@gmail.com>

	* gc.c: Use the non-recursive marking instead of recursion. The
	  recursion marking of CRuby needs checking stack overflow and the
	  fail-safe system, but these systems not good at partial points,
	  for example, marking deep tree structures. [ruby-dev:46184]
	  [Feature #7095]

	* configure.in (GC_MARK_STACKFRAME_WORD): removed. It's used by
	  checking stack overflow of marking.

	* win32/Makefile.sub (GC_MARK_STACKFRAME_WORD): ditto.

	* gc.c (free_stack_chunks): it is used only when per-VM object space
	  is enabled.

	* gc.c (rb_objspace_call_finalizer): mark self-referencing finalizers
	  before run finalizers, to fix SEGV from btest on 32bit.

	* gc.c (gc_mark_stacked_objects): extract from gc_marks().

	* gc.c (rb_objspace_call_finalizer): call gc_mark_stacked_objects
	  at suitable point.

	* gc.c (init_heap): call init_mark_stack before to allocate
	  altstack. This change avoid the stack overflow at the signal
	  handler on 32bit, but I don't understand reason... [Feature #7095]

Sat Nov 10 01:25:52 2012  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* file.c (append_fspath): no need to do encoding trick here.

Sat Nov 10 00:37:02 2012  NAKAMURA Usaku  <usa@ruby-lang.org>

	* siphash.h: check configure macros before include newer headers.

Sat Nov 10 00:37:02 2012  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* siphash.c (sip_init_state): use union to suppress warnings by gcc
	  4.7.

Sat Nov 10 00:37:02 2012  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* random.c (rb_memhash): use siphash.

Fri Nov  9 16:17:09 2012  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* file.c (append_fspath): revert a part of r37562.

	* file.c (rb_file_expand_path_internal): ditto.

	* file.c (rb_file_expand_path_internal): ignore the encoding of the
	  given path name and use filesystem encoding, except when the result
	  is 8bit range and the filesystem encoding is US-ASCII.
	  [ruby-dev:39393] [Bug #2154]

Fri Nov  9 16:15:50 2012  CHIKANAGA Tomoyuki  <nagachika@ruby-lang.org>

	* test/csv/test_features.rb: add require for Tempfile.
	* test/csv/test_serialization.rb: ditto.

Fri Nov  9 13:47:45 2012  Luis Lavena  <luislavena@gmail.com>

	* test/win32ole/test_win32ole.rb (test_s_codepage_changed):
	  FileSystemObject only supports ANSI or UTF-16LE encoding.
	  Patch by bosko (Bosko Ivanisevic) [ruby-trunk - Bug #6650]

Fri Nov  9 13:16:16 2012  Kenta Murata  <mrkn@mrkn.jp>

	* bignum.c (bigmul0): enable big_mul_toom3.
	  [ruby-core:48552] [Bug #7242]

	* bignum.c (bigmul1_toom3): fix incorrect calculation.
	  the patch is made by Heesob Park.
	  [ruby-core:48552] [Bug #7242]

Fri Nov  9 13:16:16 2012  Kenta Murata  <mrkn@mrkn.jp>

	* bignum.c (bigmul0): disable big_mul_toom3 temporalily.
	  [ruby-core:48552] [Bug #7242]

	* test/ruby/test_bignum.rb (test_mul_large_numbers):
	  add a test for bigmul1_toom3 suggested in [Bug #7242].

Thu Nov  8 17:37:54 2012  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* file.c (append_fspath): filesystem encoding is prior to the encoding
	  of argument.

	* file.c (rb_file_expand_path_internal, EXPAND_PATH_BUFFER): ignore
	  the encoding of the given path name, use filesystem encoding always
	  instead.  [ruby-dev:39393] [Bug #2154]

	* test/ruby/test_file_exhaustive.rb: removed 2.0 spec tests.

Thu Nov  8 17:33:53 2012  Luis Lavena  <luislavena@gmail.com>

	* ext/zlib/extconf.rb: Recognize zlibwapi as linking library.
	  Patch by Daniel Berger.

	  [ruby-core:44979] [Feature #6421]

Thu Nov  8 16:17:54 2012  NAKAMURA Usaku  <usa@ruby-lang.org>

	* test/ruby/test_dir_m17n.rb: remove a garbage.

Thu Nov  8 15:22:09 2012  NAKAMURA Usaku  <usa@ruby-lang.org>

	* test/ruby/test_dir_m17n.rb: sorry, typo.

Thu Nov  8 14:50:02 2012  Masaki Suketa <masaki.suketa@nifty.ne.jp>

	* test/win32ole/test_win32ole_variant.rb: setting WIN32OLE.locale
	  to pass some assertion.  Thanks to Hiroshi Shirosaki.
	  [ruby-core:46873][Bug #6814]

Thu Nov  8 14:46:17 2012  Masaki Suketa <masaki.suketa@nifty.ne.jp>

	* test/win32ole/test_win32ole.rb (test_s_codepage_changed):
	  FileSystemObject only supports ANSI or UTF-16LE encoding.
	  Patch by h.shirosaki (Hiroshi Shirosaki) [ruby-trunk - Bug #6650]


Thu Nov  8 14:43:17 2012  NAKAMURA Usaku  <usa@ruby-lang.org>

	* test/ruby/test_dir_m17n.rb: refactoring. RE should be in the left side
	  of the =~ operator, and compare the result with nil is meaningless.

Thu Nov  8 14:43:17 2012  Luis Lavena  <luislavena@gmail.com>

	* test/ruby/test_dir_m17n.rb (create_and_check_raw_file_name): add new
	  helper method to ease encoding testing. Patch by Oleg Sukhodolsky.
	  [ruby-core:46589][Bug #6765]

	* test/ruby/test_dir_m17n.rb (test_filename_extutf8): use filesystem
	  encoding when reading entries and comparing.

	* test/ruby/test_dir_m17n.rb (test_filename_utf8_raw_name): removed.

	* test/ruby/test_dir_m17n.rb (test_filename_utf8_raw_jp_name): split test.

Thu Nov  8 14:16:53 2012  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* lib/mkmf.rb (MakeMakefile#timestamp_file): use .-. instead of !, a
	  special character of NMAKE and BSD make.  [Bug #7265]

Thu Nov  8 14:16:53 2012  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* lib/mkmf.rb (MakeMakefile#timestamp_file): use ! instead of %, a GNU
	  make special character.

Thu Nov  8 14:16:53 2012  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* lib/mkmf.rb (create_makefile): use timestamp for destination
	  directories to make them before making or copying files there.
	  [ruby-dev:46067] [Bug #6904]

Thu Nov  8 14:13:53 2012  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* configure.in (visibility_option): visibility attribute is not
	  available before GCC 4, so do not use -fvisibility option in that
	  case.  [ruby-core:48147] [Bug #7205]

Thu Nov  8 14:11:49 2012  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* vm.c (rb_vm_jump_tag_but_local_jump): pass through thrown objects.
	  [ruby-dev:46234] [Bug #7185]

	* vm_eval.c (rb_eval_cmd): if state is non-zero, val should be nil and
	  rb_vm_jump_tag_but_local_jump() just jump tag.

Thu Nov  8 14:09:18 2012  Kenta Murata  <mrkn@mrkn.jp>

	* ext/bigdecimal/bigdecimal.c (BigDecimal_add),
	  test/bigdecimal/test_bigdecimal.rb:
	  need to specify precision for converting Rational and Float.
	  [ruby-core:48045] [Bug #7176]

Thu Nov  8 14:05:31 2012  NAKAMURA Usaku  <usa@ruby-lang.org>

	* win32/win32.c (has_redirection): should use shell (cmd.exe) when
	  the commandline containts '&'.
	  reported by Roger Pack at [ruby-core:47912] [Bug #7143], and
	  patched by Heesob Park at [ruby-core:47931].

Fri Oct 26 17:22:18 2012  NAKAMURA Usaku  <usa@ruby-lang.org>

	* file.c (append_fspath): need to set the encoding to result always.

Fri Oct 26 11:03:46 2012  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* file.c (rb_enc_path_next, rb_enc_path_skip_prefix)
	  (rb_enc_path_last_separator, rb_enc_path_end)
	  (ruby_enc_find_basename, ruby_enc_find_extname): encoding-aware
	  path handling functions.

	* file.c (rb_home_dir, file_expand_path, rb_realpath_internal)
	  (rb_file_s_basename, rb_file_dirname, rb_file_s_extname)
	  (rb_file_join): should respect the encodings of arguments than
	  file system encoding.  [ruby-dev:45145] [Bug #5919]

	* dir.c (check_dirname, ruby_glob0): ditto.

	* ext/pathname/pathname.c (path_sub_ext): ditto.

Fri Oct 26 11:03:46 2012  NAKAMURA Usaku  <usa@ruby-lang.org>

	* util.c, include/ruby/util.h (ruby_add_suffix): remove the function.
	  [Bug #5153] [ruby-core:38736]

	* io.c (argf_next_argv): remove the call of above function.

	* ext/-test-/add_suffix, test/-ext-/test_add_suffix.rb: remove the test
	  extension module because this is only for testsing ruby_add_suffix().

	* LEGAL: remove the mention about a part of util.c, because now we
	  removed the part.

	* io.c (argf_next_argv): now the new filename is not guranteed to
	  use, so should check the return value of rename(2).

	* test/ruby/test_argf.rb (TestArgf#test_inplace_rename_impossible):
	  now we expect same result with other platforms on no_safe_rename
	  platforms (=Windows).

Thu Oct 25 18:16:25 2012  NARUSE, Yui  <naruse@ruby-lang.org>

	* lib/rubygems/installer.rb (check_that_user_bin_dir_is_in_path):
	  test_generate_bin_bindir_with_user_install_warning(TestGemInstaller)
	  fails on Windows with msys bash. It makes comparing paths
	  case-insensitive.
	  pick from upstream to fix a failure of test-all [ruby-core:47711]
	  https://github.com/rubygems/rubygems/commit/c474edb2f3704206f04da1c8c6cf9fb079d84abe

Thu Oct 25 17:55:01 2012  NAKAMURA Usaku  <usa@ruby-lang.org>

	* test/etc/test_etc.rb (TestEtc#test_getpwuid): `s' is never set to nil.

Thu Oct 25 16:59:17 2012  Luis Lavena  <luislavena@gmail.com>

	* test/ruby/test_file_exhaustive.rb: fix test introduced in r36811 for
	  posix environments where HOME is not defined.  [ruby-core:47322]

Thu Oct 25 16:59:17 2012  Luis Lavena  <luislavena@gmail.com>

	* configure.in (mingw): add shlwapi to the list of dependency
	  libs for Windows.
	* win32/Makefile.sub (EXTSOLIBS): ditto.

	* internal.h: declare internal functions rb_w32_init_file,
	  rb_file_expand_path_internal and rb_file_expand_path_fast.

	* file.c (Init_File): invoke Windows initialization rb_w32_init_file

	* win32/file.c (rb_file_load_path_internal): new function.
	  Windows-specific implementation that replaces file_expand_path.
	  [Bug #6836][ruby-core:46996]

	* win32/file.c (rb_w32_init_file): new function. Initialize codepage
	  cache for faster conversion encodings lookup.

	* file.c (file_expand_path): rename to rb_file_expand_path_internal.
	  Conditionally exclude from Windows.

	* file.c (rb_file_expand_path_fast): new function. delegates to
	  rb_file_expand_path_internal without performing a hit to the
	  filesystem.

	* file.c (file_expand_path_1): use rb_file_expand_path_internal without
	  path expansion (used by require).
	* file.c (rb_find_file_ext_safe): ditto.
	* file.c (rb_find_file_safe): ditto.

	* load.c (rb_get_expanded_load_path): use rb_file_expand_path_fast.
	* load.c (rb_feature_provided): ditto.

	* file.c (rb_file_expand_path): use rb_file_expand_path_internal with
	  path expansion.
	* file.c (rb_file_absolute_path): ditto.

	* test/ruby/test_file_exhaustive.rb: new tests to exercise
	  rb_file_expand_path_internal implementation and compliance with
	  existing behaviors.

Thu Oct 25 16:59:17 2012  NAKAMURA Usaku  <usa@ruby-lang.org>

	* win32/file.c (INVALID_FILE_ATTRIBUTES): define for old SDK.

Thu Oct 25 16:59:17 2012  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* win32/makedirs.bat: new command to make intermediate
	  directories, and not to report any errors if the directory
	  already exists.

	* win32/Makefile.sub (MAKEDIRS): enable command extensions.

Thu Oct 25 16:59:17 2012  NAKAMURA Usaku  <usa@ruby-lang.org>

	* win32/Makefile.sub (MAKEDIRS): use mkdir of cmd.exe instead of ruby.
	  [Bug #6103] [ruby-core:43012]

	* win32/README.win32: added a notice about command extension of cmd.exe.

Thu Oct 25 16:59:17 2012  Hiroshi Shirosaki  <h.shirosaki@gmail.com>

	* Makefile.in (PLATFORM_DIR): add a variable for `win32` directory.
	* Makefile.in (clean-platform): add new target.
	  It cleans `win32` directory.

	* common.mk (clean): add a dependency for `win32` directory.
	* common.mk (distclean): ditto.
	* common.mk (distclean-platform): add new target.
	  It cleans `win32` directory.
	* common.mk ($(PLATFORM_D)): add new target to make `win32` directory.
	* common.mk (win32/win32.$(OBJEXT)): move win32.o into `win32`
	  directory.
	* common.mk (win32/file.$(OBJEXT)): add new target for win32/file.c.

	* configure.in: move win32.o into `win32` directory and add
	  win32/file.o to MISSING.

	* file.c (file_load_ok, rb_file_load_ok): replace static
	  file_load_ok() with public rb_file_load_ok().
	  It's to link Windows implementation in win32/file.c.
	* file.c (rb_find_file_ext_safe): ditto.
	* file.c (rb_find_file_safe): ditto.

	* win32/file.c (rb_file_load_ok): new file. Add Windows specific
	  optimized implementation of rb_file_load_ok(). We created a
	  separated file to avoid too many #ifdef macro which is unreadable.

	* win32/Makefile.sub (PLATFORM_DIR): add a variable for `win32`
	  directory.
	* win32/Makefile.sub (MISSING): move win32.obj into `win32`
	  directory and add win32/file.obj to MISSING.
	* win32/Makefile.sub (MAKEDIRS): replace MINIRUBY with BASERUBY.
	  It's because miniruby doesn't exist when making `win32` directory.
	* win32/Makefile.sub (clean-platform): add new target to clean `win32`
	  directory.
	* win32/Makefile.sub ({$(srcdir)}.c{}.obj): make it not match
	  win32/file.c to build properly.
	* win32/Makefile.sub (win32/win32.$(OBJEXT)): move win32.obj into
	 `win32` directory.

	  Patch created with Luis Lavena.
	  [ruby-core:42480] [Feature #5999]

Fri Oct 19 13:28:29 2012  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* configure.in (opt-dir): allow multiple directories separated by
	  $PATH_SEPARATOR as well as dir_config in mkmf.rb. [ruby-core:47868]
	  [Bug #7120]

Tue Oct 16 11:18:06 2012  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* lib/mkmf.rb (dir_config, init_mkmf): use configured libdir value as
	  default library path.  [ruby-core:43726] [Bug #6207]

Tue Oct 16 10:56:55 2012  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* file.c (rb_find_file_ext_safe, rb_find_file_safe): default to
	  US-ASCII for encdb and transdb.

	* load.c (search_required): keep encoding of feature name.  set
	  loading path to filesystem encoding.  [Bug #6377][ruby-core:44750]

	* ruby.c (add_modules, require_libraries): assume default external
	  encoding as well as ARGV.

Tue Oct 16 10:47:43 2012  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* random.c (random_s_rand): ensure default PRNG is re-initialized
	  after fork.  patched by Eric Wong.  [ruby-core:41209][Bug #5661]

Tue Oct 16 10:21:23 2012  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ruby.c (rb_f_sub, rb_f_gsub): pass the given block.
	  [ruby-core:47967] [Bug #7157]

Tue Oct 16 09:47:47 2012  NAKAMURA Usaku  <usa@ruby-lang.org>

	* test/ruby/test_regexp.rb
	  (TextRegexp#test_raw_hyphen_and_tk_char_type_after_range): use
	  Regexp.new instead of literal to ignore a parser warning.

Tue Oct 16 09:47:47 2012  NAKAMURA Usaku  <usa@ruby-lang.org>

	* test/ruby/test_regexp.rb
	  (TextRegexp#test_raw_hyphen_and_tk_char_type_after_range): ignoring
	  warnings are already set in setup method.

Sun Oct 14 01:21:42 2012  NAKAMURA Usaku  <usa@ruby-lang.org>

	* regparse.c (parse_char_class): should match with a hyphen after a
	  range in a character class.

	* test/ruby/test_regexp.rb (TestRegexp#test_char_class): fixed wrong
	  test.

	* test/ruby/test_regexp.rb (TestRegexp#check): now can accept the
	  error message.

	* test/ruby/test_regexp.rb
	  (TextRegexp#test_raw_hyphen_and_tk_char_type_after_range): renamed
	  because the previous name was wrong.

	* test/ruby/test_regexp.rb
	  (TextRegexp#test_raw_hyphen_and_tk_char_type_after_range): added
	  more test pattern.

Sat Oct 13 01:41:38 2012  NAKAMURA Usaku  <usa@ruby-lang.org>

	* regparse.c (parse_char_class): also need to check the type of token
	  after raw hyphen in regexp class, because the charcter code area
	  is union'ed with the property of TK_CHAR_TYPE.
	  reported by Bushi Zhang at [ruby-core:47115] [Backport #6853].

Sat Oct 13 01:39:46 2012  NAKAMURA Usaku  <usa@ruby-lang.org>

	* test/ruby/test_regexp.rb
	  (TestRegexp#test_raw_hyphen_and_type_char_after_range): added new
	  test. ref [ruby-core:47115] [Backport #6853]

Fri Oct 12 18:19:35 2012  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* file.c (rb_get_path_check): path name must not contain NUL bytes.

Fri Oct 12 17:51:43 2012  Shugo Maeda  <shugo@ruby-lang.org>

	* error.c (exc_to_s, name_err_to_s, name_err_mesg_to_str): do not
	  taint messages.

Fri Oct 12 16:11:23 2012  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* configure.in (LIBDIR_BASENAME): use configured libdir value to fix
	  --enable-load-relative on systems where libdir is not default value,
	  overridden in config.site files.  [ruby-core:47267] [Bug #6903]

	* ruby.c (ruby_init_loadpath_safe): ditto.

Fri Oct 12 13:56:01 2012  Ayumu AIZAWA  <ayumu.aizawa@gmail.com>

	* test/rexml/test_encoding.rb:
	  Add require 'require 'rexml/document'

Fri Oct 12 13:36:32 2012  NAKAMURA Usaku  <usa@ruby-lang.org>

	* numeric.c (flodivmod): must through the same pass if HAVE_FMOD or not.
	  this is a bugfix of r35013.

Fri Oct 12 13:28:37 2012  NAKAMURA Usaku  <usa@ruby-lang.org>

	* io.c (rb_cloexec_fcntl_dupfd): get rid of compile error on windows.
	  reported by Donovan Lampa at [ruby-core:43152] [Backport #6127],
	  based on a patch by Hiroshi Shirosaki at [ruby-core:47917].

Fri Oct 12 00:30:17 2012  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* io.c (ioctl_narg_len, linux_iocparm_len): reinstantiate linux
	  specific narg length calculation.
	* test/ruby/test_io.rb (test_ioctl_linux2): add new test for old and
	  unstructured ioctl.

Fri Oct 12 00:30:17 2012  NARUSE, Yui  <naruse@ruby-lang.org>

	* io.c (ioctl_narg_len): don't use _IOC_SIZE macro on Linux.
	  On Linux some constants for ioctl(2) doesn't include the size of
	  its return value and 16bit value; for example FIONREAD 0x541B.
	  Moreover the manual, ioctl_list(2),  says "Note  that  the  size
	  bits  are  very unreliable: in lots of cases they are wrong,
	  either because of buggy macros using sizeof(sizeof(struct)),
	  or because of legacy values."
	  So we shouldn't use it.

Tue Sep 25 09:30:36 2012  NAKAMURA Usaku  <usa@ruby-lang.org>

	* win32/mkexports.rb: should not export DllMain().
	  reported by luis at [ruby-core:46743] [Bug #6790], solved by
	  Heesob Park, and confirmed by nobu.

Mon Sep 24 16:34:07 2012  Hiroshi Shirosaki  <h.shirosaki@gmail.com>

	* include/ruby/win32.h (rb_w32_pow): add new function.
	  We use powl() instead of broken pow() for x64-mingw32. This workaround
	  fixes test failures related to floating point numeric.
	  [ruby-core:46686] [Bug #6784]

Mon Sep 24 10:38:55 2012  Luis Lavena  <luislavena@gmail.com>

	* test/win32ole/test_win32ole_method.rb (is_ruby64?): Correct platform
	  used to identify mingw-w64 (x64-mingw32). Patch by Hiroshi Shirosaki.
	  [ruby-core:46651][Bug #6782]

Mon Sep 24 10:37:56 2012  NARUSE, Yui  <naruse@ruby-lang.org>

	* lib/test/unit/parallel.rb: workaround fix for rubygems.
	  RubyGems can't find rake if the source directory is not equal to
	  the directory which is running the test. [Bug #6604]

Fri Sep 21 19:53:38 2012  NAKAMURA Usaku  <usa@ruby-lang.org>

	* ext/dl/cfunc.c (rb_dlcfunc_call): should convert a Bignum value to
	  unsigned long long on Win64.
	  [ruby-core:44636][Bug #6364] reported by raylinn@gmail.com (ray linn)

Fri Sep 21 18:45:20 2012  Luis Lavena  <luislavena@gmail.com>

	* include/ruby/win32.h: undef stat to silence mingw-w64 stat
	  redefinition warnings (GCC 4.6.3).

Fri Sep 21 17:54:54 2012  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* configure.in: add -Wall always.

Thu Sep 20 10:23:37 2012  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* thread_pthread.c (native_cond_initialize): destroy condattr
	  after using it. Patch by Stanislav Sedov. Thank you.
	  [Bug #7041] [ruby-core:47619]

Sun Sep  9 23:01:43 2012  Tanaka Akira  <akr@fsij.org>

	* ext/zlib/extconf.rb: detect z_crc_t type which will be defined
	  since zlib-1.2.7.

	* ext/zlib/zlib.c (rb_zlib_crc_table): use z_crc_t if available.

Sun Sep  9 02:44:21 2012  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* ext/zlib/extconf.rb: Use an exception instaed of bare puts.

Sun Sep  9 02:44:21 2012  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* ext/psych/extconf.rb: Use an exception instaed of bare abort.

Sun Sep  9 02:44:21 2012  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* ext/fiddle/extconf.rb: Use an exception instaed of bare abort.

Sun Sep  9 02:44:21 2012  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* ext/readline/extconf.rb: Use an exception instead of bare exit.

Sun Sep  9 02:34:39 2012  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* ext/extmk.rb: Show a message when extconf.rb raised an exception.
	* ext/openssl/extconf.rb: Use exception raising instead of message
	  and/or abort. We want to display error message to console _and_
	  logging into mkmf.log.

Sun Sep  9 02:30:20 2012  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* thread.c (rb_mutex_lock): stop multiple threads use
	  pthread_cond_timedwait() concurrently. [Bug #6278] [ruby-core:44275]

Thu Aug 30 09:24:43 2012  NARUSE, Yui  <naruse@ruby-lang.org>

	* lib/uri/ftp.rb (URI::FTP#initialize): raise InvalidURIError if "//"
	  is not present [ruby-core:47344] [Bug #6945]

Tue Aug 28 00:40:14 2012  NAKAMURA Usaku  <usa@ruby-lang.org>

	* test/webrick/test_cgi.rb (TestWEBrickCGI#start_cgi_server): there are
	  no guarantee of existance of RbConfig::CONFIG['LIBPATHENV'].
	  it only exists in Unix-like environments.

	* test/webrick/test_filehandler.rb
	  (WEBrick::TestFileHandler#test_script_disclosure): ditto.

Thu Aug 23 12:08:25 2012  Hiroshi Shirosaki  <h.shirosaki@gmail.com>

	* test/ruby/test_file_exhaustive.rb
	  (TestFileExhaustive#test_stat_special_file): add a test.
	  GetFileAttributesExW fails to get attributes of special files
	  such as pagefile.sys.

	* win32/win32.c (check_valid_dir): for performance, check the path
	  by FindFirstFileW only if the path contains "...".

	* win32/win32.c (winnt_stat): use GetFileAttributesExW instead of
	  FindFirstFileW since GetFileAttributesExW is faster.
	  Based on the patch by Dusan D. Majkic.
	  [ruby-core:47083] [Feature #6845]

Thu Aug 23 11:19:51 2012  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* thread_pthread.c (ruby_init_stack): STACK_GROW_DIR_DETECTION is
	  necessary on platforms with unknown stack direction.  [Bug #6761]

Thu Aug 23 11:19:51 2012  NARUSE, Yui  <naruse@ruby-lang.org>

	* thread_pthread.c (get_stack): Linux is the only OS which includes
	  the size of guard page into the stack size.

Thu Aug 23 11:19:51 2012  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* gc.h (IS_STACK_DIR_UPPER): utility macro.

	* thread_pthread.c (get_stack): seems stack size does not include
	  guard size on Mac OS X.

	* thread_pthread.c (ruby_init_stack): adjust stack size for offset of
	  addr from the bottom.

Thu Aug 23 11:19:51 2012  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* thread_pthread.c (ruby_init_stack): use stack info if possible.

Mon Aug 20 17:11:01 2012  NARUSE, Yui  <naruse@ruby-lang.org>

	* file.c (file_path_convert): don't convert it when the path string is
	  ascii only. [ruby-core:41556] [Bug #5733]
	  tests are contributed by nobu.

Thu Aug  9 22:48:58 2012  NARUSE, Yui  <naruse@ruby-lang.org>

	* pack.c (pack_unpack): when unpack('M') occurs an illegal byte
	  sequence, output the "=" character and the following character in
	  the decoded data without any transformation.
	  [ruby-dev:44875] [Bug #5635]

Tue Jul 31 10:36:12 2012  Aaron Patterson <aaron@tenderlovemaking.com>

	* ext/psych/lib/psych.rb: updated to released version.

	* ext/psych/psych.gemspec: ditto

Thu Jul 19 09:33:46 2012  Aaron Patterson <aaron@tenderlovemaking.com>

	* ext/psych/emitter.c (initialize): allow a configuration object to be
	  passed to the constructor so that mutation isn't required after
	  instantiation.

	* ext/psych/lib/psych/handler.rb: add configuration object

	* ext/psych/lib/psych/visitors/emitter.rb: use configuration object if
	  extra configuration is present.

Tue Jul 17 03:56:34 2012  Aaron Patterson <aaron@tenderlovemaking.com>

	* ext/psych/lib/psych/visitors/to_ruby.rb: strings with YAML anchors
	  are properly referenced. Patched by Joe Rafaniello via Github:
	    https://github.com/tenderlove/psych/pull/69
	* ext/psych/lib/psych/visitors/yaml_tree.rb: ditto
	* test/psych/test_alias_and_anchor.rb: test for change

Sat Jun 16 01:27:14 2012  Aaron Patterson <aaron@tenderlovemaking.com>

	* ext/psych/lib/psych.rb: bumping psych to 1.3.3
	* ext/psych/psych.gemspec: ditto

Fri May 18 15:53:05 2012  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* ext/psych/extconf.rb: Use an exception instaed of bare abort.

Fri May 18 01:28:21 2012  Aaron Patterson <aaron@tenderlovemaking.com>

	* ext/psych/parser.c (transcode_string): fix encoding index names.
	  Thanks markizko for reporting.

Wed May 16 05:11:29 2012  Aaron Patterson <aaron@tenderlovemaking.com>

	* ext/psych/lib/psych/visitors/to_ruby.rb: fix a bug with string
	  subclass dumping and loading.

	* test/psych/test_array.rb: pertinent tests

	* test/psych/test_string.rb: ditto

Wed May 16 01:31:21 2012  Aaron Patterson <aaron@tenderlovemaking.com>

	* ext/psych/lib/psych/visitors/to_ruby.rb: convert omap tagged maps to
	  Psych::Omap objects rather than hashes. [Bug #6425]

	* test/psych/test_omap.rb: pertinent test.

Wed May 16 01:15:45 2012  Aaron Patterson <aaron@tenderlovemaking.com>

	* ext/psych/lib/psych/visitors/yaml_tree.rb: keep a reference to
	  custom coders so that GC does not impact dumped yaml reference ids.

Mon Apr 30 04:43:53 2012  Aaron Patterson <aaron@tenderlovemaking.com>

	* ext/psych/lib/psych/json/yaml_events.rb: implicit styles should not
	  be changeable for JSON events.

Sun Jul 29 04:32:31 2012  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* configure.in (ruby_pc): make configurable.  [Bug #6051]

Sun Jul 29 04:32:06 2012  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* template/ruby.pc.in: added rubylibprefix, {rubylib,vendor,site}dir
	  and {ruby,vendor,site}archdir.  [ruby-core:42766][Feature #6052]

Sun Jul 29 04:31:01 2012  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* bignum.c: Added #include <strings.h> for ffs(). Patch by Perry
	  Smith. Thank you. [Bug #6748]

Sat Jul 28 04:04:01 2012  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* include/ruby/intern.h (rb_num_zerodiv): Added NORETURN.
	  Patched by Xi Wang. [Bug #6736]

Wed Jul  4 19:36:17 2012  NAKAMURA Usaku  <usa@ruby-lang.org>

	* ext/dl/cfunc.c (rb_dlcfunc_call): also needed the workaround for VC8
	  for x64.  [ruby-dev:45875] [Bug #6676]
	  reported by aves_ramphastos (Seigo Ishigane)

Tue Jul  3 19:37:52 2012  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* file.c (rmext): no extension to strip if empty string.

	* proc.c (rb_vm_rewrite_dfp_in_errinfo): Fix `unexpected return'
	occurs when a proc is called in ensure. [Backport #6460]

Tue Jul  3 11:44:23 2012  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* file.c (rb_enc_path_next, rb_enc_path_skip_prefix)
	  (rb_enc_path_last_separator, rb_enc_path_end)
	  (ruby_enc_find_basename, ruby_enc_find_extname): encoding-aware
	  path handling functions.

	* file.c (rb_home_dir, file_expand_path, rb_realpath_internal)
	  (rb_file_s_basename, rb_file_dirname, rb_file_s_extname)
	  (rb_file_join): should respect the encodings of arguments than
	  file system encoding.  [ruby-dev:45145] [Bug #5919]

	* dir.c (check_dirname, ruby_glob0): ditto.

	* ext/pathname/pathname.c (path_sub_ext): ditto.

Tue Jul  3 11:43:46 2012  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* dir.c (dir_chdir, check_dirname): get rid of optimization-out.

Thu Jun 28 17:57:49 2012  NAKAMURA Usaku  <usa@ruby-lang.org>

	* win32/win32.c (is_socket, is_console): add prototypes to fix compile
	  problem with gcc introduced at r32549.

Wed Jun 27 08:31:50 2012  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* insns.def (splatarray): make new array if flag is set.

	* compile.c (iseq_compile_each): make new array with
	  splat. [ruby-core:21901][Feature #1125]

Wed Jun 27 04:23:26 2012  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* win32/win32.c (rb_w32_sysinit): let the system not display the
	  critical-error-handler message box and the Windows Error Reporting
	  dialog.  [ruby-core:45389] [Bug #6535]

Wed Jun 27 04:20:41 2012  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* bignum.c (rb_big_pow): estimate result bit size more precisely.
	  [ruby-core:30735][Feature #3429]

Tue Jun 26 20:36:53 2012  Tanaka Akira  <akr@fsij.org>

	* lib/drb/ssl.rb: generate 1024 bits RSA key instead of 512 bits.
	  OpenSSL 1.0.1 rejects 512 bits RSA key for TLS1.2 with SHA512.
	  http://rt.openssl.org/Ticket/Display.html?id=2769&user=guest&pass=guest
	  reported by Bohuslav Kabrda.
	  [ruby-core:43844] [ruby-trunk - Bug #6221]

Tue Jun 26 20:35:59 2012  Eric Hodel  <drbrain@segment7.net>

	* ext/zlib/zlib.c (do_inflate):  Inflate more data if buffered data
	  exists.  Allows Zlib::Inflate#set_dictionary to work.
	  [ruby-trunk - Bug #5929]

Thu Jun 21 13:42:57 2012  NARUSE, Yui  <naruse@ruby-lang.org>

	* thread.c (rb_threadptr_execute_interrupts_common):
	  test_signal_requiring of test/ruby/test_signal.rb fail if the sub
	  process is killed on waiting IO in lex_io_gets in rb_load_file in
	  rb_load_internal in require.
	  This is because
	  (1) the process receive the killing signal in
	      rb_thread_io_blocking_region in rb_read_internal in lex_io_gets.
	  (2) set th->errinfo as INT2FIX(TAG_FATAL) at
	      rb_threadptr_execute_interrupts_common.
	  (3) escape rb_load_file in rb_load_internal and jump to EXEC_TAG()
	      without set loaded as TRUE.
	  (4) call first rb_exc_raise(GET_THREAD()->errinfo); because loaded
	      is FALSE as above. this errinfo should be an exception object
	      but this is INT2FIX(TAG_FATAL).
	  Don't call first rb_exc_raise if GET_THREAD()->errinfo is Fixnum.

Mon Jun 11 19:56:22 2012  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* test/webrick/test_cgi.rb (class TestWEBrickCGI): respect
	  RbConfig::CONFIG["LIBPATHENV"]. [Bug #5135] [ruby-core:38653]
	* test/webrick/test_filehandler.rb (class WEBrick): ditto.

Tue Jun  5 14:03:53 2012  Akinori MUSHA  <knu@iDaemons.org>

	* lib/ipaddr.rb: Inhibit zero-filled octets in an IPv4 address in
	  all platforms. [ruby-dev:45671]

	* lib/ipaddr.rb: Allow the x:x:x:x:x:x:d.d.d.d form not limited to
	  IPv4 mapped/compatible addresses.  This change also makes it
	  possible for the parser to understand IPv4 mapped and compatible
	  IPv6 addresses in non-compressed form.

	* lib/ipaddr.rb: Stop exposing IPSocket.valid*? methods which were
	  only usable on non-IPv6-ready platforms.

Sat Jun  2 18:49:39 2012  NARUSE, Yui  <naruse@ruby-lang.org>

	* string.c (rb_enc_cr_str_buf_cat): don't reset coderange as unknown.
	  the condition 'ptr_a8 && str_cr != ENC_CODERANGE_7BIT' means not
	  unknown, str is also ASCII-8BIT because str_encindex == ptr_encindex,
	  and nont (str_cr == ENC_CODERANGE_UNKNOWN) and
	  str_cr != ENC_CODERANGE_7BIT means str_cr is valid because ASCII-8BIT
	  can't be broken. [ruby-dev:45688] [Bug #6509]

Wed May 30 17:19:56 2012  Eric Hodel  <drbrain@segment7.net>

	* ext/zlib/zlib.c (do_inflate):  Inflate more data if buffered data
	  exists.  Allows Zlib::Inflate#set_dictionary to work.
	  [ruby-trunk - Bug #5929]

Mon May 28 11:40:19 2012  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* io.c (rb_io_extract_modeenc): fail only if conflicting
	  text/binary modes given explicitly.  [ruby-dev:45268][Bug #6055]

Fri May 25 17:18:06 2012  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* parse.y (f_arglist): should reset lexical states after empty
	  argument list with no parenthesis as well as parenthesized list,
	  so that reserved name method definition work.  [ruby-dev:45626]
	  [Bug #6403]

Fri May 25 10:40:31 2012  Hiroshi Shirosaki  <h.shirosaki@gmail.com>

	* include/ruby/win32.h (FD_SET): change function to macro.
	  To avoid buffer overflow when smaller FD_SETSISE is used in ext
	  libraries.

	* win32/win32.c (rb_w32_fdset): this function is not used anymore.
	  But we leave this for compatibility.

	* win32/win32.c (rb_w32_select_with_thread): fix SEGV when smaller
	  FD_SETSISE is used in ext libraries. Dereference of fd_set pointer
	  causes SEGV.

	* test/-ext-/win32/test_fd_setsize.rb(TestFdSetSize): add tests for
	  above.
	* ext/-test-/win32/fd_setsize/depend: ditto.
	* ext/-test-/win32/fd_setsize/extconf.rb: ditto.
	* ext/-test-/win32/fd_setsize/fd_setsize.c: ditto.

	  [ruby-core:44588] [Bug #6352]

Fri May 25 10:38:06 2012  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* io.c (io_strip_bom): check EOF.  [Bug #6487][ruby-core:45203]

Fri May 25 10:36:38 2012  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* parse.y (f_arglist): should reset lexical states after empty
	  argument list with no parenthesis as well as parenthesized list,
	  so that reserved name method definition work.  [ruby-dev:45626]
	  [Bug #6403]

Mon May 21 16:24:40 2012  Akinori MUSHA  <knu@iDaemons.org>

	* ext/syslog/syslog.c (mSyslog_inspect): Use rb_sprintf().

	* ext/syslog/syslog.c (mSyslog_inspect): Make sure self is a
	  module before calling rb_class2name().

Sat May 19 14:42:37 2012  NAKAMURA Usaku  <usa@ruby-lang.org>

	* test/drb/drbtest.rb ({DRbCore,DRbAry}#teardown}: cannot pass SIGTERM
	  to another process on Windows, so use SIGINT instead.

Sat May 19 14:42:20 2012  Tanaka Akira  <akr@fsij.org>

	* lib/drb/ssl.rb: generate 1024 bits RSA key instead of 512 bits.
	  OpenSSL 1.0.1 rejects 512 bits RSA key for TLS1.2 with SHA512.
	  http://rt.openssl.org/Ticket/Display.html?id=2769&user=guest&pass=guest
	  reported by Bohuslav Kabrda.
	  [ruby-core:43844] [ruby-trunk - Bug #6221]

Sat May 19 14:41:45 2012  Tanaka Akira  <akr@fsij.org>

	* test/drb/drbtest.rb: rescue Errno::ESRCH for Process.kill.
	  reported by NARUSE, Yui.  [ruby-dev:45551]

Sat May 19 14:41:09 2012  Tanaka Akira  <akr@fsij.org>

	* lib/drb/extservm.rb (DRb::ExtServManager): don't use /bin/sh to
	  invoke service subprocess.  mark detach threads for clean up.

	* test/drb/drbtest.rb: clean up the service subprocess in teardown.

	* test/drb/test_drb.rb: set @service_name for teardown.

	* test/drb/test_drbunix.rb: ditto.

	* test/drb/test_drbssl.rb: ditto.

Sat May 19 14:40:49 2012  Tanaka Akira  <akr@fsij.org>

	* lib/drb/ssl.rb: close accepted TCP socket if SSL accept is failed.
	  [ruby-dev:45541]

Sat May 19 14:39:50 2012  Tanaka Akira  <akr@fsij.org>

	* lib/webrick/utils.rb: fix fcntl call.

	* lib/drb/unix.rb: ditto.

Fri May 18 18:13:44 2012  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* lib/mkmf.rb (MakeMakefile#configuration): keep space at end of
	  OUTFLAG and COUTFLAG.  [ruby-dev:45650]

Fri May 18 00:04:53 2012  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* win32/win32.c (rb_w32_fstat, rb_w32_fstati64): convert FILETIME
	  to time_t directly, not to be affected by TZ unnecessarily.

	* win32/win32.c (unixtime_to_filetime): convert time_t to FILETIME
	  simply.

Wed May 16 01:07:46 2012  Aaron Patterson <aaron@tenderlovemaking.com>

	* ext/digest/md5/extconf.rb: use pkg_config for openssl so that
	  customized ssl paths are used for linking.  Backports fixes for
	  [ruby-core:44755].
	* ext/digest/rmd160/extconf.rb: ditto
	* ext/digest/sha1/extconf.rb: ditto
	* ext/digest/sha2/extconf.rb: ditto

Mon May 14 17:14:10 2012  CHIKANAGA Tomoyuki  <nagachika@ruby-lang.org>

	* test/ruby/test_io.rb (test_flush_in_finalizer1): don't use IO.for_fd
	  to close IO objects. it create IO object with already closed fd, and
	  cause occasional Errno::EBADF in following tests. [ruby-core:45020]
	  [Bug #6228]

Mon May 14 17:14:10 2012  CHIKANAGA Tomoyuki  <nagachika@ruby-lang.org>

	* test/ruby/test_io.rb (TestIO): revert r35631. it broke the intent of
	  test_flush_in_finalizer1.  [ruby-core:43951] [Bug ##6228]

Mon May 14 13:18:56 2012  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* parse.y (parser_tokadd_string): insert a backslash only if
	  quoted by single quotes.  [ruby-dev:45281] [Bug #6069]

Mon May 14 13:17:57 2012  Luis Lavena  <luislavena@gmail.com>

	* test/ruby/test_io.rb (class TestIO):  Disable GC during IO tests to
	  avoid file descriptors being GC'ed. Suggestion by Tomoyuki Chikanaga
	  [ruby-core:43951][Bug #6228]

Fri May 11 14:09:48 2012  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/bigdecimal/bigdecimal.c (PUSH): to prevent VALUE from GC,
	  must not cast it to unsigned long, which may be shorter than
	  VALUE, and the result can be mere garbage.

Fri May 11 01:04:54 2012  Hiroshi Shirosaki  <h.shirosaki@gmail.com>

	* io.c (io_unread): fix IO#pos with mode 'r' bug on Windows.
	  If the end of reading buffer is CR, io_unread() needs to unread one
	  more byte.
	  [ruby-core:44874] [Bug #6401]

	* test/ruby/test_io_m17n.rb (TestIO_M17N#test_pos_with_buffer_end_cr):
	  add a test for above.

Wed May  9 15:59:17 2012  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* configure.in (RUBY_WERROR_FLAG): append all warning flags which
	  are enabled to compile, so that printf format modifiers properly
	  fail.  [ruby-core:41351] [Bug #5679]

Mon May  7 20:23:29 2012  Tanaka Akira  <akr@fsij.org>

	* lib/securerandom.rb (random_bytes): call to_int method for the
	  argument at first.

Mon May  7 20:23:29 2012  Tanaka Akira  <akr@fsij.org>

	* lib/securerandom.rb: show actual read length in an error message.

Mon May  7 11:09:20 2012  NARUSE, Yui  <naruse@ruby-lang.org>

	* ext/bigdecimal/bigdecimal.c (Init_bigdecimal): define IDs before
	  they are used. [ruby-core:44900] [Bug #6406]

Fri Apr 27 11:02:33 2012  Masatoshi SEKI  <m_seki@mva.biglobe.ne.jp>

	* test/rinda/test_rinda.rb (test_core_03_notify): Fixed test failures
	  [ruby-dev:44430] [Ruby 1.9 - Bug #372]

Fri Apr 27 08:29:51 2012  Masatoshi SEKI  <m_seki@mva.biglobe.ne.jp>

	* test/rinda/test_rinda.rb: fix sticks on some testsf problem
	  [Bug #6272]

Wed Apr 25 05:56:56 2012  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* lib/optparse.rb (OptionParser#to_a): split for each lines.
	  [ruby-dev:45568][Bug #6348]

Tue Apr 24 21:20:39 2012  NARUSE, Yui  <naruse@ruby-lang.org>

	* lib/optparse.rb (OptionParser#to_a): should split by end-of-line,
	  and MUST TEST IT, MUST RUN THE TEST, MUST VERIFY BEFORE BACKPORT.
	  [ruby-dev:45568][Bug #6348]

Tue Apr 24 14:55:41 2012  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* lib/optparse.rb (OptionParser#to_a): String#to_a is no longer
	  defined.  [ruby-dev:45568][Bug #6348]

Sat Apr 21 07:16:16 2012  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* strftime.c (rb_strftime_with_timespec): fix padding of time zone
	  offset.  [ruby-dev:43287][Bug #4458]

	* strftime.c (rb_strftime_with_timespec): add an interim digit for
	  the timezone offset which is less than an hour.

	* strftime.c (rb_strftime_with_timespec): fix carry-up bug and
	  overwrite '+' with '-' if negative offset less than a hour.
	  [ruby-core:44447][Bug #6323]

Fri Apr 20 12:30:06 2012  Eric Hodel  <drbrain@segment7.net>

	* lib/rubygems/ssl_certs/AddTrustExternalCARoot.pem:  Removed to avoid
	  conflict with ca-bundle.pem
	* lib/rubygems/ssl_certs/VerisignClass3PublicPrimaryCertificationAuthority-G2.pem:
	  ditto.
	* lib/rubygems/ssl_certs/Entrust_net-Secure-Server-Certification-Authority.pem:
	  ditto.

Fri Apr 20 08:30:55 2012  Eric Hodel  <drbrain@segment7.net>

	* lib/rubygems:  Update to RubyGems 1.8.23 which contains security
	  fixes:

	  RubyGems now disallows redirection from HTTPS to HTTP.

	  RubyGems now verifies SSL connections.

	  See https://github.com/rubygems/rubygems/blob/1.8/History.txt for
	  changes since 1.8.22.
	* test/rubygems:  ditto.

Fri Apr 20 07:39:50 2012  Eric Hodel  <drbrain@segment7.net>

	* lib/rubygems:  Update to RubyGems 1.8.22 plus r33517 and r35337 which
	  were ported to the rubygems git repository.

	  See https://github.com/rubygems/rubygems/blob/1.8/History.txt for
	  changes since 1.8.11.

	* test/rubygems:  ditto.

	* lib/rubygems/version.rb:  Fixed init_with warning by calling into
	  yaml_initialize (for syck) from psych's init_with

Thu Apr 19 12:55:31 2012  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/-test-/win32/dln/extconf.rb: need import library for ordinal
	  entry even on mingw.  [ruby-core:44441][Bug #6320]

Wed Apr 18 23:08:58 2012  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* configure.in (DOT, DOXYGEN): use AC_CHECK_PROGS instead of
	  AC_CHECK_PROG which needs the third argument.  [ruby-core:44433]
	  [Bug #6316]

	* configure.in (PKG_CONFIG): fix condition to skip older version
	  of pkg-config.  continue in backticks does not affect outside.

Tue Apr 17 21:35:47 2012  Kouhei Sutou  <kou@cozmixng.org>

	* lib/rexml/parsers/baseparser.rb, test/rexml/test_namespace.rb:
	  fix the default xml namespace URI validation.
	  [ruby-dev:45169] [Bug #5956]
	  Reported by Miho Hiramatsu. Thanks!!!

Mon Apr 17 14:27:22 2012  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* dln.c (rb_w32_check_imported): skip ordinal entries.  based on a
	  patch by phasis68 (Heesob Park) at [ruby-core:44381].
	  [ruby-core:44371][Bug #6303]

Sun Apr 15 14:57:00 2012  Tanaka Akira  <akr@fsij.org>

	* test/test_pty.rb (test_pty_check_default): call PTY.check until
	  "cat" command is finished.

Sun Apr 15 14:54:16 2012  NAKAMURA Usaku  <usa@ruby-lang.org>

	* test/ruby/test_process.rb (TestProcess#windows?): new method.

	* test/ruby/test_process.rb (TestProcess#*): use above method.

	* test/ruby/test_process.rb (TestProcess#test_execopts_redirect):
	  windows doesn't support FD_CLOEXEC.

Sun Apr 15 06:40:28 2012  Hiroshi Shirosaki  <h.shirosaki@gmail.com>

	* include/ruby/win32.h (rb_w32_aspawn_flags): add the declaration of
	  new function.

	* process.c (enum): add EXEC_OPTION_PGROUP and move the position
	  above for the usage in proc_spawn_n().

	* process.c (proc_spawn_n): add an argument to pass new option
	  `new_pgroup`. The option specifies CREATE_NEW_PROCESS_GROUP flag to
	  CreateProcessW(). This flag is necessary for the usage of
	  Process.kill on the subprocess on Windows.

	* process.c (rb_exec_arg_addopt): ditto.

	* process.c (rb_spawn_process): ditto.

	* process.c (documentation for rb_f_spawn): add documentation for new
	  option `new_pgroup` of spawn.

	* test/ruby/test_process.rb (TestProcess#test_execopts_new_pgroup):
	  add tests for option `new_pgroup`.

	* test/ruby/test_thread.rb
	  (TestThreadGroup#test_thread_timer_and_interrupt):
	  add option `new_pgroup: true` to spawn on Windows. It's needed for
	  Process.kill on a subprocess.

	* win32/win32.c (CreateChild): add an argument to pass
	  dwCreationFlags of CreateProcessW().

	* win32/win32.c (rb_w32_spawn): ditto.

	* win32/win32.c (rb_w32_aspawn_flags): add new function to pass
	  dwCreationFlags.

	* win32/win32.c (rb_w32_aspawn): refactor to move the content to
	  rb_w32_aspawn_flags().
	  [ruby-core:43245][Bug #6131]

Sun Apr 15 06:40:28 2012  Hiroshi Shirosaki  <h.shirosaki@gmail.com>

	* test/ruby/test_thread.rb
	  (TestThreadGroup#test_thread_timer_and_interrupt): skip on Windows.
	  Process.kill cannot kill a subprocess if CREATE_NEW_PROCESS_GROUP
	  flag is not specified in a call to CreateProcessW().

	* win32/win32.c (CreateChild): revert the usage of
	  CREATE_NEW_PROCESS_GROUP flag for compatibility.
	  [ruby-core:43245][Bug #6131]

Sun Apr 15 04:35:48 2012  Hiroshi Shirosaki  <h.shirosaki@gmail.com>

	* io.c (rb_io_eof): use eof() instead of io_fillbuf(). It's because
	  io_unread() doesn't work properly when reading CRLF with read(length)
	  and mode 'r'.
	  [ruby-core:44189][Bug #6271]

	* test/ruby/test_io_m17n.rb (TestIO_M17N#test_read_crlf_and_eof):
	  test for above.

Sun Apr 15 03:00:54 2012  NAKAMURA Usaku  <usa@ruby-lang.org>

	* io.c (io_unread): fixed memory leak.  report by nagachika via IRC.

Sun Apr 15 03:00:54 2012  Hiroshi Shirosaki  <h.shirosaki@gmail.com>

	* io.c (static int io_fflush): add the definition.
	  Use it in set_binary_mode_with_seek_cur().

	* io.c (set_binary_mode_with_seek_cur): refactoring to split the
	  content into io_unread(). Fix the possibility of buffer overflow.

	* io.c (io_unread): add new implementation for Windows. Previous one
	  caused invalid cursor position using IO#pos with OS text mode. New
	  one fixes the bug.

	* test/ruby/test_io_m17n.rb
	  (TestIO_M17N#test_pos_dont_move_cursor_position): add a test for
	  above bug.
	  [ruby-core:43497] [Bug #6179]

Sun Apr 15 03:00:54 2012  NAKAMURA Usaku  <usa@ruby-lang.org>

	* test/ruby/test_io.rb (TestIO#test_pos_with_getc): updated.
	  see [ruby-core:43550]

Sun Apr 15 03:00:54 2012  NAKAMURA Usaku  <usa@ruby-lang.org>

	* test/ruby/test_io.rb (TestIO#test_pos_with_getc): added.
	  see [Bug #6179][ruby-core:43518]

Wed Apr 11 16:22:16 2012  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/-test-/add_suffix/bug.c (ruby_add_suffix): no static
	  declaration.  [ruby-core:44277][Bug #6279]

Sun Apr  8 06:53:55 2012  NARUSE, Yui  <naruse@ruby-lang.org>

	* io.c (io_unread): cast as long the value for extra_max.
	  [ruby-core:44137] [Bug #6257]

Sat Apr  7 10:28:40 2012  Aaron Patterson <aaron@tenderlovemaking.com>

	* ext/psych/lib/psych.rb: bumping up psych version to match release.
	* ext/psych/psych.gemspec: ditto

Sat Apr  7 02:07:00 2012  Aaron Patterson <aaron@tenderlovemaking.com>

	* ext/psych/parser.c: fall back to any encoding if the external
	  encoding is wrong.  [ruby-core:44163]
	* test/psych/test_encoding.rb: fix test

Wed Apr  4 18:29:15 2012  NAKAMURA Usaku  <usa@ruby-lang.org>

	* test/ruby/test_sleep.rb (TestSleep#test_sleep_5sec): syntax error.

	* test/ruby/test_sleep.rb (TestSleep#test_sleep_5sec): call uname
	  only on linux because it's a workaround for linux only.

Wed Apr  4 11:32:09 2012  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/-test-/add_suffix/bug.c: make all functions in util.c static
	  to get rid of multiple definitions.  reported at
	  https://trac.macports.org/ticket/33814

Tue Apr  3 18:34:33 2012  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* process.c (setreuid, setregid): suppress warnings.
	  [ruby-core:43374][Bug #6169]

Sat Mar 31 12:11:21 2012  Martin Bosslet  <Martin.Bosslet@googlemail.com>

	* ext/openssl/ossl_x509cert.c: Fix doc typo.

Fri Mar 30 14:17:17 2012  Martin Bosslet  <Martin.Bosslet@googlemail.com>

	* ext/openssl/ossl_pkcs7.c: fix crash when parsing garbage data.
	* test/openssl/test_pkcs7.rb: assert correct behavior for it.
	  Thanks to Matt Venables for reporting the issue.
	  [ruby-core:43250][Bug #6134]

Fri Mar 30 14:17:17 2012  Martin Bosslet  <Martin.Bosslet@googlemail.com>

	* test/openssl/test_x509cert.rb: exclude test that fails when issuing
	  a certificate with RSA signature and DSS1 digest for earlier
	  OpenSSL versions when used in conjunction with OpenSSL 1.0.1.
	  Thanks, Vit Ondruch, for reporting the issue.
	  [ruby-core:42949][Bug #6089]

Fri Mar 30 14:15:40 2012  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* string.c (str_new_empty): should copy also the encoding as an
	  empty substring.  [ruby-dev:45441][Bug #6206]

Fri Mar 30 14:14:36 2012  Tadayoshi Funaba  <tadf@dotrb.org>

	* ext/date/date_core.c (datetime_s_now): [ruby-core:43256].

Fri Mar 30 14:12:53 2012  Marc-Andre Lafortune  <ruby-core@marc-andre.ca>

	* numeric.c: fix flodivmod for cornercases [Bug #6044]
	  add ruby_float_mod

	* insns.def (opt_mod): use ruby_float_mod

	* internal.h: declare ruby_float_mod

	* test/ruby/test_float.rb: tests for above

	* test/ruby/envutil.rb: create helper assert_is_minus_zero

Wed Mar 28 08:44:24 2012  Aaron Patterson <aaron@tenderlovemaking.com>

	* ext/psych/lib/psych.rb: updating version to match gem
	* ext/psych/psych.gemspec: ditto
	* ext/psych/lib/psych/visitors/to_ruby.rb: fixing deprecation warning

Mon Jul 18 13:36:47 2011  Aaron Patterson <aaron@tenderlovemaking.com>

	* ext/psych/lib/psych.rb: define a new BadAlias error class.

	* ext/psych/lib/psych/visitors/to_ruby.rb: raise an exception when
	  deserializing an alias that does not exist.

	* test/psych/test_merge_keys.rb: corresponding test.

Fri Mar  9 06:29:22 2012  Aaron Patterson <aaron@tenderlovemaking.com>

	* ext/psych/lib/psych.rb (load, parse): stop parsing or loading after
	  the first document has been parsed.

	* test/psych/test_stream.rb: pertinent tests.

Fri Mar  9 06:17:05 2012  Aaron Patterson <aaron@tenderlovemaking.com>

	* ext/psych/lib/psych.rb (parse_stream, load_stream): if a block is
	  given, documents will be yielded to the block as they are parsed.
	  [ruby-core:42404] [Bug #5978]

	* ext/psych/lib/psych/handlers/document_stream.rb: add a handler that
	  yields documents as they are parsed

	* test/psych/test_stream.rb: corresponding tests.

Tue Mar  6 02:31:20 2012  Aaron Patterson <aaron@tenderlovemaking.com>

	* ext/psych/lib/psych/core_ext.rb: only extend Kernel if IRB is loaded
	  in order to stop method pollution.

Tue Feb 28 10:28:51 2012  Aaron Patterson <aaron@tenderlovemaking.com>

	* ext/psych/lib/psych.rb: default open YAML files with utf8 external
	  encoding. [ruby-core:42967]
	* test/psych/test_tainted.rb: ditto

Fri Feb 24 13:54:33 2012  Aaron Patterson <aaron@tenderlovemaking.com>

	* ext/psych/parser.c: prevent a memory leak by protecting calls to
	  handler callbacks.
	* test/psych/test_parser.rb: test to demonstrate leak.

Fri Feb 24 08:08:38 2012  Aaron Patterson <aaron@tenderlovemaking.com>

	* ext/psych/parser.c: set parser encoding based on the YAML input
	  rather than user configuration.
	* test/psych/test_encoding.rb: corresponding tests.
	* test/psych/test_parser.rb: ditto
	* test/psych/test_tainted.rb: ditto

Fri Feb 10 03:41:31 2012  Aaron Patterson <aaron@tenderlovemaking.com>

	* ext/psych/parser.c: removed external encoding setter, allow parser
	  to be reused.
	* ext/psych/lib/psych/parser.rb: added external encoding setter.
	* test/psych/test_parser.rb: test parser reuse

Wed Jan 18 12:49:15 2012  Aaron Patterson <aaron@tenderlovemaking.com>

	* ext/psych/lib/psych/visitors/to_ruby.rb: Added support for loading
	  subclasses of String with ivars
	* ext/psych/lib/psych/visitors/yaml_tree.rb: Added support for dumping
	  subclasses of String with ivars
	* test/psych/test_string.rb: corresponding tests

Wed Jan 18 10:39:47 2012  Aaron Patterson <aaron@tenderlovemaking.com>

	* ext/psych/lib/psych/visitors/to_ruby.rb: Added ability to load array
	  subclasses with ivars.
	* ext/psych/lib/psych/visitors/yaml_tree.rb: Added ability to dump
	  array subclasses with ivars.
	* test/psych/test_array.rb: corresponding tests

Wed Dec 21 02:25:36 2011  Aaron Patterson <aaron@tenderlovemaking.com>

	* ext/psych/emitter.c: fixing clang warnings. Thanks Joey!

Sun Dec 18 12:42:48 2011  Aaron Patterson <aaron@tenderlovemaking.com>

	* ext/psych/lib/psych/visitors/to_ruby.rb: BigDecimals can be restored
	  from YAML.
	* ext/psych/lib/psych/visitors/yaml_tree.rb: BigDecimals can be dumped
	  to YAML.
	* test/psych/test_numeric.rb: tests for BigDecimal serialization

Sun Dec 18 12:03:13 2011  Aaron Patterson <aaron@tenderlovemaking.com>

	* ext/psych/lib/psych/scalar_scanner.rb: Strings that look like dates
	  should be treated as strings and not dates.

	* test/psych/test_scalar_scanner.rb: corresponding tests.

Wed Dec  7 08:04:31 2011  Aaron Patterson <aaron@tenderlovemaking.com>

	* ext/psych/lib/psych.rb (module Psych): parse and load methods take
	  an optional file name that is used when raising Psych::SyntaxError
	  exceptions
	* ext/psych/lib/psych/syntax_error.rb (module Psych): allow nil file
	  names and handle nil file names in the exception message
	* test/psych/test_exception.rb (module Psych): Tests for changes.

Wed Nov 30 09:09:37 2011  Aaron Patterson <aaron@tenderlovemaking.com>

	* ext/psych/parser.c (parse): parse method can take an option file
	  name for use in exception messages.
	* test/psych/test_parser.rb: corresponding tests.

Tue Nov 22 04:46:22 2011  Aaron Patterson <aaron@tenderlovemaking.com>

	* ext/psych/lib/psych.rb: remove autoload from psych
	* ext/psych/lib/psych/json.rb: ditto

Wed Nov  9 04:52:16 2011  Aaron Patterson <aaron@tenderlovemaking.com>

	* ext/psych/lib/psych/tree_builder.rb: dump complex numbers,
	  rationals, etc with reference ids.
	* ext/psych/lib/psych/visitors/yaml_tree.rb: ditto
	* ext/psych/lib/psych/visitors/to_ruby.rb: loading complex numbers,
	  rationals, etc with reference ids.
	* test/psych/test_object_references.rb: corresponding tests

Mon Nov  7 20:31:52 2011  Aaron Patterson <aaron@tenderlovemaking.com>

	* ext/psych/lib/psych/scalar_scanner.rb: make sure strings that look
	  like base 60 numbers are serialized as quoted strings.
	* test/psych/test_string.rb: test for change.

Thu Oct 27 08:47:38 2011  Martin Bosslet  <Martin.Bosslet@googlemail.com>

	* ext/psych/parser.c: remove unused variable.

Wed Oct  5 02:50:27 2011  Aaron Patterson <aaron@tenderlovemaking.com>

	* ext/psych/lib/psych/syntax_error.rb: Add file, line, offset, and
	  message attributes during parse failure.
	* ext/psych/parser.c: Update parser to raise exception with correct
	  values.
	* test/psych/test_exception.rb: corresponding tests.

Wed Oct  5 01:52:16 2011  Aaron Patterson <aaron@tenderlovemaking.com>

	* ext/psych/parser.c (parse): Use context_mark for indicating error
	  line and column.

Wed Oct  5 01:22:08 2011  Aaron Patterson <aaron@tenderlovemaking.com>

	* ext/psych/lib/psych/scalar_scanner.rb: use normal begin / rescue
	  since postfix rescue cannot receive the exception class. Thanks
	  nagachika!

Tue Mar 27 22:22:50 2012  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* configure.in (RUBY_STACK_GROW_DIRECTION): substitute CPU name as
	  shell variable name.  based on the patch by The Written Word Inc. at
	  [ruby-core:40421].  [Bug #5488]

Mon Mar 26 09:57:12 2012  NARUSE, Yui  <naruse@ruby-lang.org>

	* parse.y (parser_nextc): set encoding for the buffer of ripper.

Sun Mar 18 13:23:28 2012  NARUSE, Yui  <naruse@ruby-lang.org>

	* encoding.c (rb_enc_compatible): return ASCII-8BIT even if 2nd string
	  is ascii only string. [ruby-core:42354] [Bug #5968]

Tue Mar  6 18:55:37 2012  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* lib/test/unit/assertions.rb (assert_send, assert_not_send):
	  parenthesize non-empty arguments.

Tue Mar  6 18:55:37 2012  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* lib/test/unit/assertions.rb (assert_send): make arguments in
	  the default message clearer.

Tue Mar  6 12:48:08 2012  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/io/console/console.c (set_rawmode): clear ECHOE and ECHOK
	  bits too.

	* ext/io/console/console.c (echo_p): ignore ECHOE and ECHOK bits.
	  [ruby-dev:45309] [Bug #6116]

	* ext/io/console/console.c (console_raw): fix rdoc.

	* ext/io/console/console.c (console_set_echo): mentioned about
	  platform dependency.

Tue Mar  6 12:40:08 2012  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/io/console/console.c (console_raw, console_set_raw)
	  (console_getch): optional parameters.  [EXPERIMENTAL]

Tue Mar  6 12:39:27 2012  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/io/console/console.c (console_cooked, console_set_cooked):
	  new methods to reset cooked mode.  [EXPERIMENTAL]

Tue Mar  6 12:31:47 2012  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/io/console/console.c (io_getch): default delegating method
	  for StringIO.  https://github.com/nobu/io-console/issues/4

	* ext/stringio/stringio.c: moved some methods to hidden modules.

Tue Mar  6 12:29:34 2012  Eric Hodel  <drbrain@segment7.net>

	* io.c (Init_IO):  Mention io/console methods.  [Ruby 1.9 - Bug #5602]
	* ext/io/console/console.c:  Mention that io/console must be required
	  similar to lib/time.rb

Tue Mar  6 11:42:52 2012  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/syck/lib/syck/rubytypes.rb (Exception.yaml_new): fix bug
	  that causes YAML serialization problem for Exception.
	  Exception#initialize doesn't use visible instance variable for
	  the exception message, so call the method with the message.
	  patched by Jingwen Owen Ou <jingweno AT gmail.com>.
	  http://github.com/ruby/ruby/pull/41

Fri Mar  2 22:09:03 2012  Hiroshi Nakamura  <nahi@ruby-lang.org>

	* .travis.yml: Backport TravisCI configuration from trunk.

Thu Mar  1 18:39:44 2012  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* file.c (rb_file_join): honor input encodings than ASCII-8BIT.
	  [ruby-core:40338] [Bug #5483]

Tue Feb 28 11:56:52 2012  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* configure.in (debugflags): check if -ggdb is accepted.
	  [ruby-core:42875][Bug #6080]

Mon Feb 27 17:25:40 2012  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/bigdecimal/bigdecimal.c (GetVpValueWithPrec): since methods
	  can be overridden, so should not make an assumption on the type
	  of results.  [ruby-core:42969][Bug #6093]

Mon Feb 27 02:28:17 2012  NARUSE, Yui  <naruse@ruby-lang.org>

	* regparse.c (add_code_range_to_buf0): wrong condition of duplicated
	  warnings.

Sun Feb 26 12:26:26 2012  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* compile.c (iseq_compile_each): call on special object instead of
	  self.  since stabby lambda is a syntax, so it should not be
	  affected by the context.  [ruby-core:42349][Bug #5966]

	* insns.def (send): no special deal for FCALL.  self should be put
	  on TOS instead.

Sat Feb 25 23:47:49 2012  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* file.c (utime_internal): fix a variable missed to replace.
	  [ruby-core:42864] [Bug #6077]

Sat Feb 25 21:29:09 2012  URABE Shyouhei  <shyouhei@ruby-lang.org>

	* test/ruby/test_literal.rb (TestRubyLiteral#test_special_const):
	  test for https://bugs.php.net/bug.php?id=61095

Sat Feb 25 21:29:09 2012  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* dir.c, file.c, io.c (rb_sys_fail_path): use rb_sys_fail_str.

	* error.c: new functions to deal exceptions with string instances.

	* dir.c, file.c, io.c: use rb_sys_fail_path.

Sat Feb 25 21:18:12 2012  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* dir.c (dir_inspect), io.c (rb_io_inspect): keep encoding of path.
	  [Bug #6072]

Sat Feb 25 21:18:12 2012  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* dir.c (dir_initialize): keep path in original encoding.

	* error.c (syserr_initialize): prefer the encoding of message over
	  locale.  [ruby-dev:45279][Bug #6071]

Sat Feb 25 17:10:51 2012  NARUSE, Yui  <naruse@ruby-lang.org>

	* lib/fileutils.rb: use chomp(?/) instead of sub to optimize and avoid
	  to regexping invalid string.

Sat Feb 25 16:39:13 2012  NARUSE, Yui  <naruse@ruby-lang.org>

	* complex.c (nucomp_marshal_load): raise error on invalid data.
	  reported by John Firebaugh [ruby-core:42860] [Bug #6076]

Fri Feb 24 23:49:05 2012  Marc-Andre Lafortune  <ruby-core@marc-andre.ca>

	* lib/ostruct.rb (delete_field): Bug fix so previous value is
	  returned. Patch by Nick Recobra [Bug #6063]

Fri Feb 24 08:53:28 2012  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* parse.y (parser_tokadd_string, parser_yylex): insert a backslash
	  if the next character is non-ascii.  [ruby-dev:45278] [Bug #6069]

Thu Feb 23 14:44:36 2012  NARUSE, Yui  <naruse@ruby-lang.org>

	* lib/uri/common.rb (URI::Parser#initialize_regexp):
	  use \A \z instead of ^ $. [Bug #5843]

Thu Feb 23 08:08:23 2012  NAKAMURA Usaku  <usa@ruby-lang.org>

	* win32/win32.c (rb_w32_uchmod): typo.  [Bug#5671] [ruby-dev:44898]

	* test/ruby/test_file.rb (TestFile#test_chmod_m17n): test of above bug.

Wed Feb 22 23:27:52 2012  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* test/iconv/test_option.rb: enabled.  [ruby-core:42802][Bug #6061]

Wed Feb 22 22:04:15 2012  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* io.c (rb_io_s_foreach): argument check before making Enumerator.
	  [ruby-dev:31525]

Wed Feb 22 22:04:15 2012  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* io.c (rb_io_s_foreach): return enumerator including kerword
	  arguments.  [ruby-dev:45267][Bug #6054]

Wed Feb 22 21:42:16 2012  NARUSE, Yui  <naruse@ruby-lang.org>

	* configure.in: remove workaround replacement from gcc to gcc-4.2.
	  [Backport #6043]

Wed Feb 22 08:11:06 2012  Narihiro Nakamura  <authornari@gmail.com>

	* gc.c : remove gc_clear_mark_on_sweep_slots() and use
	  rest_sweep() instead of it, because some dead objects might be
	  marked in next the mark phase by false pointers.
	  [ruby-core:42672]

Sun Feb 19 12:27:24 2012  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* configure.in: ignore all warnings from an arbitrary
	  header in /usr/local/include.

Fri Feb 17 12:51:25 2012  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* lib/mkmf.rb (create_header): log the content of header.

Fri Feb 17 12:26:15 2012  CHIKANAGA Tomoyuki  <nagachika00@gmail.com>

	* test/readline/test_readline.rb (test_completion_proc_empty_result):
	  ensure clearance of Readline's line_buffer after the test.

Fri Feb 17 11:46:39 2012  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* test/readline/test_readline.rb (test_line_buffer__point): use
	  lambda not to exit entire method by "return".  or "next" for
	  proc.  [ruby-dev:45042] [Bug #5802]

Fri Feb 17 10:15:54 2012  Tanaka Akira  <akr@fsij.org>

	* ext/dbm/extconf.rb: check _DB_H_ macro unavailable except
	  Berkeley DB library.

Fri Feb 17 10:14:47 2012  Tanaka Akira  <akr@fsij.org>

	* test/dbm/test_dbm.rb: fix skip condition for libgdbm 1.8.0 or prior.
	  reported by Bohuslav Kabrda.
	  [ruby-core:42685] [ruby-trunk - Bug #6036]

Fri Feb 17 09:53:46 2012  NARUSE, Yui  <naruse@ruby-lang.org>

	* tool/transcode-tblgen.rb (import_ucm): don't use \h because the
	  script should work with ruby 1.8.

	* tool/enc-unicode.rb: ditto.

Thu Feb 16 17:54:14 2012  NARUSE, Yui  <naruse@ruby-lang.org>

	* ext/dbm/extconf.rb: merge trunk's ext/dbm/extconf.rb and
	  related functions of lib/mkmf.rb. [Backport #6021]

Thu Feb 16 09:25:52 2012  NARUSE, Yui  <naruse@ruby-lang.org>

	* configure.in (enable_pthread): use -pthread on OpenBSD without
	  explicit option. patched by Jeremy Evans. [ruby-core:38572]

Thu Feb 16 07:34:34 2012  CHIKANAGA Tomoyuki  <nagachika00@gmail.com>

	* cont.c (rb_fiber_reset_root_local_storage): add a new function to
	  restore rb_thread_t::local_storage.

	* cont.c (rb_obj_is_fiber): add a new function to tell finalizer to
	  prevent fibers from destroy.

	* gc.c (rb_objspace_call_finalizer): don't sweep fibers at finalizing
	  objspace.

	* internal.h (rb_fiber_reset_root_local_storage, rb_obj_is_fiber):
	  add prototypes.

	* vm.c (ruby_vm_destruct): reset main thread's local_storage before
	  free main thread. rb_thread_t::local_storage is replaced by fiber's
	  local storage when forked from fiber, and it should be already freed
	  when the fiber was destroyed. [ruby-core:41456] [Bug #5700]

	* test/ruby/test_fiber.rb (test_fork_from_fiber): add test for fork
	  from fiber.

Thu Feb 16 06:30:37 2012  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/fiddle/closure.c (callback): deal with unsinged integers.
	  [ruby-core:42458][Bug #5991][Bug #6022]

	* ext/fiddle/conversions.c (value_to_generic, generic_to_value):
	  ditto.

	* ext/fiddle/closure.c (callback): same as r34506.

Wed Feb 15 10:35:43 2012  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* include/ruby/ruby.h (FIXNUM_P): simple flag should be int.

Wed Feb 15 10:33:41 2012  Eric Hodel  <drbrain@segment7.net>

	* vm_eval.c (check_funcall):  Call respond_to? with matching arity for
	  legacy single-argument implementations.  [ruby-trunk - Bug #6000]

Wed Feb 15 10:25:22 2012  Naohisa Goto  <ngotogenome@gmail.com>

	* vm_eval.c (check_funcall): set array elements one-by-one to fix
	  compile error with Fujitsu C Compiler 5.6 on Solaris 10 on Sparc.

Wed Feb 15 10:25:22 2012  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* test/ruby/test_object.rb: tests that respond_to? returns false.

Wed Feb 15 10:25:22 2012  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* vm_eval.c (check_funcall): try respond_to? first if redefined.
	  [Bug #5158]

Wed Feb 15 07:15:50 2012  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* compile.c (defined_expr): guard the whole expression.
	  [ruby-dev:45021][Bug#5786]

Wed Feb 15 05:08:25 2012  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/dl/cptr.c (rb_dlptr_s_to_ptr): use rb_check_funcall.

	* ext/dl/cfunc.c (dlcfunc_mark), ext/dl/cptr.c (dlptr_mark):
	  workaround to mark wrapped object.  this is not a true fix,
	  because [Bug #4929] is caused by the interface design of DL.

Wed Feb 15 05:04:47 2012  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/dl/cptr.c (rb_dlptr_aref, rb_dlptr_aset): check NULL pointer
	  dereference.

	* test/rinda/test_rinda.rb: decrease the code that depends on timing.
	  [Bug #372] [Bug #4160]

Wed Feb 15 05:03:41 2012  CHIKANAGA Tomoyuki  <nagachika00@gmail.com>

	* test/rinda/test_rinda.rb (test_remote_array_and_hash):
	  add local variables to protect objects from GC. [ruby-dev:44253]
	  [Bug #5104]

Wed Feb 15 05:02:43 2012  Masaki Suketa <masaki.suketa@nifty.ne.jp>

	* test/win32ole/test_err_in_callback.rb (test_err_in_callback):
	  skip test if ADODB.connection is not available.

Wed Feb 15 04:49:23 2012  Yusuke Endoh  <mame@tsg.ne.jp>

	* parse.y (debug_lines, coverage): set file path encoding for coverage
	  result.  [ruby-dev:44950]

Tue Feb 14 16:57:11 2012  NAKAMURA Usaku  <usa@ruby-lang.org>

	* lib/rake/file_list.rb (Rake::FileList#egrep): there is no need to
	  open files in binary mode.
	  see more details in https://github.com/jimweirich/rake/issues/74

Tue Feb 14 16:52:17 2012  NAKAMURA Usaku  <usa@ruby-lang.org>

	* lib/rdoc/encoding.rb (RDoc::Encoding.read_file): fixup newline chars
	  on Windows.
	  see https://github.com/rdoc/rdoc/issues/87

	* test/rdoc/test_rdoc_markup_pre_process.rb
	  (TestRDocMarkupPreProcess#test_include_file,
	  TestRDocMarkupPreProcess#test_include_file_encoding_incompatible):
	  follow above change.

Tue Feb 14 16:34:11 2012  Shota Fukumori  <sorah@tubusu.net>

	* test/rubygems/test_gem_commands_help_command.rb: Add one
	  `require` because if run test-all with test/unit parallel
	  running, sometimes this test fails by some constants not found.
	  The error reason is some worker doesn't require the file needed by
	  this test. This issue is related to [ruby-core:36168].

Tue Feb 14 15:58:31 2012  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* gc.c (initial_params): pack in a struct.

	* gc.c (rb_gc_set_params): set parameters always.
	  [ruby-dev:44648] [Bug #5467]

Tue Feb 14 15:44:42 2012  NAKAMURA Usaku  <usa@ruby-lang.org>

	* test/irb/test_completion.rb: skip if cannot load irb/completion
	  (maybe readline does not exist).

Tue Feb 14 15:07:23 2012  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* lib/test/unit/assertions.rb (build_message): skip escaped
	  question marks.

Mon Feb 13 12:06:29 2012  Loren Segal  <lsegal@soen.ca>

	* io.c (Init_IO): use directive hack to make ARGF documentable
	  in other tools.  [ruby-core:42515][Bug #6007]

Sun Feb 12 16:57:56 2012  Akinori MUSHA  <knu@iDaemons.org>

	* misc/rdoc-mode.el (rdoc-imenu-create-index): Add imenu support
	  to rdoc-mode.

	* misc/rdoc-mode.el (rdoc-mode): Fix regexp patterns containing
	  "\s " where CR/LF is not supposed to match.

Sun Feb 12 16:56:23 2012  Akinori MUSHA  <knu@iDaemons.org>

	* misc/rdoc-mode.el (rdoc-mode): Add provide so that requiring
	  this library succeeds.

Sun Feb 12 16:53:18 2012  Akinori MUSHA  <knu@iDaemons.org>

	* lib/tempfile.rb (Tempfile#unlink, Tempfile::Remover#call): Just
	  call File.unlink and ignore ENOENT because existence check
	  before unlinking does not help in terms of race condition.

	* lib/tempfile.rb (Tempfile#unlink, Tempfile::Remover#call): My
	  comment about thread safeness is obsolete.

Sun Feb 12 16:50:28 2012  Akinori MUSHA  <knu@iDaemons.org>

	* lib/shellwords.rb: Fix rdoc markups.

Sun Feb 12 16:50:28 2012  Akinori MUSHA  <knu@iDaemons.org>

	* lib/shellwords.rb (Shellwords#shellsplit): Fix a bug where
	  consecutive backslashes in double quotes are all removed except
	  the one at the tail.

Sun Feb 12 16:38:13 2012  Akinori MUSHA  <knu@iDaemons.org>

	* lib/shellwords.rb (Shellwords#shellescape): Drop the //n flag
	  that only causes warnings with no real effect.  [Bug #5637]

Sun Feb 12 16:34:55 2012  Akinori MUSHA  <knu@iDaemons.org>

	* tool/merger.rb (#default_merge_branch): Add support for
	  Subversion 1.7 which adopted a whole new working directory
	  structure.

Sun Feb 12 09:38:46 2012  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* vm_method.c (rb_add_method): should not call method_added hook
	  for undef operation. [Bug #5015]

Sun Feb 12 09:29:28 2012  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* regint.h (PLATFORM_UNALIGNED_WORD_ACCESS): Power PC does not
	  allow unaligned word access.

	* st.c (UNALIGNED_WORD_ACCESS): x86_64 allows unaligned word
	  access as well as i386.

Sat Feb 11 08:06:12 2012  Tanaka Akira  <akr@fsij.org>

	* test/openssl/test_ssl.rb (test_multibyte_read_write): start server
	  for each length to avoid race condition.

Sat Feb 11 06:13:07 2012  NARUSE, Yui  <naruse@ruby-lang.org>

	* dir.c (fnmatch): The * needs to be escaped to avoid formatting in
	  fnmatch comment.
	  patched by @dalton. https://github.com/ruby/ruby/pull/91

Sat Feb 11 03:38:48 2012  Hiroshi Shirosaki <h.shirosaki@gmail.com>

	* io.c (rb_sys_fail_path): move the definition.
	  Move above for using it in set_binary_mode_with_seek_cur().

	* io.c (set_binary_mode_with_seek_cur): fix improper seek cursor.
	  Seeking file cursor with setting binary mode has possibility to
	  cause infinite loop. Fixed the bug and refined error handling.
	  Introduced at r34043.

	  And cleanups as below.
	  Remove unnecessary parentheses of `fptr`.
	  Use return value of setmode().

	* test/ruby/test_io_m17n.rb
	  (TestIO_M17N#test_seek_with_setting_binmode): add a test for abobe.
	  [ruby-core:41671] [Bug #5714]

Sat Feb 11 03:38:48 2012  NAKAMURA Usaku  <usa@ruby-lang.org>

	* test/ruby/test_io_m17n.rb
	  (TestIO_M17N#test_{read_with_binmode_and_get[cs]}): only for Windows.

Sat Feb 11 03:38:48 2012  NAKAMURA Usaku  <usa@ruby-lang.org>

	* win32/win32.c, include/ruby/win32.h (rb_w32_fd_is_text): new function.

	* win32/win32.c (init_stdhandle): set default mode of stdin as binmode.

	* io.c (set_binary_mode_with_seek_cur): new function to replace
	  SET_BINARY_MODE_WITH_SEEK_CUR macro.  now returns previous mode of the
	  fd and take care of LF in rbuf.

	* io.c (do_writeconv): set text mode when needed.

	* io.c (io_read): need to change the mode of the IO to binmode
	  temporally when the length for IO#read, because IO#read with length
	  must behave so.

	* test/ruby/test_io_m17n.rb (TestIO_M17N#test_{read_with_length,
	  read_with_length_binmode,get[cs]_and_read_with_binmode,
	  read_with_binmode_and_get[cs],read_write_with_binmode}): tests for
	  above changes.

	all patches are written by Hiroshi Shirosaki. [ruby-core:41496]
	[Feature #5714]

Sat Feb 11 03:37:56 2012  NAKAMURA Usaku  <usa@ruby-lang.org>

	* test/rexml/test_order.rb (OrderTester#test_more_ordering): use
	  GZip::GzReader.open instead of GZip::GzReader.new with File.new.
	  fixed a test error on Windows introduced at r33946.

Sat Feb 11 03:37:34 2012  NAKAMURA Usaku  <usa@ruby-lang.org>

	* ext/zlib/zlib.c (rb_gzreader_initialize): revert a part of r33937.
	  1st, to change the mode of an IO is very sensitive problem, so
	  fixed test errors on Windows introduced at r33953.
	  the maintainer of this library should judge it.
	  2nd, usually Zlib::GzReader.new is not called directly.  #initialize
	  is called via .open, and in the method the I/O is opened in binary
	  mode, so there is no problem without changing the mode in #initialize.

	  fixed test errors on Windows introduced at r33947.
Sat Feb 11 03:23:58 2012  Luis Lavena  <luislavena@gmail.com>

	* ext/zlib/zlib.c (rb_gzreader_initialize): use binary mode by default
	  under Windows. Patch by Hiroshi Shirosaki. [ruby-core:40706]
	  [Feature #5562]

	* include/ruby/encoding.h (void rb_econv_binmode): define NEWLINE
	  decorator.

	* io.c (rb_cloexec_fcntl_dupfd): Introduce NEED_READCONV and
	  NEED_WRITECONV to replace universal newline decorator by CRLF only
	  when required to improve file reading and writing under Windows.
	  Patch by Hiroshi Shirosaki. [ruby-core:40706] [Feature #5562]
	* io.c (do_writeconv): adjust binary mode if required.
	* io.c (read_all, appendline, swallow, rb_io_getline_1): ditto.
	* io.c (io_getc, rb_io_each_codepoint, rb_io_ungetc): ditto.
	* io.c (rb_io_binmode, rb_io_ascii8bit_binmode): ditto.
	* io.c (rb_io_extract_modeenc, rb_sysopen): ditto.
	* io.c (pipe_open, prep_stdio, io_encoding_set): ditto.
	* io.c (rb_io_s_pipe, copy_stream_body): ditto.

	* test/ruby/test_io_m17n.rb (EOT): add test for pipe and stdin in
	  binary mode.

	* win32/win32.c (init_stdhandle): remove O_BINARY from stdhandle
	  initialization.
	* win32/win32.c (rb_w32_write): use FTEXT mode accordingly.

Sat Feb 11 03:20:22 2012  NAKAMURA Usaku  <usa@ruby-lang.org>

	* io.c (argf_next_argv): wrong timing of setting ecflags.
	  fixed the failure of TestArgf#test_textmode introduced at r33662.

Sat Feb 11 03:19:45 2012  NAKAMURA Usaku  <usa@ruby-lang.org>

	* test/ruby/test_io_m17n.rb
	  (TestIO_M17N#test_default_stdout_stderr_mode): new test for
	  r33627-33629.  see [backport #5565]
Sat Feb 11 03:20:22 2012  NAKAMURA Usaku  <usa@ruby-lang.org>

	* include/ruby/encoding.h (ECONV_NEWLINE_DECORATOR_READ_MASK,
	  ECONV_NEWLINE_DECORATOR_WRITE_MASK): new macro.

	* io.c (rb_io_extract_modeenc, pipe_open, prep_stdio, argf_next_argv):
	  set TEXTMODE_NEWLINE_DECORATOR_ON_WRITE for textmode on creating IO
	  if the flag is available.

	* io.c (make_writeconv): drop decorators for reading.

	* io.c (make_readconv): drop decorators for writing.

	* io.c (do_writeconv): existing writeconv is not the condition to raise
	  ArgumentError.  should check textmode or not.

	* test/ruby/test_io_m17n.rb
	  (TestIO_M17N#test_{cr,lf,crlf}_decorator_on_stdout): test above
	  changes.


Sat Feb 11 03:19:45 2012  NAKAMURA Usaku  <usa@ruby-lang.org>

	* test/ruby/test_io_m17n.rb (TestIO_M17N#test_{default_mode_on_dosish,
	  default_mode_on_unix,text_mode,binary_mode}): sorry for wrong test
	  committed in r33144.  I'd misunderstood the spec of ruby's universal
	  newline.

Sat Feb 11 03:17:41 2012  NAKAMURA Usaku  <usa@ruby-lang.org>

	* test/ruby/test_io_m17n.rb (TestIO_M17N#test_{default_mode_on_dosish,
	  default_mode_on_unix,text_mode,binary_mode}): tests for [Bug #5164].

Sat Feb 11 03:13:27 2012  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* transcode.c: enabled econv newline option.

Sat Feb 11 02:39:09 2012  CHIKANAGA Tomoyuki  <nagachika00@gmail.com>

	* variable.c (set_const_visibility): clear inine-cache when constant's
	  visibility is modified. [ruby-dev:44929]

	* test/ruby/test_module.rb (test_private_constants_clear_inlinecache):
	  add test for it.

Sat Feb 11 02:39:09 2012  Yusuke Endoh  <mame@tsg.ne.jp>

	* variable.c (set_const_visibility): print a warning when no argument
	  is passwd to Module#private_constant.  [ruby-list:48558]

	* vm_method.c (set_method_visibility): ditto for
	  Module#private_class_method.

Sat Feb 11 02:39:09 2012  Yusuke Endoh  <mame@tsg.ne.jp>

	* variable.c (set_const_visibility): Module#private_constant has
	  changed the visibility of only the first argument.  Now it changes
	  all of them.  [ruby-list:48558]

	* test/ruby/test_module.rb: add a test for above.

Sat Feb 11 02:39:09 2012  CHIKANAGA Tomoyuki  <nagachika00@gmail.com>

	* variable.c (set_const_visibility): clear inine-cache when constant's
	  visibility is modified. [ruby-dev:44929]

	* test/ruby/test_module.rb (test_private_constants_clear_inlinecache):
	  add test for it.

Sat Feb 11 02:39:09 2012  Yusuke Endoh  <mame@tsg.ne.jp>

	* variable.c (set_const_visibility): print a warning when no argument
	  is passwd to Module#private_constant.  [ruby-list:48558]

	* vm_method.c (set_method_visibility): ditto for
	  Module#private_class_method.

Sat Feb 11 02:39:09 2012  Yusuke Endoh  <mame@tsg.ne.jp>

	* variable.c (set_const_visibility): Module#private_constant has
	  changed the visibility of only the first argument.  Now it changes
	  all of them.  [ruby-list:48558]

	* test/ruby/test_module.rb: add a test for above.

Sat Feb 11 02:26:51 2012  Martin Bosslet  <Martin.Bosslet@googlemail.com>

	* lib/openssl/buffering.rb: Force multi-byte strings to be treated as
	  binary data.
	* test/openssl/test_ssl.rb: Add test for it.

	Thanks to Niklas Baumstark for reporting the issue!

	[Ruby 1.9 - Bug #5233] [ruby-core:39120]

Fri Feb 10 17:25:28 2012  Tanaka Akira  <akr@fsij.org>

	* lib/set.rb (SortedSet.setup): remove old_init after initialize
	  method is redefined.  The remove before redefinition makes the
	  warning prevention fragile.  [ruby-dev:44892]

Fri Feb 10 17:02:12 2012  okkez  <okkez000@gmail.com>

	* thread_pthread.c (rb_thread_create_timer_thread): fix memory
	  leak. [ruby-dev:44904] [Bug #5688]

Fri Feb 10 05:22:32 2012  NARUSE, Yui  <naruse@ruby-lang.org>

	* cont.c (fiber_setcontext): Use longjmp() instead of swapcontext() on
	  FreeBSD 9. [ruby-dev:41316] [Bug #3295] [Bug #5526]

Fri Feb 10 05:13:12 2012  Ayumu AIZAWA  <ayumu.aizawa@gmail.com>

	* object.c: Added examples for Object#is_a? and
	  Object#instance_of? patcheed from Manoj Kumar.
	  [Bug #5880] [ruby-core:42057]

Fri Feb 10 05:11:43 2012  NARUSE, Yui  <naruse@ruby-lang.org>

	* io.c (argf_next_argv): reset ARGF.next_p on ARGV.replace.
	  r34409 breaks replacing ARGV.
	  [ruby-dev:45160] [Bug #5952]

Fri Feb 10 05:11:43 2012  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* io.c (argf_close): skip stdin, which should be readable again.
	  [ruby-dev:45160] [Bug #5952]

	* io.c (argf_readlines): reinitialize after all read to be
	  readable again.

Fri Feb  9 01:36:19 2012  Martin Bosslet  <Martin.Bosslet@googlemail.com>

	* backport r34482 from trunk

	* ext/openssl/ossl_ssl.c: Add SSL constants and allow to unset SSL
	  option to prevent BEAST attack. See [Bug #5353].

	  In OpenSSL, OP_DONT_INSERT_EMPTY_FRAGMENTS is used to prevent
	  TLS-CBC-IV vulunerability described at
	  http://www.openssl.org/~bodo/tls-cbc.txt
	  It's known issue of TLSv1/SSLv3 but it attracts lots of attention
	  these days as BEAST attack. (CVE-2011-3389)

	  Until now ossl sets OP_ALL at SSLContext allocation and call
	  SSL_CTX_set_options at connection.  SSL_CTX_set_options updates the
	  value by using |= so bits set by OP_ALL cannot be unset afterwards.
	  This commit changes to call SSL_CTX_set_options only 1 time for each
	  SSLContext. It sets the specified value if SSLContext#options= are
	  called and sets OP_ALL if not.

	  To help users to unset bits in OP_ALL, this commit also adds several
	  constant to SSL such as
	  OpenSSL::SSL::OP_DONT_INSERT_EMPTY_FRAGMENTS.  These constants were
	  not exposed in Ruby because there's no way to unset bits in OP_ALL
	  before.

	  Following is an example to enable 0/n split for BEAST prevention.

	    ctx.options = OP_ALL & ~OP_DONT_INSERT_EMPTY_FRAGMENTS

	* test/openssl/test_ssl.rb: Test above option exists.

Thu Feb  9 17:08:20 2012  CHIKANAGA Tomoyuki  <nagachika00@gmail.com>

	* cont.c (cont_mark): mark original Thread object from saved_thread.
	  [ruby-dev:44567] [Bug #5386]

Thu Feb  9 17:05:07 2012  NARUSE, Yui  <naruse@ruby-lang.org>

	* cont.c (HAVE_GETCONTEXT): see getcontext(3) because DragonFly BSD
	  x64 port doesn't have it.

Thu Feb  9 16:19:04 2012  NAKAMURA Usaku  <usa@ruby-lang.org>

	* test/ruby/memory_status.rb (Memory::Win32): 64bit support.

Thu Feb  9 16:19:04 2012  NAKAMURA Usaku  <usa@ruby-lang.org>

	* ext/dl/lib/value.rb (DL::ValueUtil.{unsigned_value,signed_value}):
	  currenly pack/unpack does not accept "q!" and "Q!".

Thu Feb  9 16:19:04 2012  NAKAMURA Usaku  <usa@ruby-lang.org>

	* ext/fiddle/conversions.c (value_to_generic): src is not guranteed as
	  a Bignum if the type is LONG_LONG.  it may be a Fixnum if the value
	  is small.

Thu Feb  9 16:19:04 2012  NAKAMURA Usaku  <usa@ruby-lang.org>

	* ext/dl/lib/types.rb: Win64 support.

Thu Feb  9 11:11:15 2012  Hiroshi Shirosaki <h.shirosaki@gmail.com>

	* ext/dbm/dbm.c (Init_dbm): fix a build error on mswin32.
	  use `extern __declspec(dllimport)` for dll link with VC.
	  [ruby-core:41996] [Bug #5869]

Thu Feb  9 11:11:15 2012  Tanaka Akira  <akr@fsij.org>

	* ext/dbm/dbm.c: use db_version() instead of DB_VERSION_STRING to
	  detect runtime Berkeley DB version.
	  use dpversion instead of _QDBM_VERSION to detect runtime QDBM
	  version.
	  [ruby-dev:44948]

Thu Feb  9 11:11:15 2012  Tanaka Akira  <akr@fsij.org>

	* ext/dbm/extconf.rb: detect gdbm_version in libgdbm.

	* ext/dbm/dbm.c: make DBM::VERSION more informative for gdbm, qdbm and
	  Berkeley DB 1.x.  [ruby-dev:44944]

Thu Feb  9 07:32:40 2012  NARUSE, Yui  <naruse@ruby-lang.org>

	* numeric.c (rb_enc_uint_char): raise RangeError when added codepoint
	  is invalid. [Feature #5855] [Bug #5863] [Bug #5864]

	* string.c (rb_str_concat): ditto.

	* string.c (rb_str_concat): set encoding as ASCII-8BIT when the string
	  is US-ASCII and the argument is an integer greater than 127.

	* regenc.c (onigenc_mb2_code_to_mbclen): rearrange error code.

	* enc/euc_jp.c (code_to_mbclen): ditto.

	* enc/shift_jis.c (code_to_mbclen): ditto.

Thu Feb  9 07:28:43 2012  NARUSE, Yui  <naruse@ruby-lang.org>

	* test/pathname/test_pathname.rb: not read but binread.
	  patched by Benoit Daloze, [ruby-core:42440] [Bug #5984]

Wed Feb  8 22:29:59 2012  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* string.c (rb_str_modify_expand): fix memory leak.

Wed Feb  8 10:58:45 2012  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/readline/readline.c (readline_attempted_completion_function):
	  respect encodings.  [Bug #5941]

Wed Feb  8 10:56:00 2012  Kazuhiro NISHIYAMA  <zn@mbf.nifty.com>

	* ext/readline/readline.c (readline_attempted_completion_function):
	  fix compile error.

Wed Feb  8 10:56:00 2012  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/readline/readline.c (readline_attempted_completion_function):
	  empty completion result does not mean memory error.

Wed Feb  8 10:54:49 2012  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/readline/readline.c (readline_readline): check if outstream
	  is closed to get rid of a bug of readline 6.  [ruby-dev:45043]
	  [Bug #5803]

Wed Feb  8 10:52:51 2012  NARUSE, Yui  <naruse@ruby-lang.org>

	* ext/readline/readline.c (Init_readline): like r18313, libedit's
	  replace_history_entry may use offset instead of which.
	  so introduce history_replace_offset_func and initialize it.

	* ext/readline/readline.c (hist_set): use history_replace_offset_func.

Wed Feb  8 10:52:36 2012  NARUSE, Yui  <naruse@ruby-lang.org>

	* ext/readline/readline.c (Init_readline): fix wrong condition.

Wed Feb  8 10:50:11 2012  Naohisa Goto  <ngotogenome@gmail.com>

	* test/ruby/test_rubyoptions.rb (test_script_from_stdin): slave pty
	  should be manipulated because master pty may not be a tty on some
	  environment (e.g. Solaris). [Bug:#5222] [ruby-dev:44420]

Wed Feb  8 10:38:36 2012  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* Makefile.in (CFLAGS): append ARCH_FLAG.

	* configure.in (ARCH_FLAG): exclude from CFLAGS.

Wed Feb 08 09:19:00 2012  Martin Bosslet  <Martin.Bosslet@googlemail.com>

	* ext/openssl/ossl_cipher.c: Add warning about key as IV.

Wed Feb  8 10:37:31 2012  Martin Bosslet  <Martin.Bosslet@googlemail.com>

	* ext/openssl/ossl_cipher.c: Update and complete documentation.

Wed Feb 08 09:57:33 2012  Martin Bosslet  <Martin.Bosslet@googlemail.com>

	* ext/openssl/ossl_asn1.c: Call INT2NUM only once for GeneralString.
	  Thanks to Mantas Mikulenas for noticing and providing a patch!
	  [ruby-core:42358] [Bug #5972]

Wed Feb  8 10:34:59 2012  TAKAO Kouji  <kouji@takao7.net>

	* ext/readline/readline.c (readline_attempted_completion_function):
	  in Readline module with GNU Readline 6 case, Readline module
	  resets completion_append_character to " ", after it executes
	  completion. So, Readline module stores
	  completion_append_character, and Readline module always sets it
	  after Readline module executes completion. [ruby-dev:43456]
	  [Feature #4635]

Wed Feb  8 09:47:52 2012  Tanaka Akira  <akr@fsij.org>

	* test/ruby/test_sleep.rb (test_sleep_5sec): 0.1sec tolerance is too
	  small for busy environment.

Wed Feb  8 09:45:23 2012  Tanaka Akira  <akr@fsij.org>

	* test/dbm/test_dbm.rb: split tests for read only database.

	* test/gdbm/test_gdbm.rb: ditto.

Wed Feb  8 09:43:48 2012  CHIKANAGA Tomoyuki  <nagachika00@gmail.com>

	* error.c (name_err_mesg_to_str): clear rb_thread_t::errinfo when
	  ignore exception under rb_protect(). [ruby-core:41612] [Bug #5755]

	* test/ruby/test_exception.rb (test_exception_in_name_error_to_str):
	  add a corresponding test.

Wed Feb  8 09:36:42 2012  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* encoding.c (require_enc): reject only loading from untrusted
	  load paths.  [ruby-dev:44541] [Bug #5279]

	* transcode.c (load_transcoder_entry): ditto.

Wed Feb  8 09:36:42 2012  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* encoding.c (load_encoding): predefined encoding names are safe.
	  [ruby-dev:44469] [Bug #5279]

	* transcode.c (load_transcoder_entry): ditto.

Tue Feb  7 14:29:16 2012  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* st.c (st_foreach): should not yield same pair when checking
	  after unpacking.

Tue Feb  7 14:03:45 2012  CHIKANAGA Tomoyuki  <nagachika00@gmail.com>

	* lib/tempfile.rb (Tempfile#_close): clear @tempfile and @data[1] even
	  when exception is raised at @tempfile.close. [ruby-dev:45113]

	* lib/tempfile.rb (Tempfile#unlink): fix a typo.

Tue Feb  7 14:02:32 2012  CHIKANAGA Tomoyuki  <nagachika00@gmail.com>

	* test/ruby/test_io.rb (test_autoclose_true_closed_by_finalizer,
	  test_autoclose_true_closed_by_finalizer): skip if IO objects are
	  not recycled yet. [ruby-dev:45098] [Bug #5850]

Tue Feb  7 13:59:26 2012  CHIKANAGA Tomoyuki  <nagachika00@gmail.com>

	* gc.c (run_finalizer): clear rb_thread_t::errinfo when ignore
	  an exception under rb_protect(). [ruby-dev:45113]

Mon Feb  6 15:34:47 2012  Tanaka Akira  <akr@fsij.org>

	* ruby.c (fill_standard_fds): use fstat() instead of fcntl(F_GETFD)
	  for MinGW.  reported by Luis Lavena.  [ruby-core:40526] [Bug #5516]

Mon Feb  6 15:34:47 2012  Tanaka Akira  <akr@fsij.org>

	* ruby.c (fill_standard_fds): new function to open closed standard
	  file descriptors.
	  (ruby_sysinit): call fill_standard_fds.

Mon Feb  6 15:19:17 2012  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* io.c (rb_io_fsync,rb_io_fdatasync): release GVL during fsync().
	  fsync() and fdatasync() may take a long time on slow disks and/or
	  if there is much dirty data.
	  Patch by Eric Wong. [Feature #5665] [ruby-core:41247]

Mon Feb  6 15:01:55 2012  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* vm_eval.c (vm_call0): should pass block to enumerators.  patched
	  by Kazuki Tsujimoto.  [ruby-dev:44961][Bug #5731]

	* vm_eval.c (method_missing), vm_insnhelper.c (vm_call_method):
	  ditto.  patched by satoshi shiba.

Mon Feb  6 21:52:20 2012  Yuki Sonoda (Yugui)  <yugui@yugui.jp>

	* common.mk (INSTRUBY_ARGS): added --mantype to apply mdoc2man.rb
	  to man pages.  Fixes #5598.
	  (do-install-nodoc, do-install-local, do-install-man,
	  dont-install-nodoc, dont-install-local, dont-install-man):
	  No longer needs --mantype.

	  Reported by Rainer Orth <ro AT cebitec.uni-bielefeld.de>,
	  patch by George Koehler <xkernigh AT netscape.net>.

Mon Feb  6 21:21:46 2012  NAKAMURA Usaku  <usa@ruby-lang.org>

	* test/unit/assertions.rb (MINI_DIR): quick dirty hack to get rid of
	  warnings when using assert/assert_respond_to.

Mon Feb  6 20:38:19 2012  NARUSE, Yui  <naruse@ruby-lang.org>

	* file.c (file_expand_path): reset coderange after expanding path.

Mon Feb  6 20:32:17 2012  Tadayoshi Funaba  <tadf@dotrb.org>

	* ext/date/date_strptime.c: moved detector of leftover.

Mon Feb  6 20:32:17 2012  Tadayoshi Funaba  <tadf@dotrb.org>

	* ext/date/date_parse.c: [ruby-core:42173].

Mon Feb  6 20:31:35 2012  Tadayoshi Funaba  <tadf@dotrb.org>

	* ext/date/date_core.c: uses to_integer instead.
	* test/date/test_switch_hitter.rb: added a test.

Mon Feb  6 20:31:35 2012  NARUSE, Yui  <naruse@ruby-lang.org>

	* ext/date/date_core.c (wholenum): fix the type of the return value.

Mon Feb  6 20:31:35 2012  Tadayoshi Funaba  <tadf@dotrb.org>

	* ext/date/date_core.c:  [ruby-dev:45008].

Mon Feb  6 16:38:56 2012  NAKAMURA Usaku  <usa@ruby-lang.org>

	* win32/win32.c (unixtime_to_filetime): should check the return value
	  of localtime().  reported by snowjail at gmail.com.
	  [ruby-dev:44838] [Bug #5596]

Mon Feb  6 16:36:25 2012  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* io.c (rb_update_max_fd): fstat(2) can fail with other than
	  EBADF.  [ruby-dev:44837] [Bug #5593].  Cf.
	  http://pubs.opengroup.org/onlinepubs/9699919799/functions/fstat.html

Mon Feb  6 16:31:16 2012  NAKAMURA Usaku  <usa@ruby-lang.org>

	* io.c (io_fwrite): call rb_w32_write_console() only if FMODE_TTY is
	  set.  this is the one of the reason of IO writing slowness of Windows
	  in 1.9.3 or later.

Mon Feb  6 16:21:57 2012  NARUSE, Yui  <naruse@ruby-lang.org>

	* file.c (file_expand_path): reset coderange after expanding path.

Mon Feb  6 00:06:39 2012  NARUSE, Yui  <naruse@ruby-lang.org>

	* ext/json/parser/parser.rl (json_string_unescape): workaround fix
	  for over optimization of GCC 4.7. [ruby-core:42085] [Bug #5888]
	  http://gcc.gnu.org/bugzilla/show_bug.cgi?id=51862

Fri Feb  3 16:16:10 2012  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* test/ruby/envutil.rb (EnvUtil.invoke_ruby): yield also child pid
	  in block form.

Fri Feb  3 16:16:10 2012  Hiroshi Shirosaki  <h.shirosaki@gmail.com>

	* test/ruby/test_thread.rb
	  (TestThreadGroup#test_thread_timer_and_interrupt): skip exit status
	  assertion because we cannot get signal status on Windows.

	* win32/win32.c (CreateChild): create process group to receive the
	  signal by GenerateConsoleCtrlEvent().

	* win32/win32.c (kill): use CTRL_BREAK_EVENT instead of CTRL_C_EVENT
	  if a process group is specified. CTRL_C_EVENT signal cannot be
	  generated for process groups for the specification.
	  [ruby-dev:45149] [Bug #5812]

Fri Feb  3 16:16:10 2012  CHIKANAGA Tomoyuki  <nagachika00@gmail.com>

	* test/ruby/envutil.rb (invoke_ruby): remove :timeout option before
	  pass it to Kernel#spawn.

Fri Feb  3 10:10:02 2012  CHIKANAGA Tomoyuki  <nagachika00@gmail.com>

	* thread_pthread.c (ping_signal_thread_list): remove return value.
	* thread_pthread.c (check_signal_thread_list): add a new function to
	  check if signal thread list is empty.
	* thread_pthread.c (thread_timer): check signal thread list after
	  timer_thread_function(). main thread might be added into signal thread
	  list during timer_thread_function().

Fri Feb  3 10:10:02 2012  NARUSE, Yui  <naruse@ruby-lang.org>

	* thread_pthread.c (ubf_select): call rb_thread_wakeup_timer_thread()
	  only when it is not timer_thread. [Bug #5757] [ruby-dev:44985]
	  patched by Tomoyuki Chikanaga.

Wed Feb  1 09:50:10 2012  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* doc/re.rdoc (Repetition): fix typo.  reported by Ori Avtalion
	  and patched by Zachary Scott.  [Bug #5947]

Tue Jan 24 11:38:05 2012  NARUSE, Yui  <naruse@ruby-lang.org>

	* lib/uri/common.rb (URI.encode_www_form_component): initialize on
	  requiring to support JRuby, which runs parallel multithreads.
	  [ruby-core:42222] [Bug #5925]

	* lib/uri/common.rb (URI.decode_www_form_component): initialize on

Sat Jan 28 05:53:34 2012  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* lib/irb/completion.rb (IRB::InputCompletor::CompletionProc):
	  ignore non-string name modules.  [ruby-core:42244][Bug #5938]

Mon Jan 23 18:18:58 2012  NARUSE, Yui  <naruse@ruby-lang.org>

	* encoding.c (rb_enc_compatible): fix segv on symbols.
	  [ruby-core:42204] [Bug #5921]

Tue Jan 17 17:18:41 2012  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* configure.in (SPT_TYPE): enable as SPT_REUSEARGV on Darwin.

	* missing/setproctitle.c (ruby_init_setproctitle): changed prefix.

Mon Jan 16 16:41:53 2012  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* lib/optparse.rb (Regexp): fix incorrect options when casting to
	  a Regexp, and suppress encoding option warnings.
	  https://github.com/ruby/ruby/pull/82

Fri Jan 13 15:22:43 2012  Tanaka Akira  <akr@fsij.org>

	* time.c (TIME_COPY_GMT): copy vtm.utc_offset and vtm.zone too.
	  patch by Tomoyuki Chikanaga.
	  [ruby-dev:44827] [Bug #5586]

Thu Jan 12 13:52:13 2012  NARUSE, Yui  <naruse@ruby-lang.org>

	* cont.c (cont_restore_0): prevent optimizing out `sp'. sp is used for
	  reserving a memory space with ALLOCA_N for restoring machine stack
	  stored in cont->machine_stack, but clang optimized out it (and
	  maybe #5851 is also caused by this).
	  This affected TestContinuation#test_check_localvars.

	* cont.c (cont_restore_1): revert workaround introduced in r32201.

Thu Jan 12 01:40:33 2012  NAKAMURA Usaku  <usa@ruby-lang.org>

	* test/ruby/test_io.rb (TestIO#test_autoclose): Tempfile.new doesn't
	  accept the block argument.

Sat Jan  7 22:46:36 2012  Kouhei Sutou  <kou@cozmixng.org>

	* lib/rexml/parsers/baseparser.rb: use private instead of _xxx
	  method name. This is Ruby code not Python code.
	  refs #5696

Tue Jan 03 23:57:37 2012  Ayumu AIZAWA  <ayumu.aizawa@gmail.com>

	* lib/rexml/parsers/baseparser.rb: rexml BaseParser uses
	  instance_eval unnecessarily on listener add.
	  patch from Charles Nutter. [Bug #5696] [ruby-core:41437]

Tue Jan 03 19:13:05 2012  Ayumu AIZAWA  <ayumu.aizawa@gmail.com>

	* test/rexml/test_sax.rb: add require 'rexml/document'.
	  [Backport #5834] [ruby-dev:45079]

Tue Jan  3 19:05:42 2012  Naohisa Goto  <ngotogenome@gmail.com>

	* include/ruby/defines.h (FLUSH_REGISTER_WINDOWS): move sparc asm code
	  to a separete file sparc.c for preventing inlining optimization.
	  Patched by Jurij Smakov. [Bug #5244] [ruby-core:40685]
	* sparc.c (rb_sparc_flush_register_windows): ditto.
	* configure.in: ditto.

Mon Jan  2 23:52:20 2012  TAKAO Kouji  <kouji@takao7.net>

	* ext/readline/readline.c (Init_readline): libedit check
	  rl_getc_function only when rl_initialize() is called, and
	  using_history() call rl_initialize(). This assignment should be
	  placed before using_history(). [ruby-core:40641] [Bug #5539]

Mon Jan  2 23:47:58 2012  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* tool/rbinstall.rb (install_recursive, bin-comm): split mere
	  string not path name.  [ruby-core:40462] [Bug #5492]

Mon Jan  2 23:41:57 2012  Tajima Akil <artonx@yahoo.co.jp>

	* win32/Makefile.sub (CONFIG_H): have stdint.h if VC2010.
	  [Bug #5243]

Mon Jan  2 21:40:45 2012  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* tool/merger.rb (#version_up): version.h date should be Japanese
	  locale date.

Mon Jan  2 21:36:56 2012  Luis Lavena  <luislavena@gmail.com>

	* configure.in: check -fno-omit-frame-pointer acceptance and usage
	  under MinGW. [ruby-core:39957] [Bug #5407]

Mon Jan  2 20:05:10 2012  NARUSE, Yui  <naruse@ruby-lang.org>

	* include/ruby/ruby.h (SIZE_MAX): define SIZE_MAX if not defined.
	  patched by The Written Word Inc. [ruby-core:40422] [Bug #5489]

Mon Jan  2 20:00:01 2012  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/pty/pty.c (pty_check): should return nil until the child
	  terminates or stops.  [ruby-dev:44600] [Bug #2642]

Mon Jan  2 19:27:18 2012  Yusuke Endoh  <mame@tsg.ne.jp>

	* thread.c (update_coverage): skip coverage count up if the current
	  line is out of the way.  rb_sourceline() is unreliable when source
	  code is big.  [ruby-dev:44413]

	* test/coverage/test_coverage.rb: add a test for above.

Mon Jan  2 19:08:54 2012  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* thread_pthread.c (gvl_yield): don't prevent concurrent sched_yield().
	  [Bug #5130] [ruby-core:38647]

Mon Jan  2 18:54:52 2012  NAKAMURA Usaku  <usa@ruby-lang.org>

	* win32/configure.bat: disable delayed expansion of enironment variable.
	  [Bug #5517] [ruby-core:40531]

Wed Dec 28 11:22:45 2011  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* lib/fileutils.rb (FileUtils::Entry_#entries): use utility method
	  instead of typoed regexp.  [ruby-core:41829] [Bug #5817]

Thu Dec 15 10:44:54 2011  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* array.c (rb_ary_reject_bang, rb_ary_delete_if): update rdoc.
	  documentation from Thomas Leitner <t_leitner AT gmx.at> in
	  [ruby-core:41616].  [Bug #5752]

Wed Dec 14 15:28:31 2011  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* transcode.c (str_encode): about the extension of :fallback
	  option since 1.9.3.

Tue Oct  4 06:43:47 2011  Aaron Patterson <aaron@tenderlovemaking.com>

	* ext/psych/lib/psych.rb: update psych version.
	* ext/psych/psych.gemspec: generate new gemspec for new version.

Tue Oct  4 06:29:55 2011  Aaron Patterson <aaron@tenderlovemaking.com>

	* ext/psych/lib/psych.rb: calling `yaml` rather than `to_yaml`.
	* ext/psych/lib/psych/nodes/node.rb: Rename `to_yaml` to just `yaml`
	  in order to avoid YAML::ENGINE switching from replacing this method.
	* test/psych/helper.rb: fix tests for method name change.
	* test/psych/test_document.rb: ditto
	* test/psych/visitors/test_emitter.rb: ditto

Tue Oct  4 06:20:19 2011  Aaron Patterson <aaron@tenderlovemaking.com>

	* ext/psych/lib/psych/scalar_scanner.rb: Match values against the
	  floating point spec defined in YAML to avoid erronious parses.
	* test/psych/test_numeric.rb: corresponding test.

Tue Oct  4 05:59:24 2011  Aaron Patterson <aaron@tenderlovemaking.com>

	* ext/psych/lib/psych/visitors/to_ruby.rb: ToRuby visitor can be
	  constructed with a ScalarScanner.
	* ext/psych/lib/psych/visitors/yaml_tree.rb: ScalarScanner can be
	  passed to the YAMLTree visitor.

Tue Oct  4 05:47:23 2011  Aaron Patterson <aaron@tenderlovemaking.com>

	* ext/psych/lib/psych/visitors/to_ruby.rb: Define Regexp::NOENCODING
	  for 1.9.2 backwards compatibility.
	* ext/psych/lib/psych/visitors/yaml_tree.rb: Fix Date string
	  generation for 1.9.2 backwards compatibility.

Fri Sep  2 04:05:25 2011  Aaron Patterson <aaron@tenderlovemaking.com>

	* ext/psych/lib/psych/visitors/yaml_tree.rb: emit strings tagged as
	  ascii-8bit as binary in YAML.
	* test/psych/test_string.rb: corresponding test.

Wed Dec  7 19:04:22 2011  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* configure.in (rpath): fix typo in the help string.  a patch from
	  Yuji Yamano <yyamano AT kt.rim.or.jp> in [ruby-list:48568].

Wed Nov 30 18:22:10 2011  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* complex.c (nucomp_rationalize): fix function.  [ruby-core:40667]
	  [Bug #5546]

Thu Nov 17 10:36:46 2011  Aaron Patterson <aaron@tenderlovemaking.com>

	* ext/psych/lib/psych.rb (load_file): make sure opened yaml files are
	  also closed. [ruby-core:41088]

Wed Nov 30 02:58:46 2011  Marc-Andre Lafortune  <ruby-core@marc-andre.ca>

	* numeric.c (dbl2ival): Fix Float#divmod and #round for 32 bit
	  platform. part 1 of [bug #5276]

Wed Nov 30 02:58:46 2011  Marc-Andre Lafortune  <ruby-core@marc-andre.ca>

	* numeric.c (flo_round): Fix criteria for 32 bits platform
	  part 2 of [bug #5276]

Wed Nov 30 02:37:32 2011  Marc-Andre Lafortune  <ruby-core@marc-andre.ca>

	* numeric.c (flo_round): Make Float#round round big values [bug
	  #5272]

Wed Nov 30 02:37:32 2011  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* numeric.c (flo_round): substitute machine dependent magic number.

Wed Nov 30 02:28:22 2011  Marc-Andre Lafortune  <ruby-core@marc-andre.ca>

	* numeric.c (int_round): Integer#round always returns an Integer [Bug
	  #5271]

Fri Nov  4 01:56:30 2011  NAKAMURA Usaku  <usa@ruby-lang.org>

	* io.c (make_writeconv): unversal_newline converter is for reading.
	  so, if the io is text mode and has ECONV_UNIVERSAL_NEWLINE_DECORATOR
	  flag, use crlf_newline converter for writing.
	  this change fixes the problem about the luck of CR up Kernel.p and
	  Kernel.puts to stdout/stderr on Windows.

Mon Nov  7 23:39:23 2011  Tajima Akio <artonx@yahoo.co.jp>

	* io.c (io_fflush): remove fsync().
	* io.c (rb_io_flush, rb_io_rewind): fsync() here.
	  These pathces are backports of trunk r33651 for [Bug #5585]

Mon Oct 10 22:33:12 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* test/-ext-/old_thread_select/test_old_thread_select.rb:
	  select() with timeout may return early in old Linux kernels
	  with 250 Hz tickrate and no dynticks, so skip everything older
	  than 2.6.32 (which has long term support).
	  And, Make the timing assertions consistently use assert_operator with
	  timing difference in error message
	  Patch by Eric Wong. [Bug #5335] [ruby-core:39618]

Tue Oct  4 16:17:50 2011  NARUSE, Yui  <naruse@ruby-lang.org>

	* lib/time.rb (Time.strptime): use Time.at if d[:seconds] is set.
	  Reported by Christopher Eberz. [ruby-core:39903] Bug #5399

Tue Oct  4 11:44:10 2011  NARUSE, Yui  <naruse@ruby-lang.org>

	* gc.c (rb_gc_set_params): ruby_verbose can be Qnil, so use RTEST.

Mon Oct  3 23:56:39 2011  CHIKANAGA Tomoyuki  <nagachika00@gmail.com>

	* gc.c (rb_gc_set_params): output GC parameter change messages only
	  if -w/-v options are specified. these messages are output to stderr,
	  not to stdout. [ruby-core:39795] [Bug #5380]

	* test/ruby/test_gc.rb (test_gc_parameter): add test for it.

Wed Sep 28 09:14:16 2011  Nobuyoshi Nakada  <>

	* configure.in (pthread_np.h): needs pthread.h to be included
	  previously on OpenBSD.  a patch by George Koehler <xkernigh AT
	  netscape.net> at [ruby-core:39752].  [Bug #5376]

Tue Sep 13 15:02:48 2011  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* lib/pstore.rb (PStore): always open in binary mode even if
	  default encodings are set.  [Bug #5311] [ruby-core:39503]

Sat Oct  8 07:31:42 2011  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* array.c (ary_join_1): should not copy the encoding of non-string
	  element after string element.  [ruby-core:39776] [Bug #5379]

Sat Oct  8 06:51:46 2011  Eric Hodel  <drbrain@segment7.net>

	* lib/rubygems:  Update to RubyGems 1.8.11.  Move Deprecate into the
	  Gem namespace.

Sat Oct  8 06:37:08 2011  CHIKANAGA Tomoyuki  <nagachika00@gmail.com>

	* gc.c (rb_gc_set_params): output GC parameter change messages only
	  if -w/-v options are specified. these messages are output to stderr,
	  not to stdout. [ruby-core:39795] [Bug #5380]

	* test/ruby/test_gc.rb (test_gc_parameter): add test for it.

Sat Oct  8 06:26:24 2011  CHIKANAGA Tomoyuki  <nagachika00@gmail.com>

	* gc.c (add_heap_slots, init_heap): reset heaps_inc zero when
	  heap slots are expanded by environment variable RUBY_HEAP_MIN_SLOTS.
	  [ruby-core:39777] [Bug #5380]

	* test/ruby/test_gc.rb (test_gc_parameter): add test for it.

	* test/ruby/envutil.rb (assert_normal_exit): add :child_env option to
	  enable pass environemnt variables to child process.

Sat Oct  8 05:45:28 2011  Eric Hodel  <drbrain@segment7.net>

	* proc.c (proc_call):  Update documentation to match argument handling
	  of proc/Proc.new/lambda/->()

Sat Oct  8 05:38:29 2011  Eric Hodel  <drbrain@segment7.net>

	* proc.c (proc_call):  Fix documentation of Proc#call vs Proc#===.
	  [Ruby 1.9 - Bug #5349]

Tue Sep 27 13:05:39 2011  Martin Bosslet  <Martin.Bosslet@googlemail.com>

	* ext/openssl/ossl_asn1.c: fix int_ossl_asn1_decode0_cons when being
	  fed arbitrary string values.
	  Clearly distinguish between the cases "universal, infinite and
	  not a SEQUENCE or SET" and "universal SEQUENCE or SET, possibly
	  infinite". Raise error for universal tags that are not infinite.
	* test/openssl/test_asn1.rb: add a test for this.

	  Thanks to Hiroshi Yoshida for reporting this bug.
	  [Bug #5363] [ruby-dev:44542]

Sat Sep 17 23:34:10 2011  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* parse.y (parser_data_type): inherit the core type in ripper so
	  that checks in core would work.  [ruby-core:39591] [Bug #5331]

Fri Sep 23 14:15:01 2011  Martin Bosslet  <Martin.Bosslet@googlemail.com>

	* ext/openssl/ossl_asn1.c
	  ext/openssl/ossl_pkey.c: Remove unused variables.

Fri Sep 23 06:54:44 2011  Martin Bosslet  <Martin.Bosslet@googlemail.com>

	* backport r33315 from trunk.

	* test/openssl/test_ssl_session.rb: execute test_session_exts_read
	  only for OpenSSL versions >= 0.9.8k. Thanks, Eric Wong, for
	  reporting this.
	  [Bug #4961] [ruby-core:37726]

Fri Sep 23 12:18:52 2011  Martin Bosslet  <Martin.Bosslet@googlemail.com>

	* backport r33311 from trunk.

	* test/openssl/test_ssl_session.rb: ensure server calls callbacks in
	  test_ctx_server_session_cb. Thanks to Eric Wong for the patch.
	  [Bug #5336] [ruby-core:39619]

Thu Sep 22 19:45:22 2011  CHIKANAGA Tomoyuki  <nagachika00@gmail.com>

	* thread_pthread.c (ubf_select): activate timer thread when interrupt
	  blocking thread.
	  A patch created by Koichi Sasada. [ruby-core:39634] [Bug #5343]
	  to cover race condition, timer thread periodically send SIGVTARLM to
	  threads in signal thread list. so you should activate timer thread
	  when interrupt a thread.

Wed Sep 21 16:57:03 2011  NAKAMURA Usaku  <usa@ruby-lang.org>

	* test/io/wait/test_io_wait.rb (TestIOWait#setup): of course, the
	  behavior of mingw is just same with mswin.

Sat Sep 17 22:21:26 2011  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* vm.c (rb_vm_make_env_object, rb_vm_get_sourceline): export as a
	  workaround for ruby-debug19 for the time being.
	  [ruby-core:38972] [Bug #5193]

Fri Sep 16 01:08:19 2011  NAKAMURA Usaku  <usa@ruby-lang.org>

	* NEWS: cosmetic changes.

Wed Sep 14 12:39:00 2011  Kenta Murata  <mrkn@mrkn.jp>

	* configure.in: do not use gcc-4.2 as the default compiler.

	* NEWS: describe the issue about Xcode.

Wed Sep 14 11:46:30 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* thread.c (rb_fd_rcopy): added an argument guard.
	  Patch by NAKAMURA Usaku. [Bug #5306] [ruby-core:39435]

Tue Sep 13 09:28:58 2011  Koichi Sasada  <ko1@atdot.net>

	* NEWS: wrote about rb_reserved_fd_p() and objspace.

Mon Sep 12 20:47:52 2011  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* thread.c (rb_thread_select): fix a typo to initialize efds
	  properly.  [Bug #5299] [ruby-core:39380]

Mon Sep 12 20:41:20 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* thread.c (rb_thread_select): fix to ignore an argument
	  modification of rb_thread_fd_select().
	  based on a patch by Eric Wong. [Bug #5306] [ruby-core:39435]
	* thread.c (rb_fd_rcopy): New. for reverse fd copy.

	* test/-ext-/old_thread_select/test_old_thread_select.rb
	(test_old_select_false_positive): test for bug5306.

	* ext/-test-/old_thread_select/old_thread_select.c (fdset2array):
	  New. convert fdsets to array.
	* ext/-test-/old_thread_select/old_thread_select.c (old_thread_select):
	  return 'read', 'write', 'except' argument of rb_thread_select()
	  to ruby script.

Tue Sep  6 13:15:44 2011  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* encoding.c (load_encoding): predefined encoding names are safe.
	  [ruby-dev:44469] [Bug #5279]

	* transcode.c (load_transcoder_entry): ditto.

Fri Sep  9 16:02:04 2011  NARUSE, Yui  <naruse@ruby-lang.org>

	* insns.def (concatstrings): don't use initial ASCII-8BIT string.
	  [ruby-core:38635] [Bug #5126]

Thu Sep  8 21:17:36 2011  NARUSE, Yui  <naruse@ruby-lang.org>

	* ext/nkf/nkf-utf8/nkf.c: import nkf 2.1.2 (be9c280)
	  Bump version number/release date only.

Wed Sep  7 23:42:45 2011  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* io.c (argf_next_argv): open in default text mode.
	  [ruby-core:39234] [Bug #5268]

Mon Sep  5 15:06:55 2011  NARUSE, Yui  <naruse@ruby-lang.org>

	* test/rubygems/test_gem_security.rb
	  (test_class_build_self_signed_cert): reset opt[:trust_dir] to apply
	  temporary Gem.user_home.

Sun Sep  4 00:56:58 2011  Kazuki Tsujimoto  <kazuki@callcc.net>

	* backport r33177 from trunk.

	* test/ruby/test_fiber.rb (TestFiber#test_no_valid_cfp):
	  add a test. Unlike TestThread#test_no_valid_cfp,
	  this test succeeds even if win32ole is required (see r33153).

Fri Sep  2 21:11:16 2011  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* io.c (validate_enc_binmode, prep_stdio): default to text mode on
	  dosish platforms.  [ruby-core:38822] [Bug #5164]

	* transcode.c (rb_econv_prepare_options): keep default ecflags
	  unchanged if no options.

Fri Sep  2 14:36:47 2011  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* vm_insnhelper.c (vm_search_const_defined_class): search
	  ancestors only when global scope.  [ruby-core:39227] [Bug #5264]

Fri Sep  2 09:58:08 2011  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* parse.y (parser_tokadd_string, parser_yylex): ignore a backslash
	  which prefixes an non-ascii character, which has no escape
	  syntax.  [ruby-core:39222] [Ruby 1.9 - Bug #5262]

Thu Sep  1 17:31:22 2011  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* insns.def (defineclass), vm_insnhelper.c (vm_get_cvar_base): see
	  also inherited constants for classes without superclass and
	  modules.  [ruby-core:37698] [Bug #3423]

Thu Sep  1 14:11:16 2011  NAKAMURA Usaku  <usa@ruby-lang.org>

	* test/ruby/test_thread.rb (TestThread#test_no_valid_cfp): skip when
	  win32ole is required.  in such case, win32ole redefines
	  Thread#initialize, and the block argument becomes to be not the top
	  of the thread, then this testcase always fails.

Wed Aug 31 16:02:45 2011  NARUSE, Yui  <naruse@ruby-lang.org>

	* ext/json: Merge json gem v1.5.4 (3dab4c5a6a97fac03dac).

Wed Aug 31 13:19:31 2011  Marc-Andre Lafortune  <ruby-core@marc-andre.ca>

	* numeric.c (flo_round): Avoid overflow by optimizing for trivial
	  cases
	  [Bug #5227]

Wed Aug 31 06:45:32 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* configure.in: fix r32835. $withval can't be used outer AC_ARG_WITH().

Wed Aug 31 05:29:03 2011  NAKAMURA Usaku  <usa@ruby-lang.org>

	* win32/win32.c (rb_w32_select_with_thread): and my typo. we all must
	  be more careful.

Wed Aug 31 05:28:45 2011  NAKAMURA Usaku  <usa@ruby-lang.org>

	* thread.c (rb_thread_select): critical typo in r33117.

Wed Aug 31 05:28:26 2011  NAKAMURA Usaku  <usa@ruby-lang.org>

	* test/-ext-/old_thread_select/test_old_thread_select.rb
	  (TestOldThreadSelect#test_old_select_read_timeout): if the machine
	  is fast enough, the time used by code around IO.select may be smaller
	  than Time implement threshold.

Wed Aug 31 05:27:59 2011  NAKAMURA Usaku  <usa@ruby-lang.org>

	* ext/-test-/old_thread_select/old_thread_select.c (old_thread_select):
	  typo.

	* test/-ext-/old_thread_select/test_old_thread_select.rb
	  (TestOldThreadSelect#test_old_select_signal_safe): use SIGINT instead
	  of SIGUSR1 because the former is general and the latter is platform
	  dependent.

Wed Aug 31 05:26:30 2011  NAKAMURA Usaku  <usa@ruby-lang.org>

	* win32/win32.c, include/ruby/intern.h (rb_w32_fd_copy): implement
	  for rb_thread_select() in thread.c.  the use of rb_fd_copy() is
	  introduced in r33117.
	  [Bug #5229] [ruby-core:39102]

	* thread.c (rb_thread_select): must call rb_fd_init() before using
	  rb_fdset_t.  see the implementations of rb_fd_init()s if you want to
	  know the reason.

Tue Aug 30 11:25:21 2011  NARUSE, Yui  <naruse@ruby-lang.org>

	* ext/json: Merge json gem 1.5.4+ (2149f4185c598fb97db1).
	  [Bug #5173] [ruby-core:38866]

Tue Aug 30 09:53:59 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* cont.c (fiber_entry): fix stack allocation failure on Debian
	  GNU/kFreeBSD.
	  Patch by Lucas Nussbaum <lucas at lucas-nussbaum dot net>.
	  [Bug #5241] [ruby-core:39147]

Tue Aug 30 09:52:29 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* backport r33117 from trunk.

	* thread.c (rb_thread_select): rewrite by using
	  rb_thread_fd_select(). old one is EINTR unsafe.
	  Patch by Eric Wong. [Bug #5229] [ruby-core:39102]

	* test/-ext-/old_thread_select/test_old_thread_select.rb:
	  a testcase for rb_thread_select().
	* ext/-test-/old_thread_select/old_thread_select.c: ditto.
	* ext/-test-/old_thread_select/depend: ditto.
	* ext/-test-/old_thread_select/extconf.rb: ditto.

Tue Aug 30 09:16:17 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* configure.in: fix a build failure on GNU Hurd.
	  Patch by Samuel Thibault <sthibault at debian dot org>. Thank you!
	  [Bug #5250] [ruby-core:39185]

Sun Aug 28 15:38:17 2011  CHIKANAGA Tomoyuki  <nagachika00@gmail.com>

	* backport r33106 from trunk.

	* ext/date/date_parse.c (date_zone_to_diff): keep a temporary string
	  stored in variable while the contents buffer is beeing used.

	* ext/date/date_parse.c (date_zone_to_diff): get rid of out of bounds
	  memory read. [ruby-dev:44409] [Bug #5213]

Sun Aug 28 05:29:50 2011  Ryan Davis  <ryand-ruby@zenspider.com>

	* backport r33102 from trunk.

	* lib/minitest/*: Imported minitest 2.5.1 (r6596)
	* test/minitest/*: ditto

Sat Aug 27 20:54:54 2011  Kazuki Tsujimoto  <kazuki@callcc.net>

	* backport r33099 from trunk.

	* vm.c (rb_vm_rewrite_dfp_in_errinfo): change return type
	  to suppress a warning.

	* vm_core.h: ditto.

Sat Aug 27 19:03:44 2011  Kazuki Tsujimoto  <kazuki@callcc.net>

	* backport r33096 from trunk.

	* proc.c (proc_new): force to rewrite errinfo when calling Proc.new in ensure.
	  [Bug #5234] [ruby-core:39125]

	* vm.c (rb_vm_rewrite_dfp_in_errinfo): new function.

	* vm.c (vm_make_env_each): changed accordingly.

	* vm_core.h: ditto.

	* bootstraptest/test_flow.rb: add tests for above.

Sat Aug 27 08:59:12 2011  Eric Hodel  <drbrain@segment7.net>

	* NEWS:  Update version of rake to 0.9.2.2.

Sat Aug 27 08:44:58 2011  Eric Hodel  <drbrain@segment7.net>

	* backport r33087 from trunk

	* lib/rdoc:  Import RDoc 3.9.4.  Typo and grammar fixes by Luke Gruber.
	  [Ruby 1.9 - Bug #5203]

Sat Aug 27 07:53:34 2011  Eric Hodel  <drbrain@segment7.net>

	* backport r33087 from trunk.

	* lib/open-uri.rb:  Fix indentation of OpenURI::OpenRead#open.  Use ++
	  instead of `' for method arguments in open-uri.rb

Sat Aug 27 07:22:07 2011  Eric Hodel  <drbrain@segment7.net>

	* backport r33086 from trunk.

	* ext/pathname/lib/pathname.rb:  Fix typos and grammar mistakes.  Patch
	  by Luke Gruber.  [#5203]
	* ext/pty/lib/expect.rb:  ditto
	* lib/mathn.rb:  ditto
	* lib/net/http.rb:  ditto
	* lib/open-uri.rb:  ditto
	* lib/ostruct.rb:  ditto
	* lib/tempfile.rb:  ditto
	* lib/thread.rb:  ditto
	* lib/weakref.rb:  ditto
	* sample/webrick/httpproxy.rb:  ditto

Fri Aug 26 10:10:37 2011  Eric Hodel  <drbrain@segment7.net>

	* backport r33074 from trunk.

	* lib/rubygems:  Update to RubyGems 1.8.10.  Fixes security issue in
	  creating ruby-format gemspecs.  Fixes Gem.dir not being at the front
	  of Gem.path to fix uninstall and cleanup commands.  Fixes gem
	  uninstall stopping on the first missing gem.

Wed Aug 24 09:49:10 2011  Koichi Sasada  <ko1@atdot.net>

	* backport r33045 from trunk.

	* insns.def (defined): fix to checking class variable.
	  A patch by Magnus Holm <judofyr@gmail.com>.  Thanks!

Fri Aug 26 08:21:10 2011  Aaron Patterson <aaron@tenderlovemaking.com>

	* test/ruby/test_variable.rb: add a test for above.

Thu Aug 25 09:43:16 2011  Eric Hodel  <drbrain@segment7.net>

	* backport r33066 from trunk.

	* ext/openssl/lib/openssl/bn.rb:  Hide copyright info from RDoc.
	* ext/openssl/lib/openssl/digest.rb:  ditto
	* ext/openssl/lib/openssl/cipher.rb:  ditto

Thu Aug 25 09:25:48 2011  Eric Hodel  <drbrain@segment7.net>

	* backport r33065 from trunk.

	* ext/openssl/ossl_digest.c:  Document OpenSSL::Digest::digest and add
	  an example to OpenSSL::Digest.  Patch by Sylvain Daubert.
	  [Ruby 1.9 - Bug #5166]
	* ext/openssl/lib/openssl/digest.rb (module OpenSSL):  ditto

Thu Aug 25 08:19:43 2011  Koichi Sasada  <ko1@atdot.net>

	* vm.c (vm_make_env_each): work around to solve Bug #2729.
	  fixes: Bug #2729
	  a patch from Kazuki Tsujimoto <kazuki@callcc.net>
	  This problem is caused by changing dfp (dynamic env pointer)
	  from saved dfp.  Saved dfp is pointed env in VM stack.  However,
	  the dfp can be moved because VM copies env from VM stack to
	  the heap.  At this copying, dfp was also changed.  To solve this
	  problem, I'll try to change throw mechanism (not save target dfp,
	  but save target cfp).

	* bootstraptest/test_flow.rb: add a test for above.

Thu Aug 25 08:04:08 2011  Marc-Andre Lafortune  <ruby-core@marc-andre.ca>

	* numeric.c (int_round): Fix Integer#round [ruby-core:39096]

Thu Aug 25 06:51:08 2011  Aaron Patterson <aaron@tenderlovemaking.com>

	* ext/psych/lib/psych.rb: Fixing psych version number.

Thu Aug 25 06:11:35 2011  Aaron Patterson <aaron@tenderlovemaking.com>

	* ext/psych/lib/psych/nodes/node.rb: default `to_yaml` encoding to be
	  UTF-8.
	* test/psych/test_encoding.rb: test yaml dump encoding.

Wed Aug 24 08:53:06 2011  Eric Hodel  <drbrain@segment7.net>

	* backport r33043 from trunk.

	* lib/rdoc:  Update to RDoc 3.9.3.  Fixes RDoc with `ruby -Ku`.  Allows
	  HTTPS image paths to be turned into <img> tags.  Prevents special
	  markup inside <tt> from being processed.

Wed Aug 24 07:57:43 2011  Eric Hodel  <drbrain@segment7.net>

	* backport r33040 from trunk.

	* lib/rubygems:  Update to RubyGems 1.8.9.  Fixes uninstalling multiple
	  gems and gem cleanup.

Wed Aug 24 06:45:20 2011  Ryan Davis  <ryand-ruby@zenspider.com>

	* backport r33036 from trunk.

	* lib/minitest/*: Imported minitest 2.5.0 (r6557)
	* test/minitest/*: ditto

Tue Aug 23 15:23:56 2011  Eric Hodel  <drbrain@segment7.net>

	* backport r33027 from trunk.

	* load.c (rb_f_require):  Improve documentation of Kernel#require.
	  [Ruby 1.9 - Bug #5210]

Tue Aug 23 15:11:48 2011  Hiroshi Nakamura  <nahi@ruby-lang.org>

	* backport r33023 from trunk.

	* ext/zlib/zlib.c (gzfile_read_header): Ensure that each section of
	  gzip header is readable to avoid SEGV.

	* test/zlib/test_zlib.rb (test_corrupted_header): Test it.

Mon Aug 22 23:43:33 2011  CHIKANAGA Tomoyuki  <nagachika00@gmail.com>

	* backport r33021 from trunk.

	* sprintf.c (rb_str_format): add RB_GC_GUARD to prevent temporary
	  strings from GC.

Sun Aug 21 17:58:38 2011  Kazuki Tsujimoto  <kazuki@callcc.net>

	* backport r33019 from trunk.

	* iseq.c (iseq_s_disasm): remove variable which is no longer used
	  since r33013.

Sun Aug 21 14:20:58 2011  Naohisa Goto  <ngotogenome@gmail.com>

	* configure.in: use LD_LIBRARY_PATH_64 on 64-bit Solaris.

Sun Aug 21 11:13:54 2011  Naohisa Goto  <ngotogenome@gmail.com>

	* backport r32895 from trunk.

	* ext/fiddle/conversions.c (generic_to_value): ffi_arg and ffi_sarg
	  should be used to handle shorter return value. fix [Bug #3861]
	  [ruby-core:32504]

	* ext/fiddle/closure.c (callback): ditto

	* ext/fiddle/conversions.h (fiddle_generic): ditto

	* ext/fiddle/conversions.c (value_to_generic): char, short and int
	  are strictly distinguished on big-endian CPU, e.g. sparc64.

Sat Aug 20 13:28:32 2011  Kazuki Tsujimoto  <kazuki@callcc.net>

	* backport r33013 from trunk.

	* iseq.c (iseq_s_disasm): fix a bug that may cause SEGV.

	* test/ruby/test_method.rb (test_body): add a test for the above change.

Sat Aug 20 10:43:24 2011  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/stringio/stringio.c (strio_read): return new string if nil
	  is explicitly given as a buffer ([Bug #5207]), otherwise set the
	  encoding.  also removed dead code.

Fri Aug 19 14:25:51 2011  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* process.c (proc_spawn_v, proc_spawn): should not wait the
	  spawned process.

	* process.c (proc_spawn_v): fix missing argument, and try with
	  /bin/sh only if failed with ENOEXEC.

Fri Aug 19 14:12:57 2011  Shugo Maeda  <shugo@ruby-lang.org>

	* backport r33007 from trunk.

	* lib/net/imap.rb (idle): raises a Net::IMAP::Error when the
	  connection is closed.  based on the patch by Hugo Barauna.
	  [Bug #5190] [ruby-core:38930]

Fri Aug 19 11:28:58 2011  Shugo Maeda  <shugo@ruby-lang.org>

	* backport r33001 from trunk.

	* lib/net/imap.rb (msg_att): accepts extra space before ')'.
	  based on the patch by art lussos.  [Bug #5163] [ruby-core:38820]

Wed Aug 17 15:27:00 2011  Kenta Murata  <mrkn@mrkn.jp>

	* backport r32996 from trunk.

	* ext/bigdecimal/bigdecimal.c (cannot_be_coerced_into_BigDecimal):
	  add a new function for raising error when an object cannot coerce
	  into BigDecimal.  [Bug #5172]

	* ext/bigdecimal/bigdecimal.c (BigDecimalValueWithPrec): use
	  cannot_be_coerced_into_BigDecimal function.

	* ext/bigdecimal/bigdecimal.c (BigMath_s_exp): ditto.

	* ext/bigdecimal/bigdecimal.c (BigMath_s_log): ditto.

	* test/bigdecimal/test_bigdecimal.rb: test for the avobe changes.

	* test/bigdecimal/testbase.rb (under_gc_stress): add a new utility
	  method to run tests under the condition of GC.stress = true.

Wed Aug 17 10:16:00 2011  Kenta Murata  <mrkn@mrkn.jp>

	* backport r32994 from trunk.

	* rational.c (nurat_coerce): Rational#coerce should converts itself
	  into Complex if the argument is a Complex with non-zero imaginary
	  part.  [Bug #5020] [ruby-dev:44088]

	* test/ruby/test_rational.rb (test_coerce): test for the above change.

Wed Aug 17 06:33:19 2011  Martin Bosslet  <Martin.Bosslet@googlemail.com>

	* backport r32992 from trunk.

	* ext/openssl/ossl_x509cert.c: Add class documentation for
	  OpenSSL::X509::Certificate.

Wed Aug 17 05:02:25 2011  Martin Bosslet  <Martin.Bosslet@googlemail.com>

	* backport r32987 from trunk.

	* ext/openssl/ossl_pkey.c: corrected docs, OpenSSL::PKey::DH does
	  *not* support #sign/verify.

Tue Aug 16 18:56:54 2011  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* vm.c (ruby_threadptr_data_type): rename to hide.
	  [ruby-core:38972]

Tue Aug 16 18:52:08 2011  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* win32/mkexports.rb (Exports::Mswin#each_export): exclude Init_
	  and _threadptr_ functions, as well as mingw.

Tue Aug 16 09:38:37 2011  Eric Hodel  <drbrain@segment7.net>

	* backport r32981 and r32982 from trunk.

	* ext/dl:  Add documentation.  Patch by Vincent Batts.
	  [Ruby 1.9 - Bug #5192]

	* ext/.document (fiddle):  Remove duplicate entry

	* ext/fiddle:  Complete documentation of Fiddle.  Patch by Vincent
	  Batts.  [#5192]

Tue Aug 16 08:00:15 2011  Eric Hodel  <drbrain@segment7.net>

	* backport r32977 from trunk

	* ext/socket:  Make Socket documentation appear.  Add documentation for
	  Socket, TCPServer, SOCKSSocket.  Patch by Sylvain Daubert.
	  [Ruby 1.9 - Feature #5182]

Mon Aug 15 10:16:55 2011  Martin Bosslet  <Martin.Bosslet@googlemail.com>
	* backport r32973 from trunk.

	* ext/openssl/ossl_ssl.c: Support disabling OpenSSL compression.

	* test/openssl/test_ssl.rb: Add a test for it.
	  Thanks to Eric Wong for the patch.
	  [Ruby 1.9 - Feature #5183] [ruby-core:38911]

Sat Aug 13 22:17:27 2011  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* tool/mkconfig.rb: do not make the entries related to sitedir and
	  verdordir if disabled by --without options.  [ruby-core:38922]
	  [Bug #5187]

Sat Aug 13 17:06:57 2011  Tadayoshi Funaba  <tadf@dotrb.org>

	* ext/date/date_core.c: [ruby-core:38861]

Sat Aug 13 16:59:51 2011  Tadayoshi Funaba  <tadf@dotrb.org>

	* test/date/test_*.rb: added tests.

Sat Aug 13 09:36:19 2011  CHIKANAGA Tomoyuki  <nagachika00@gmail.com>

	* ext/date/date_parse.c (parse_ddd_cb): fix r32896. RB_GC_GUARD
	  insertion position was mistaken. [ruby-dev:44337] [Bug #5152]

Sat Aug 13 09:26:24 2011  Aaron Patterson <aaron@tenderlovemaking.com>

	* ext/psych/lib/psych/core_ext.rb: Make Kernel#y private.
	  [ruby-core:38913]

	* test/psych/test_yaml.rb: corresponding test.

Sat Aug 13 09:15:16 2011  Tadayoshi Funaba  <tadf@dotrb.org>

	* ext/date/date_core.c (date_strftime_alloc): followed the change
	  of r32885.

	* NEWS: followed the above change.

Sat Aug 13 08:49:05 2011  Tadayoshi Funaba  <tadf@dotrb.org>

	* ext/date/date_core.c: [ruby-core:38855].

Sat Aug 13 03:41:37 2011  Eric Hodel  <drbrain@segment7.net>

	* backport r32953 from trunk.

	* lib/uri/common.rb:  Fix documentation of URI::Parser.new.  Patch by
	  Steve Klabnik.  [Ruby 1.9 - Bug #5177]

Sat Aug 13 02:19:57 2011  Eric Hodel  <drbrain@segment7.net>

	* backport r32950 from trunk.

	* ext/digest/digest.c:  Add documentation for the Digest module.  Patch
	  by Sylvain Daubert.  [Ruby 1.9 - Bug #5167]

Fri Aug  5 13:32:43 2011  Shugo Maeda  <shugo@ruby-lang.org>

	* backport r32856 from trunk.

	* lib/xmlrpc/client.rb, lib/xmlrpc/server.rb: should use
	  String#bytesize instead of String#size.

Fri Aug 12 13:53:03 2011  Narihiro Nakamura  <narihiro@netlab.jp>

	* backport r32894 from trunk.

	* gc.c (gc_lazy_sweep): if sweep target slots are not found, we
	  try heap_increment() because it might be able to expand the
	  heap. [Bug #5127] [ruby-dev:44285]

	* gc.c (gc_clear_mark_on_sweep_slots): if a sweeping was
	  interrupted, we expand the heap if at all possible.

Fri Aug 12 12:28:17 2011  Eric Hodel  <drbrain@segment7.net>

	* lib/rake:  Update to Rake 0.9.2.2.  Prevent pollution of toplevel
	  namespace by Commands.  Remove unused variable and debugging
	  statement in tests.

Fri Aug 12 09:00:24 2011  Eric Hodel  <drbrain@segment7.net>

	* backport r32941 from trunk

	* lib/rubygems:  Import RubyGems 1.8.8.  Fixes encoding of YAML gemspec
	  from gems.  Github Issue #149

Fri Aug 12 03:24:35 2011  Eric Hodel  <drbrain@segment7.net>

	* backport r32935 from trunk

	* lib/rdoc:  Import RDoc 3.9.2.  Fixes TIDYLINK for HTML output.

Tue Aug  2 22:04:46 2011  NARUSE, Yui  <naruse@ruby-lang.org>

	* backport r32815 from trunk.

	* gc.c (init_heap): allocate sigaltstack after heaps are allocated.
	  [ruby-dev:44315] [Bug #5139]

	* vm.c (thread_free): use free because objspace is not ready.

	* vm.c (th_init): use malloc because objspace is not ready.

Thu Aug 11 19:04:38 2011  Hiroshi Nakamura  <nahi@ruby-lang.org>

	* backport r32931 from trunk.

	* variable.c (autoload_delete): An autoload entry is still in a
	  RCLASS_IV_TBL, not in a RCLASS_CONST_TBL, so take back the table
	  changed in r29600. And an autoload entry keeps not a
	  rb_const_entry_t but a NODE so remove rb_const_entry_t thing added
	  in r29602.

Thu Aug 11 15:07:36 2011  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* lib/mkmf.rb (link_command): use LIBRUBYARG in rbconfig for
	  unbundled extensions.  [ruby-core:38802] [Bug #5147]

	* lib/mkmf.rb (init_mkmf): revert r32902.  [ruby-core:38903]

Wed Aug 10 19:30:00 2011  Kenta Murata  <mrkn@mrkn.jp>

	* backport r32903 from trunk.

	* complex.c (nucomp_rationalize): calls rationalize of real part if
	  imaginary part is exactly zero.  The patch is made by Marc-Andre
	  Lafortune.  fixes [Bug #5178] [ruby-core:38885]

	* test/ruby/test_complex.rb (test_rationalize): add a test for the
	  above change.

	* complex.c (nucomp_to_r): fix RDoc comment.  The patch is made by
	  Marc-Andre Lafortune.

Wed Aug 10 14:11:07 2011  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* lib/mkmf.rb (init_mkmf): set $LIBRUBYARG regardless of shared
	  option.  [ruby-core:38802] [Bug #5147]

Wed Aug 10 02:57:01 2011  NARUSE, Yui  <naruse@ruby-lang.org>

	* lib/net/http.rb: come back autoload. OpenSSL constant is used
	  some places, so it leads mistakes like HTTP.start.

Tue Aug  9 22:57:45 2011  CHIKANAGA Tomoyuki  <nagachika00@gmail.com>

	* ext/date/date_parse.c (date_zone_to_diff): add RB_GC_GUARD.
	  [ruby-dev:44337] [Bug #5152]

	* ext/date/data_parse.c (parse_ddd_cb): ditto.

Tue Aug  9 12:20:33 2011  Naohisa Goto  <ngotogenome@gmail.com>

	* test/fiddle/helper.rb (libc_so, libm_so): Solaris support added.
	  [ruby-core:38853] [Bug #5168]

	* test/dl/test_base.rb (libc_so, libm_so): on Solaris, remove libc
	  and libm version numbers for detecting default libc and libm.

Tue Aug  9 10:49:52 2011  Igor Zubkov  <igor.zubkov@gmail.com>

	* array.c: Fix typo. https://github.com/ruby/ruby/pull/36

Mon Aug  8 00:10:45 2011  Akinori MUSHA  <knu@iDaemons.org>

	* test/test_syslog.rb (TestSyslog#test_log): Do not be too
	  specific about the log line format.  Fixes #5081.

Sun Aug  7 23:39:44 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* time.c (rb_strftime_alloc): raise ERANGE if width is too large.
	  Patch by Nobuyoshi Nakada. [Bug #4457] [ruby-dev:43285]

	* test/ruby/test_time.rb (class TestTime): add a test for the
	  above change.

Sun Aug  7 14:15:10 2011  Kazuki Tsujimoto  <kazuki@callcc.net>

	* backport r32876 from trunk.

	* ext/objspace/objspace.c: fix typos in a document.

Sun Aug  7 04:42:36 2011  Eric Hodel  <drbrain@segment7.net>

	* marshal.c (w_object):  Fix exception message when _dump_data
	  is not defined on a T_DATA object.

Sat Aug  6 06:14:20 2011  Eric Hodel  <drbrain@segment7.net>

	* lib/rdoc:  Update to 3.9.1.  Fixes === lines in verbatim sections.
	  Fixes :nodoc: on class aliases.  Fixes :stopdoc: creating references
	  to Object.  Fixes spacing when class comments are merged in ri.
	  Fixes `ri []` crash.  Fixes bug report URL when rdoc crashes.  Adds
	  :doc: and :nodoc: to allow hiding of implementation details in ruby.
	  Makes `rdoc` and `ri` gem-aware.

Sat Aug  6 03:19:45 2011  Eric Hodel  <drbrain@segment7.net>

	* lib/rubygems:  Import RubyGems 1.8.7:
	  Added missing require for `gem uninstall --format-executable`.

	  The correct name of the executable being uninstalled is now displayed
	  with --format-executable.

	  Fixed `gem unpack uninstalled_gem` default version picker.

	  RubyGems no longer claims a nonexistent gem can be uninstalled.

	  `gem which` no longer claims directories are requirable files.

	  `gem cleanup` continues cleaning up gems if one can't be uninstalled
	  due to permissions.  Issue #82.

	  Gem repository directories are no longer created world-writable.
	  Patch by Sakuro OZAWA.  [Ruby 1.9 - Bug #4930]

Fri Aug  5 23:08:39 2011  Naohisa Goto  <ngotogenome@gmail.com>

	* backport r32845 from trunk.

	* configure.in: when Solaris cc, use $(CC) to link shared libs.

Fri Aug  5 22:16:20 2011  Naohisa Goto  <ngotogenome@gmail.com>

	* numeric.c (rb_infinity, rb_nan): use WORDS_BIGENDIAN to get endian.
	  fix [Bug #5160] [ruby-dev:44356]

Fri Aug  5 15:57:10 2011  Naohisa Goto  <ngotogenome@gmail.com>

	* complex.c (f_signbit): fix compile error in gcc4 on Solaris with
	  CFLAGS="-std=gnu99".  [ruby-dev:44355] fix [Bug #5159]

	* math.c: ditto.

Thu Aug  5 10:09:00 2011  Kenta Murata  <mrkn@mrkn.jp>

	* backport r32846 from trunk.

	* thread_pthread.c (native_cond_signal): retry to call pthread_cond_signal
	  and pthread_cond_broadcast if they return EAGAIN in
	  native_cond_signal and native_cond_broadcast, respectively.
	  It is for the pthread implementation of Mac OS X 10.7 (Lion).
	  fixes #5155.  [ruby-dev:44342].

	* thread_pthread.c (native_cond_broadcast): ditto.

	* thread_pthread.c (struct cached_thread_entry): stop using
	  pthread_cond_t and its functions directly.

	* thread_pthread.c (register_cached_thread_and_wait): ditto.

	* thread_pthread.c (use_cached_thread): ditto.

Fri Aug  5 07:35:00 2011  Luis Lavena  <luislavena@gmail.com>

	* lib/rubygems/installer.rb (class Gem): Correct path check on Windows
	  Possible fix for [Ruby 1.9 - Bug #5111]

	* test/rubygems/test_gem_installer.rb (load Gem): ditto
	  Backported from trunk r32804

Fri Aug  5 07:00:31 2011  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* test/io/console/test_io_console.rb (test_noctty): daemon() on
	  Fedora Rawhide seems not to detach the controlling terminal,
	  when the argument noclose is non-zero.  ref: [Bug #5135]

Wed Aug  4 02:35:00 2011  Kenta Murata  <mrkn@mrkn.jp>

	* configure.in: use build_os variable for checking C and C++ compilers
	  matching.

	* configure.in: use clang++ if clang is used.

Thu Aug  4 02:21:10 2011  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* lib/mkmf.rb (link_command): use static library only for bundled
	  extensions.  [Bug #5147]

Wed Aug  3 00:11:08 2011  Tanaka Akira  <akr@fsij.org>

	* lib/prettyprint.rb: update document.  [ruby-core:36776]


Tue Aug  2 20:10:16 2011  Shota Fukumori  <sorah@tubusu.net>

	* test/testunit/test_parallel.rb: pass "--ruby" option to
	  test/testunit/tests_for_parallel/runner.rb. [Bug #5132] [ruby-dev:44303]
	  Backported from trunk r32812.

Tue Aug  2 12:03:16 2011  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* hash.c (recursive_hash): hash value of emptied hash should be
	  equal to an empty hash.  [ruby-core:38650]

Tue Aug  2 11:42:15 2011  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* parse.y (rb_enc_symname2_p): :! is valid symbol.  [Bug #5136]

Tue Aug  2 03:26:02 2011  NAKAMURA Usaku  <usa@ruby-lang.org>

	* test/rake/test_rake_directory_task.rb (TestRakeDirectoryTask#
	  test_directory_win32): fixed wrong test.
	  backported r32670 from trunk.

Mon Aug  1 15:45:23 2011  Eric Hodel  <drbrain@segment7.net>

	* test/rake/test_rake_functional.rb:  Don't assume the binary name of
	  ruby is "ruby".  [Ruby 1.9 - Bug #5114]
	* test/rake/helper.rb:  ditto

Mon Aug  1 05:21:42 2011  TAKANO Mitsuhiro (takano32)  <tak@no32.tk>

	* cont.c (cont_save_thread): fix missing semicolon.

Sun Jul 31 22:57:16 2011  Yuki Sonoda (Yugui)  <yugui@yugui.jp>

	* enc/Makefile.in (ECHO1): Same as the recent fix in common.mk.
	  ":" in a make variable replacement cause a syntax error with
	  /usr/ccs/bin/make on Solaris.  Uses $(NULLCMD) instead.

Sun Jul 31 22:44:08 2011  Kazuki Tsujimoto  <kazuki@callcc.net>

	* configure.in: fix typos.

Sun Jul 31 21:19:51 2011  Yuki Sonoda (Yugui)  <yugui@yugui.jp>

	* lib/mkmf.rb (configuration:ECHO1): Same as the recent fix in
	  common.mk.
	  ":" in a make variable replacement cause a syntax error with
	  /usr/ccs/bin/make on Solaris.  Uses $(NULLCMD) instead.

Sun Jul 31 21:16:02 2011  Yuki Sonoda (Yugui)  <yugui@yugui.jp>

	* complex.c (f_signbit): gcc4 on Solaris DOES have signbit but does
	  not have it on header.

	* math.c: ditto.

Sun Jul 31 21:09:04 2011  Yuki Sonoda (Yugui)  <yugui@yugui.jp>

	* common.mk (node_name.inc): Use $(Q) for consistency.

	* Makefile.in (INSNS): ditto.

Sun Jul 31 20:39:12 2011  Yuki Sonoda (Yugui)  <yugui@yugui.jp>

	* common.mk (ECHO1): nmake does not allow parenthesis in make variable
	  replacement.

Sun Jul 31 20:21:36 2011  "Yuki Sonoda (Yugui)"  <yugui@yugui.jp>

	* common.mk (ECHO1): ":" in a make variable replacement cause a syntax
	  error with /usr/ccs/bin/make on Solaris.  Uses $(NULLCMD) instead.

	* configure.in (NULLCMD): new check.

	* Makefile.in (NULLCMD): Reflects checking in configure.

	* win32/Makefile.sub (NULLCMD): new assignment.

Sun Jul 31 11:31:07 2011  Kazuki Tsujimoto  <kazuki@callcc.net>

	* backport r32768 from trunk.

	* vm.c: check if cfp is valid. [Bug #5083] [ruby-dev:44208]

Sat Jul 31 01:23:45 2011  Kenta Murata  <mrkn@mrkn.jp>

	* backport r32762 from trunk.

	* test/bigdecimal/test_bigdecimal.rb (test_version): removed.

Sat Jul 30 23:51:44 2011  Tadayoshi Funaba  <tadf@dotrb.org>

	* lib/cmath.rb (cbrt): should return a real number if possible.

Sat Jul 30 23:48:04 2011  Tadayoshi Funaba  <tadf@dotrb.org>

	* ext/date/date_core.c: an issue that is same as  [ruby-dev:44071].

	* ext/date/date_strftime.c: identical to [ruby-dev:44112].

Sat Jul 30 23:19:09 2011  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* defs/default_gems: separate from tool/rbinstall.rb.

Sat Jul 30 23:14:44 2011  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* io.c (rb_io_each_byte): rbuf can be refreshed during yield.
	  [Bug #5119]

Sat Jul 30 22:35:50 2011  Naohisa Goto  <ngotogenome@gmail.com>

	* strftime.c (NEEDS): avoid SEGV due to integer overflow in
	  sparc-solaris2.10 and i686-linux.  fix [Bug #4456] [ruby-dev:43284]

Sat Jul 30 14:27:00 2011  Kenta Murata  <mrkn@mrkn.jp>

	* backport r32754 from trunk.

	* ext/bigdecimal/bigdecimal.c (BigDecimal_version): version 1.1.0.

	* ext/bigdecimal/bigdecimal.gemspec: turn into a default gem.

	* tool/rbinstall.rb: ditto.

Sat Jul 30 13:52:00 2011  Kenta Murata  <mrkn@mrkn.jp>

	* ext/bigdecimal/lib/bigdecimal/util.rb (Rational#to_d):
	  revive zero and implicit precision support as a deprecated feature.

	* test/bigdecimal/test_bigdecimal_util.rb: modify a test for the above
	  change.

	* NEWS: describes the above change.

Sat Jul 30 10:58:10 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* vm.c (th_init): preallocate alternative stack.
	  NoMemoryError is better than rb_bug, of course.
	  Patch by Eric Wong. [ruby-core:38572][ruby-core:38594].

	* signal.c (rb_register_sigaltstack): ditto.

	* vm_core.h: moved ALT_STACK_SIZE definition from signal.c.

	* vm.c (thread_free): use xfree() instead of free().

Sat Jul 30 07:20:49 2011  Tanaka Akira  <akr@fsij.org>

	* ext/socket/lib/socket.rb (udp_server_sockets): unused variable
	  removed.
	  patch by Jeremy Evans.  [ruby-core:38600]

Fri Jul 29 23:56:32 2011  Tanaka Akira  <akr@fsij.org>

	* lib/securerandom.rb: call OpenSSL::Random.seed at the
	  SecureRandom.random_bytes call.
	  based on the patch by Masahiro Tomita.  [ruby-dev:44270]

Fri Jul 29 20:48:39 2011  Tanaka Akira  <akr@fsij.org>

	* ext/socket/mkconstants.rb: fix typos.

Fri Jul 29 20:28:56 2011  Tanaka Akira  <akr@fsij.org>

	* ext/socket/mkconstants.rb: use whitespaces as a separator.

Fri Jul 29 18:59:07 2011  Tanaka Akira  <akr@fsij.org>

	* ext/socket/mkconstants.rb: add documents for constants.
	  patch by Eric Hodel.  [ruby-core:37853] [Bug #4989]

Mon Jul 25 23:51:01 2011  Yusuke Endoh  <mame@tsg.ne.jp>

	* backport r32671 from trunk.

	* proc.c: pre-allocate the unlinked_method_entry_list_entry struct to
	  avoid memory allocation during GC.  based on a patch from Eric Wong.
	  [ruby-core:38498]

Mon Jul 25 22:36:11 2011  Yusuke Endoh  <mame@tsg.ne.jp>

	* backport r32669 from trunk.

	* proc.c (struct METHOD), gc.c (gc_marks), vm_method.c
	  (rb_gc_mark_unlinked_live_method_entries): fix SEGV bug.
	  rb_method_entry_t was free'd even when the method is still on the
	  stack if it is BMETHOD (i.e., Method#call).  This is because
	  rb_method_entry_t is embedded in struct METHOD.  This commit
	  separates them and marks the live method entries.
	  See [ruby-core:38449] in detail.  fix [Bug #5047] [ruby-core:38171]

Thu Jul 28 23:36:28 2011  CHIKANAGA Tomoyuki  <nagachika00@gmail.com>

	* ext/fiddle/closure.c (callback): use rb_ary_tmp_new() instead of
	  xmalloc() to allocate an array for arguments of callback procedure,
	  to prevent arguments from being swept by GC. [ruby-core:38546]
	  [Bug #4929]

Thu Jul 28 22:51:27 2011  Hiroshi Nakamura  <nahi@ruby-lang.org>

	* backport r32723 from trunk.

	* ext/openssl/ossl_cipher.c (ossl_cipher_initialize): Avoid possible
	  SEGV from AES encryption/decryption. Processing data by
	  Cipher#update without initializing key (meaningless usage of Cipher
	  object since we don't offer a way to export a key) could cause SEGV.

	  In OpenSSL, the EVP which has EVP_CIPH_RAND_KEY flag (such as DES3)
	  allows uninitialized key, but other EVPs (such as AES) does not
	  allow it. Calling EVP_CipherUpdate() without initializing key causes
	  SEGV so we set the data filled with "\0" as the key by default. See
	  #2768.

	* test/openssl/test_cipher.rb: test it.

Thu Jul 28 04:53:31 2011  Eric Hodel  <drbrain@segment7.net>

	* lib/delegate.rb:  Move file-level documentation to the appropriate
	  classes.

Thu Jul 28 00:33:47 2011  NARUSE, Yui  <naruse@ruby-lang.org>

	* test/fileutils/test_fileutils.rb: add OpenBSD case.
	  patched by Jeremy Evans [ruby-core:38530] see #5097

	* test/ruby/test_process.rb: ditto.

Wed Jul 27 17:59:46 2011  NARUSE, Yui  <naruse@ruby-lang.org>

	* include/ruby/missing.h: define __syscall if the platform has
	  __syscall in the library but doesn't define it in headers
	  for example Mac OS X.

Wed Jul 27 15:39:14 2011  Eric Hodel  <drbrain@segment7.net>

	* object.c:  Add usage documentation for BasicObject.  Based on patch
	  by Thomas Sawyer.  [Ruby 1.9 - Bug #5067]

Wed Jul 27 12:24:17 2011  Eric Hodel  <drbrain@segment7.net>

	* lib/rubygems/uninstaller.rb:  Add missing require and update
	  messaging to avoid confusion with uninstall --format-executable.
	  [Ruby 1.9 - Bug #4062]

Wed Jul 27 10:47:57 2011  Eric Hodel  <drbrain@segment7.net>

	* lib/rubygems:  Update to RubyGems 1.8.6.1.

Wed Jul 27 10:04:06 2011  Martin Bosslet  <Martin.Bosslet@googlemail.com>

	* backport r32690 from trunk.

	* test/openssl/test_pkcs12.rb: Add test and intermediate certificates.
	  [ Ruby 1.9 - Feature #3793 ] [ruby-core:32088]

Sat Jul 27 01:26:00 2011  Kenta Murata  <mrkn@mrkn.jp>

	* NEWS: add changes of bigdecimal and bigdecimal/util.

Wed Jul 27 01:13:00 2011  Kenta Murata  <mrkn@mrkn.jp>

	* ext/bigdecimal/lib/bigdecimal/util.rb (Rational#to_d):
	  zero or negative precision is error.  fixes #5098.
	  [ruby-dev:44210]

	* ext/bigdecimal/lib/bigdecimal/util.rb (Float#to_d): modified for
	  specifying precision.  fixes #5098.  [ruby-dev:44210]

	* ext/bigdecimal/lib/bigdecimal/util.rb (Integer#to_d): added
	  for symmetry to BigDecimal() function with an Integer.
	  fixes #5098.  [ruby-dev:44210]

	* ext/bigdecimal/lib/bigdecimal/util.rb (BigDecimal#to_d): added
	  for adapting other Numeric subclasses.  [ruby-dev:44245]

	* test/bigdecimal/test_bigdecimal_util.rb: add tests for the above
	  changes.

Wed Jul 27 00:54:38 2011  Kenta Murata  <mrkn@mrkn.jp>

	* bigdecimal/bigdecimal.c (VpDup) a new function for duplicating
	  a BigDecimal.

	* bigdecimal/bigdecimal.c (BigDecimal_new): support generating a new
	  BigDecimal from another BigDecimal using BigDecimal global function
	  or constructor.  [ruby-dev:44245]

Mon Jul 25 22:24:09 2011  Hiroshi Nakamura  <nahi@ruby-lang.org>

	* backport r32666 from trunk.

	* lib/xmlrpc/client.rb: Fix possible HTTP header formatting failure by
	  'Basic' header. Long username caused the base64 String truncation in
	  HTTP header which is not allowed. See #5046.

	* test/xmlrpc/test_webrick_server.rb: test it.

Mon Jul 25 15:36:07 2011  Hiroshi Nakamura  <nahi@ruby-lang.org>

	* ext/openssl/lib/openssl/{x509.rb,ssl.rb}: Add deprecation warning
	  for openssl/{x509,ssl} usage. Users should require "openssl" instead
	  of "openssl/ssl" and "openssl/x509". Start of transition period
	  introduced by [ruby-dev:38018].

Mon Jul 25 13:50:33 2011  Hiroshi Nakamura  <nahi@ruby-lang.org>

	* backport r32662 from trunk.

	* ext/openssl/lib/openssl/x509.rb: Cosmetic change: move definition
	  introduced in r30152 to x509-internal.rb.

Mon Jul 25 13:35:20 2011  Hiroshi Nakamura  <nahi@ruby-lang.org>

	* backport r32658 from trunk.

	* ext/openssl/ossl_ssl.c (ossl_ssl_shutdown): Avoid randomly generated
	  SSLError from SSLSocket just after invoking SSLSocket#close.
	  OpenSSL's SSL_shutdown could try to send alert packet and it might
	  set SSLerr(global error stack) as the result. It causes the next
	  SSL read/write operation to fail by unrelated reason.

	  By design, we're ignoring any error at SSL_shutdown() so we clear
	  global error stack after SSL_shutdown is called. See #5039.

Sun Jul 24 20:29:53 2011  Tanaka Akira  <akr@fsij.org>

	* ext/socket/extconf.rb: refine the recvmsg test.

Sun Jul 24 20:02:31 2011  Tanaka Akira  <akr@fsij.org>

	* ext/socket/extconf.rb: fix the recvmsg test.

Sun Jul 24 08:42:51 2011  Tanaka Akira  <akr@fsij.org>

	* ext/socket/extconf.rb: test recvmsg allocates file descriptors for
	  fd passing even with MSG_PEEK.

	* ext/socket/ancdata.c: use the above test result.

Sun Jul 24 01:24:31 2011  Eric Hodel  <drbrain@segment7.net>

	* lib/rubygems/specification.rb:  Restore behavior of
	  Gem::Specification#loaded.  [Ruby 1.9 - Bug #5032]

Sun Jul 24 01:14:49 2011  NARUSE, Yui  <naruse@ruby-lang.org>

	* test/rake/test_rake_functional.rb (setup): Use __FILE__ for the base
	  directory. Current directory is not the top source directory when
	  the building process runs on other than there.

	* test/rake/test_rake_rake_test_loader.rb: ditto.

	* test/rake/test_rake_task_argument_parsing.rb
	  (test_terminal_width_using_hardcoded_80): hardcoded 80 is used
	  when app.unix? is false.

Sun Jul 24 00:42:00 2011  Kenta Murata  <mrkn@mrkn.jp>

	* configure.in: change the default compiler to gcc-4.2 if target os
	  is OS X 10.7 (Lion).

Sat Jul 23 17:06:25 2011  Tanaka Akira  <akr@fsij.org>

	* io.c (rb_update_max_fd): validate fd.

	* ext/socket/rubysocket.h (rsock_discard_cmsg_resource): add
	  msg_peek_p argument for the declaration.

	* ext/socket/ancdata.c (discard_cmsg): add msg_peek_p argument.
	  assume FreeBSD, NetBSD and MacOS X doesn't generate passed fd
	  when MSG_PEEK.
	  (rsock_discard_cmsg_resource): add msg_peek_p argument.
	  (bsock_recvmsg_internal): call rsock_discard_cmsg_resource with
	  msg_peek_p argument.

	* ext/socket/unixsocket.c (unix_recv_io): call
	  rsock_discard_cmsg_resource with msg_peek_p argument.

Sat Jul 23 14:38:28 2011  Eric Hodel  <drbrain@segment7.net>

	* test/rake*: Remove dependencies on flexmock and session gems.
	  [Ruby 1.9 - Bug #4987]

Fri Jul 22 21:46:54 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* vm_insnhelper.c (vm_call_cfunc): added volatile for a workaround
	  of cfp consistency error problem on OS X 10.7 (Lion). It's
	  suspected llvm optimization bug.
	  [Bug #5076] [ruby-dev:44185]

Fri Jul 22 21:50:16 2011  NARUSE, Yui  <naruse@ruby-lang.org>

	* lib/uri/generic.rb (WFKV_): unroll the loop of regexp.

	* lib/uri/generic.rb (URI.decode_www_form_component): ditto.

Fri Jul 22 21:49:48 2011  NARUSE, Yui  <naruse@ruby-lang.org>

	* enum.c (enum_inject): remove empty line to notify rdoc
	  Enumerable#reduce is alias. patched by milki@github.
	  https://github.com/ruby/ruby/pull/26

Fri Jul 22 21:49:28 2011  NARUSE, Yui  <naruse@ruby-lang.org>

	* lib/webrick/httprequest.rb (WEBrick::HTTPRequest#each):
	  Allow HTTP/0.9 request which doesn't has any header or body.
	  patched by Felix Jodoin. [ruby-core:38040] [Bug #5022]

Fri Jul 22 21:45:21 2011  NARUSE, Yui  <naruse@ruby-lang.org>

	* ext/dl/handle.c (dlhandle_sym): clear previous error with dlerror()
	  before calling dlsym(). [ruby-dev:44091] [Bug #5021]

Fri Jul 22 19:05:47 2011  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* parse.y (rb_enc_symname2_p): get rid of potential out-of-bound
	  access.

Fri Jul 22 13:55:59 2011  Eric Hodel  <drbrain@segment7.net>

	* lib/net/http.rb:  Net::HTTP#finish is used to manually close
	  connections.  [Ruby 1.9 - Bug #5045]

Fri Jul 22 13:51:29 2011  Eric Hodel  <drbrain@segment7.net>

	* ext/readline/readline.c:  Add examples for Readline.completion_proc=.
	  [Ruby 1.9 - Bug #5057]

Fri Jul 22 13:20:33 2011  Eric Hodel  <drbrain@segment7.net>

	* tool/rbinstall.rb (default gems):  Install executables into the fake
	  gem dir for Gem.bin_path.  [Ruby 1.9 - Bug #4485]

Fri Jul 22 13:03:12 2011  Martin Bosslet  <Martin.Bosslet@googlemail.com>

	* backport r32609 from trunk.

	* ext/openssl/ossl_hmac.c: Revert checking return type of
	  HMAC_Init_ex as it is not compatible with OpenSSL < 1.0.0.

Fri Jul 22 11:22:20 2011  Martin Bosslet  <Martin.Bosslet@googlemail.com>

	* backport r32606 from trunk.

	* ext/openssl/ossl_digest.c: Check return value of EVP_DigestInit_ex.
	* ext/openssl/ossl_hmac.c: Check return value of HMAC_Init_ex.
	  Thanks, Jared Jennings, for the patch.
	  [ Ruby 1.9 - Bug #4944 ] [ruby-core:37670]

Fri Jul 22 09:17:43 2011  Martin Bosslet  <Martin.Bosslet@googlemail.com>

	* backport r32604 from trunk.

	* ext/openssl/ossl_engine.c: Avoid double free of ENGINE reference.
	* test/openssl/test_engine.rb: Add a test for it.
	  Thanks to Ippei Obayashi for providing the patch.
	  [ Ruby 1.9 - Bug #5062 ] [ruby-dev:44173]

Fri Jul 22 06:39:34 2011  Marc-Andre Lafortune  <ruby-core@marc-andre.ca>

	* lib/csv.rb: Do not modify CSV.generate's argument [ruby-core:38356]

Thu Jul 21 20:02:11 2011  Yusuke Endoh  <mame@tsg.ne.jp>

	* thread.c (set_trace_func, thread_set_trace_func_m): reset tracing
	  state when set_trace_func hook is removed.  This is workaround patch
	  to force to reset tracing state that is broken by continuation call.
	  a patch from James M. Lawrence.  [Feature #4347] [ruby-core:34998]

	* test/ruby/test_continuation.rb (class TestContinuation): add a test
	  for above.  a patch from James M. Lawrence.

Thu Jul 21 20:59:59 2011  Tanaka Akira  <akr@fsij.org>

	* ext/socket/ancdata.c (discard_cmsg): workaround for MacOS X Lion.


Thu Jul 21 07:07:57 2011  Tanaka Akira  <akr@fsij.org>

	* backport r32579, r32581, r32587 by akr and r32588 by kazu.

	r32579:

	* io.c (rb_update_max_fd): new function.

	* internal.h (rb_update_max_fd): declare rb_update_max_fd.

	* thread_pthread.c (rb_thread_create_timer_thread): update max fd when
	  timer thread pipe is created.

	r32581:

	* io.c (UPDATE_MAXFD): removed.

	r32587:

	* include/ruby/intern.h (rb_update_max_fd): declaration moved from
	  internal.h.

	* file.c: ditto.

	* io.c: call rb_update_max_fd for each new fds.

	* process.c: ditto.

	* random.c: ditto.

	* ruby.c: ditto.

	* ext/io/console/console.c: ditto.

	* ext/openssl/ossl_bio.c: ditto.

	* ext/pty/pty.c: ditto.

	* ext/socket/init.c: ditto.

	* ext/socket/socket.c: ditto.

	* ext/socket/ancdata.c: ditto.

	* ext/socket/unixsocket.c: ditto.

	r32588:

	* io.c (rb_update_max_fd): remove parentheses. they are not in
	  macro.

Sun Jul 17 08:07:31 2011  Martin Bosslet  <Martin.Bosslet@googlemail.com>

	* backport r32563 from trunk

	* test/openssl/test_ssl_session.rb: add PEM SSL session without TLS
	  extensions. Use this as the default for the tests to ensure
	  compatibility with OpenSSL 0.9.7.
	  [ Ruby 1.9 - Bug #4961 ] [ruby-core:37726]

Sat Jul 16 17:29:20 2011  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* configure.in (RUBY_UNIVERSAL_ARCH): restore arch flag.
	  Bug #4977

Sat Jul 16 11:18:26 2011  NAKAMURA Usaku  <usa@ruby-lang.org>

	* win32/setup.mak: support to build x64-mswin64 on Windows7 (and Vista,
	  perhaps).
	  backported r32521 from trunk

Sat Jul 16 06:31:23 2011  Marc-Andre Lafortune  <ruby-core@marc-andre.ca>

	* lib/uri/common.rb (module): Remove optional parser argument to
	  Kernel#URI
	  [ruby-core:38061]

	* lib/uri/generic.rb (module): ditto

Sat Jul 16 01:15:53 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* time.c (time_dup): used rb_obj_class() instead of CLASS_OF().
	  The patch is made by Kazuki Tsujimoto. [Bug #5012] [ruby-dev:44071]

	* test/ruby/test_time.rb (TestTime#test_getlocal_dont_share_eigenclass):
	  added a new test for eigenclass of time object.

Fri Jul 15 19:11:00 2011  Kenta Murata  <mrkn@mrkn.jp>

	* bignum.c (bigsub_int): add RB_GC_GUARD.  This patch is made by
	  Makoto Kishimoto.  fixes #4223 [ruby-dev:42907]

	* bignum.c (bigadd_int): ditto.

Fri Jul 15 09:59:12 2011  Hiroshi Nakamura  <nahi@ruby-lang.org>

	* backport r32546 from trunk.

	* ext/digest/sha2/sha2.c (SHA256_Update, SHA512_Update): avoid Bus
	  Error caused by unalignment access on Sparc-Solaris (and possibly on
	  other similar environment.) This patch just do memcpy always instead
	  of checking architecture. I see no perf drop on my 64bit env. For
	  more details, see #4320.

	* test/digest/test_digest.rb: add test for unalignment access.


Thu Jul 14 12:40:07 2011  Hiroshi Nakamura  <nahi@ruby-lang.org>

	* backport r32537 from trunk.

	* ext/openssl/ossl.c (ossl_verify_cb): trap the exception from
	  verify callback of SSLContext and X509Store and make the
	  verification fail normally. Raising exception directly from callback
	  causes orphan resources in OpenSSL stack. Patched by Ippei Obayashi.
	  See #4445.

	* test/openssl/test_ssl.rb
	  (test_exception_in_verify_callback_is_ignored): test it.

Wed Jul 13 08:20:08 2011  Shota Fukumori  <sorah@tubusu.net>

	* lib/test/unit.rb(Test::Unit::Options#process_args): Fix bug.
	  Fix process_args didn't return `@option` after r30939. Backported
	  r32526 from trunk.

Mon Jul 11 23:50:39 2011  Yutaka Kanemoto  <kanemoto@ruby-lang.org>

	* time.c: can't compile time.c on AIX due to missing declaration for
	  ffs(). It is declared in strings.h on AIX. backported r32518 from
	  trunk.

Mon Jul 11 23:47:00 2011  Yutaka Kanemoto  <kanemoto@ruby-lang.org>

	* thread_pthread.c (get_stack):  need to adjust stack addr for
	  [Bug #1813] on AIX. backported r32511 from trunk.

Mon Jul 11 15:17:03 2011  NAKAMURA Usaku  <usa@ruby-lang.org>

	* numeric.c (rb_num2ull): use FIX2LONG instead of FIX2ULONG. see
	  rb_num2ulong(). fixed the problem of ObjectSpace._id2ref of IL32LLP64
	  platforms, introduced at r32433.
	  backported r32512 from trunk.

Sun Jul 10 23:58:55 2011  Yuki Sonoda (Yugui)  <yugui@yugui.jp>

	* version.h: 1.9.3 is no longer trunk.

Sun Jul 10 23:24:29 2011  Yuki Sonoda (Yugui)  <yugui@yugui.jp>

	* class.c (rb_mix_module): reverted r31873.
	  (check_mix_method_i, do_mix_method_i) reverted r31917.

	* test/ruby/test_module.rb (TestModule#test_mix_const): reverted
	  r31918.

Sun Jul 10 22:50:00 2011  Kenta Murata  <mrkn@mrkn.jp>

	* ext/bigdecimal/bigdecimal.c (rmpd_power_by_big_decimal): fix
	  precision treatment errors.

	* test/bigdecimal/test_bigdecimal.rb: add tests for the above change.
	  fix precision treatment errors.

	* ext/bigdecimal/bigdecimal.c (BigDecimal_power): precision argument
	  should be optional for its compatibility.

Sun Jul 10 22:38:09 2011  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* parse.y (var_ref): distinguish vcall from local variable
	  references.  based on a patch by Michael Edgar michael.j.edgar
	  AT dartmouth.edu.  Bug #5002

Sun Jul 10 21:51:29 2011  Koichi Sasada  <ko1@atdot.net>

	* internal.h: add comments (cautions).

Sun Jul 10 20:59:38 2011  Shota Fukumori  <sorah@tubusu.net>

	* lib/test/unit.rb: Add new class variable `@@testfile_prefix`.
	  This is for changing test name prefix. (For testing)

	* test/testunit/tests_for_parallel/ptest_first.rb: Renamed from
	  test_first.rb

	* test/testunit/tests_for_parallel/ptest_second.rb: Renamed from
	  test_second.rb

	* test/testunit/tests_for_parallel/ptest_third.rb: Renamed from
	  test_third.rb

	* test/testunit/tests_for_parallel/ptest_forth.rb: Renamed from
	  test_forth.rb

	* test/testunit/tests_for_parallel/runner.rb: Remove misc.rb

	* test/testunit/tests_for_parallel/ptest_first.rb: ditto.

	* test/testunit/tests_for_parallel/ptest_second.rb: ditto.

	* test/testunit/tests_for_parallel/ptest_third.rb: ditto.

	* test/testunit/tests_for_parallel/ptest_forth.rb: ditto.

	* test/testunit/tests_for_parallel/misc.rb: Removed because no longer
	  needed.

	* test/testunit/test_parallel.rb: Fix assertions for above.

Sun Jul 10 16:57:08 2011  Koichi Sasada  <ko1@atdot.net>

	* vm_insnhelper.c (vm_throw): check a class frame.
	  Fixes Bug #4648.
	  The patch is contributed by Kazuki Tsujimoto.

	* bootstraptest/test_proc.rb: add tests for above.

Sun Jul 10 17:28:01 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* thread_pthread.c (mutex_debug): use exit(EXIT_FAILURE) instad of
	  exit(1).
	* thread_pthread.c (add_signal_thread_list): ditto.
	* thread.c (rb_thread_call_with_gvl): ditto.
	* util.c (Bug): ditto.

Sun Jul 10 15:58:12 2011  NARUSE, Yui  <naruse@ruby-lang.org>

	* ext/json: Merge json gem 1.5.4+ (f7f78896607b6f6226cd).
	  [Bug #4700]

Sun Jul 10 16:41:32 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* vm_core.h (typedef struct rb_vm_struct): create a new
	  'inhibit_thread_creation' field.
	* thread.c (rb_thread_terminate_all): set inhibit_thread_creation.
	* thread.c (thread_s_new): don't permit to create new thread
	  if the VM is under destruction. Otherwise evil finalizer code
	  can make SEGV. [Bug #4992][ruby-core:37858]

	* bootstraptest/test_objectspace.rb: new test for this fix.

Sun Jul 10 16:06:16 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* signal.c (sigsegv): use abort() instead of exit() when nested
	  SEGV was happen. Because unnested SEGV use abort().
	  [Bug #5013][ruby-dev:44078]

Sun Jul 10 15:30:00 2011  Kenta Murata  <mrkn@mrkn.jp>

	* load.c (rb_f_autoload): prevent to autoload for singleton
	  classes.  fixes [Bug #4886] [ruby-dev:43816]

	* bootstraptest/test_autoload.rb: add tests for the above change.

Sun Jul 10 15:09:17 2011  Shota Fukumori  <sorah@tubusu.net>

	* lib/test/unit/assertions.rb: Import documentation patch by Justin
	  Collins. [ruby-core:37225] [Feature #4903]

Sun Jul 10 14:57:36 2011  Tadayoshi Funaba  <tadf@dotrb.org>

	* ext/date/date_core.c: canonicalizes nth and sf.

Sun Jul 10 14:13:50 2011  Koichi Sasada  <ko1@atdot.net>

	* internal.h (rb_thread_call_with_gvl, rb_thread_call_without_gvl):
	  make them visible as experimental C APIs.  fixes Feature #4328.

Sun Jul 10 12:18:00 2011  Kenta Murata  <mrkn@mrkn.jp>

	* ext/bigdecimal/bigdecimal.c (BigDecimal_power): support non-integral
	  exponent.  fixes [Bug #3271]

	* ext/bigdecimal/bigdecimal.c (rmpd_power_by_big_decimal): ditto.

	* ext/bigdecimal/bigdecimal.c (BigDecimal_power_op): add a function to
	  only use for "**" operator.

	* test/bigdecimal/test_bigdecimal.rb: add a bunch of tests for the
	  above changes.

	* ext/bigdecimal/bigdecimal.c (is_integer): add an utility function.

	* ext/bigdecimal/bigdecimal.c (is_negative): ditto.

	* ext/bigdecimal/bigdecimal.c (is_positive): ditto.

	* ext/bigdecimal/bigdecimal.c (is_zero): ditto.

	* ext/bigdecimal/bigdecimal.c (is_one): ditto.

	* ext/bigdecimal/bigdecimal.c (is_even): ditto.

Sun Jul 10 12:08:39 2011  Yusuke Endoh  <mame@tsg.ne.jp>

	* compile.c (when_vals): when a string literal is written on when
	  clause, skip string creation to make it faster.  [ruby-dev:44068]
	  [Feature #5000]

Sun Jul 10 11:35:29 2011  Yusuke Endoh  <mame@tsg.ne.jp>

	* parse.y (reduce_nodes_gen): NODE_RETURN in rescue body must not be
	  reduced when there is an else clause.  This caused bizarre behavior
	  in [Bug #4473] [ruby-core:35629] [ruby-core:37884].

Sun Jul 10 09:46:14 2011  Masaya Tarui  <tarui@ruby-lnag.org>

	* range.c (range_max): fix behavior with excluded end value.
	  [Bug #4591]

Sun Jul 10 09:13:18 2011  Eric Hodel  <drbrain@segment7.net>

	* NEWS:  Fix RubyGems version.  [Ruby 1.9 - Bug #5004]

Sat Jul  9 20:01:59 2011  Tadayoshi Funaba  <tadf@dotrb.org>

	* internal.h: rb_rational_reciprocal is defined in rational.c.

Sat Jul  9 19:48:31 2011  Tadayoshi Funaba  <tadf@dotrb.org>

	* internal.h: added declarations.
	* complex.c: followed the above change.

Sat Jul  9 17:24:41 2011  Tadayoshi Funaba  <tadf@dotrb.org>

	* NEWS: bigdecimal is not a builtin.

Sat Jul  9 17:17:53 2011  Tadayoshi Funaba  <tadf@dotrb.org>

	* ext/date/date_core.c: some improvements for performance.

Sat Jul  9 16:56:01 2011  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* atomic.h (ATOMIC_OR): _InterlockedOr is unavailable in VC6.

	* numeric.c (ULLONG_MAX): fallback definition.

Sat Jul  9 15:59:19 2011  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* win32/win32.c (rb_w32_{read,write}): should be signed.
	  Bug #5001

Sat Jul  9 14:02:20 2011  Takeyuki FUJIOKA  <xibbar@ruby-lang.org>

	* lib/cgi/core.rb: fix multipart form parsing bug. [Bug #3866]

Sat Jul  9 11:41:03 2011  Marc-Andre Lafortune  <ruby-core@marc-andre.ca>

	* lib/matrix.rb: Add Vector#normalize [ruby-dev:43829]

Sat Jul  9 09:25:06 2011  Eric Hodel  <drbrain@segment7.net>

	* enumerator.c:  Remove "enumeration sequenced by".
	  [Ruby 1.9 - Bug #4757]

Sat Jul  9 09:14:56 2011  Eric Hodel  <drbrain@segment7.net>

	* io.c:  Note that methods other than IO#gets may increase IO#lineno.
	  [Ruby 1.9 - Bug #4902]

Sat Jul  9 08:39:39 2011  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* common.mk (RUN_OPT): disable gems.

Sat Jul  9 08:37:05 2011  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* io.c (rb_io_close): close(2) on a fd which is being read by
	  another thread causes deadlock on Mac OS X 10.5

Fri Jul  8 21:20:39 2011  NARUSE, Yui  <naruse@ruby-lang.org>

	* addr2line.c: use USE_ELF instead of __ELF__ because Solaris
	  doesn't define it. USE_ELF is already provided by configure.
	  patched by Naohisa Goto. [ruby-dev:44066] [Bug #4998]

	* addr2line.h: ditto.

	* vm_dump.c: ditto.

Fri Jul  8 16:40:38 2011  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ext/json/parser/parser.rl (convert_encoding): should not modify
	  the argument.

	* ext/json/parser/parser.rl (convert_encoding): no needs to use
	  force_encoding.

Fri Jul  8 15:53:31 2011  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* error.c (rb_bug): get rid of segfault after all threads
	  disposed.

Fri Jul  8 15:01:06 2011  NAKAMURA Usaku  <usa@ruby-lang.org>

	* ext/openssl/ossl.h: include openssl/e_os2.h before checking the
	  definition of OPENSSL_SYS_WIN32.

Fri Jul  8 14:40:39 2011  NAKAMURA Usaku  <usa@ruby-lang.org>

	* win32/win32.c (wunlink): reverted a part of r32426. it was mistakenly
	  mixed.

Fri Jul  8 14:29:47 2011  Narihiro Nakamura  <authornari@gmail.com>

	* configure.in: can't subtract void *.

Fri Jul  8 14:33:26 2011  NAKAMURA Usaku  <usa@ruby-lang.org>

	* win32/Makefile.sub (config.h): define GC_MARK_STACKFRAME_WORD.
	  fixed build problem of r32438.  the value (30) is temporary value.
	  maybe it's enough by 20~24 according to my observation.

Fri Jul  8 13:47:39 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* thread.c (rb_mutex_unlock_all): folded into
	  rb_threadptr_unlock_all_locking_mutexes.
	* thread.c (rb_threadptr_unlock_all_locking_mutexes) ditto.

Fri Jul  8 13:36:02 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* thread.c (thread_unlock_all_locking_mutexes): rename to
	  rb_threadptr_unlock_all_locking_mutexes and remove static.
	* vm_core.h: add rb_threadptr_unlock_all_locking_mutexes declaration.
	* thread.c (thread_start_func_2): adjust the above rename.

	* eval.c (ruby_cleanup): call rb_threadptr_unlock_all_locking_mutexes
	  again after finalizer. [Bug #4988] [ruby-dev:44049]

Fri Jul  8 13:06:09 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* cont.c (FIBER_MACHINE_STACK_ALLOCATION_SIZE): Fiber stack size
	  don't need to keep multiple number of sizeof(VALUE).

Fri Jul  8 11:39:12 2011  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* common.mk (sudo-precheck): true command is not standard on
	  Windows.

Fri Jul  8 10:39:52 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* thread_pthread.c (gvl_destroy): fix cond_t leak.

Fri Jul  8 09:17:59 2011  Eric Hodel  <drbrain@segment7.net>

	* gc.c:  Improve documentation

Thu Jul  7 23:35:31 2011  Narihiro Nakamura  <authornari@gmail.com>

	* gc.c: change water_mark value that may call
	  gc_mark(lev <= GC_LEVEL_MAX) in gc_mark().
	  In ruby_stack_check(), water_mark is a value that may call some
	  C function. Fixes Bug #3781

	* configure.in: define GC_MARK_STACKFRAME_WORD that approximate
	  size of gc_mark() and gc_mark_children() stackframes.

Thu Jul  7 17:55:05 2011  NAKAMURA Usaku  <usa@ruby-lang.org>

	* test/testunit/test_parallel.rb (TestParallelWorker#teardown): wait
	  the child process even if the communication pipe is broken.

Thu Jul  7 15:44:42 2011  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* encoding.c (rb_enc_set_index, rb_enc_associate_index): should
	  check if frozen.

	* parse.y (rb_intern3), ruby.c (process_options, ruby_script):
	  defer freezing after associating encodings.

Thu Jul  7 15:16:51 2011  NARUSE, Yui  <naruse@ruby-lang.org>

	* numeric.c (rb_num2ull): use own switch sentence.
	  Current implementation can't convert 18446744073709551615.

Thu Jul  7 06:56:15 2011  NARUSE, Yui  <naruse@ruby-lang.org>

	* cont.c (FIBER_STACK_FLAGS): workaround fix for r32420 on FreeBSD.

Thu Jul  7 06:46:12 2011  Eric Hodel  <drbrain@segment7.net>

	* benchmark/driver.rb:  Add difference column to report that averages
	  across all runs of a benchmark.  [Ruby 1.9 - Feature #4982]

Thu Jul  7 06:19:38 2011  Eric Hodel  <drbrain@segment7.net>

	* lib/rubygems.rb:  Reduce requires to improve `make benchmark`.
	  [#4962]
	* lib/rubygems/specification.rb:  Delay initialization of rubygems
	  until require is called.

Thu Jul  7 04:31:26 2011  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* parse.y (arg): rescue_mod is in inverse order from other
	  modifiers.  patched by michael.j.edgar AT dartmouth.edu at
	  [ruby-core:36248].  fixed #4716.

Thu Jul  7 00:40:16 2011  NAKAMURA Usaku  <usa@ruby-lang.org>

	* win32/win32.c (kill): check that the process exited or not before
	  terminating it. [Bug #4943]

Wed Jul  6 23:13:19 2011  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* parse.y (opt_call_args): allow trailing comma after assoc
	  argument e.g. 'foo(bar:1,)'.  fixed #3456

Wed Jul  6 22:11:12 2011  Shota Fukumori  <sorah@tubusu.net>

	* test/cgi/test_cgi_header.rb(test_cgi_header_nph): Validate date in
	  "Date:" header

Wed Jul  6 21:29:33 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* cont.c (fiber_machine_stack_alloc): cleanup pointer arithmetic.
	  "size/sizeof(VALUE)" is ugly and easy confusing.
	* cont.c (fiber_initialize_machine_stack_context): ditto.

Wed Jul  6 21:24:53 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* cont.c (fiber_machine_stack_alloc): fix mprotect misuse. A stack
	  guard page should have PROT_NONE.
	* cont.c (fiber_initialize_machine_stack_context):
	  th->machine_stack_maxsize shouldn't be included guard pages size.
	  [Bug #4983][ruby-dev:44043]

Wed Jul  6 21:23:38 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* cont.c (fiber_machine_stack_alloc): use MAP_STACK if it's provided.

Wed Jul  6 21:22:16 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* cont.c (fiber_machine_stack_alloc): use MAP_FAILED instead of -1.

Wed Jul  6 21:21:05 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* cont.c (fiber_machine_stack_alloc): remove unnecessary cast.

Wed Jul  6 18:10:13 2011  Shota Fukumori  <sorah@tubusu.net>

	* test/cgi/test_cgi_header.rb(test_cgi_header_nph): Adding space after
	  comma.

	* test/cgi/test_cgi_header.rb(test_cgi_header_nph): Remove variable
	  `now`. Suppress warning.

Wed Jul  6 12:18:09 2011  Shota Fukumori  <sorah@tubusu.net>

	* test/cgi/test_cgi_header.rb(test_cgi_header_nph): Fix bug depends to
	  time. The test fails if time past 1 second in line 136-145

Tue Jul  5 15:28:04 2011  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* parse.y (parser_here_document): should dispatch heredoc_end
	  scanner event on an empty here document.  fixed Bug#4543.

Tue Jul  5 13:49:26 2011  Yusuke Endoh  <mame@tsg.ne.jp>

	* addr2line.c: fix r32407 to check HAVE_ALLOCA_H.

Tue Jul  5 14:05:43 2011  NARUSE, Yui  <naruse@ruby-lang.org>

	* lib/webrick/httpauth/digestauth.rb (_authenticate):
	  Literal texts in HTTP ABNF is case-insensitive (RFC2616 2.1),
	  and a sample implementation in RFC2617 also ignores the case
	  of algorithms. So now this ignores those cases.
	  [ruby-dev:43965] [Feature #4936]

	* lib/webrick/httpauth/digestauth.rb (initialize):
	  Because of above, opera_hack is useless and removed.

Tue Jul  5 01:30:01 2011  Yusuke Endoh  <mame@tsg.ne.jp>

	* thread_pthread.c (native_sleep): cut the waiting time up to
	  100,000,000 because Solaris cond_timedwait() return EINVAL if an
	  argument is greater than current_time + 100,000,000.  This is
	  considered as a kind of spurious wakeup.  The caller to native_sleep
	  should care about spurious wakeup.

Tue Jul  5 01:24:26 2011  Yusuke Endoh  <mame@tsg.ne.jp>

	* cont.c: disable FIBER_USE_NATIVE on Solaris because resuming any
	  Fiber caused SEGV.  I haven't follow up the issue deeply, but it
	  works when disabling the feature.

Tue Jul  5 01:22:46 2011  Yusuke Endoh  <mame@tsg.ne.jp>

	* addr2line.c: include <alloca.h> to fix a build issue on Solaris.

Tue Jul  5 00:49:05 2011  CHIKANAGA Tomoyuki  <nagachika00@gmail.com>

	* ext/coverage/coverage.c: resurrect r32071 + add GC guard for
	  rb_coverages. [ruby-core:37352] [Bug #4927]
	  [ruby-core:36539] [Feature #4796]

	* test/coverage/test_coverage.rb resurrect r32071.

Mon Jul  4 22:24:46 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* thread_pthread.c (get_stack): For NetBSD/FreeBSD, use
	  pthread_attr_getstack() if possible. and, remove an assumption
	  of stack growing direction.

Mon Jul  4 20:42:31 2011  Yusuke Endoh  <mame@tsg.ne.jp>

	* ext/coverage/coverage.c: revert r32071.  The commit caused SEGV on
	  some minor nonfree OS.  I have no means of debugging the bug.  My
	  personal opinion is that such OS should be unsupported unless there
	  is an active maintainer.  [ruby-core:37352]

	* test/coverage/test_coverage.rb: ditto.

Mon Jul  4 07:14:12 2011  NARUSE, Yui  <naruse@ruby-lang.org>

	* thread_pthread.c (get_stack): the return address of get_stack
	  must be the highest address of the current thread's stack.

Mon Jul  4 06:37:22 2011  Koichi Sasada  <ko1@atdot.net>

	* include/ruby/intern.h, thread_pthread.c (rb_reserved_fd_p,
	  RB_RESERVED_FD_P): added.  This C API is to limit to access
	  fds which are used by RubyVM internal.  In this version of
	  CRuby, return 1 if fd is communication pipe.
	  If your application needs to close all file descriptors to
	  present resource leak, skip internal fds using this C API.
	  We also define a macro RB_RESERVED_FD_P(fd).  So you can write
	    #ifndef RB_RESERVED_FD_P
	    #define RB_RESERVED_FD_P(fd) 0
	    #endif
	  for Ruby 1.9.2 or previous version to write compatible extensions.
	  See [ruby-core:37727]

	* thread_win32.c (rb_reserved_fd_p): added (return 0 for any fds).

	* io.c (rb_io_initialize): raise ArgumentError if given fd is reserved by Ruby.

Sun Jul  3 23:43:56 2011  Yuki Sonoda (Yugui)  <yugui@yugui.jp>

	* ext/extmk.rb (extmake): suppresses outputs from extconf.rb.
	  (extmake) warns a failure in extconf.rb.

Sun Jul  3 13:44:51 2011  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* array.c (ary_reject_bang): should not remove elements which are
	  not yielded.  [Bug #2545]

Sun Jul  3 06:10:26 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* thread_pthread.c (get_stack): pthread_attr_getstack() doesn't
	  return stack start address, but stack base address. Thus,
	  we need to add stack size for getting stack start address.
	  And, we don't have to decrease guard size twice.
	* thread_pthread.c (thread_start_func_1): don't use inaccurate
	  stack start guess if native_thread_init_stack() can be used.
	  [Bug #1813] [ruby-core:24540]

Sun Jul  3 04:50:08 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* thread_pthread.c (get_stack): add to a care of guard page on Mac
	  OS X. [Bug #1813] [ruby-core:24540]
	* signal.c (ruby_signal): SIGBUS use alternative stack too.
	* signal.c (sigbus): On Mac, thread stack overflow makes SIGBUS
	  instead of SIGSEGV. thus, added stackoverflow check.
	* signal.c (default_handler): get rid of compilation warning.
	* signal.c (Init_signal): ditto.

Sat Jul 02 08:59:20 2011  Martin Bosslet  <Martin.Bosslet@googlemail.com>

	* test/openssl/test_ocsp.rb
	* test/openssl/test_x509_cert.rb: Perform SHA-256 tests only if
	  supported by the available OpenSSL version. Versions < 0.9.8 don't
	  support it. [ruby-core:37724]

Sat Jul  2 07:17:45 2011  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* array.c (rb_ary_reject_bang, rb_ary_delete_if): rejected
	  elements should be removed.  fixed [Bug #2545]

Sat Jul  2 01:57:00 2011  Kenta Murata  <mrkn@mrkn.jp>

	* NEWS: remove a description of Kernel#respond_to? because it has
	  been reverted at revision 28564.

Sat Jul  2 00:58:00 2011  Kenta Murata  <mrkn@mrkn.jp>

	* NEWS: describe a change of multiplication of Bignum.

Fri Jul  1 18:52:31 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* benchmark/bm_app_erb.rb: increase loop count. too short
	  measurement time makes less accuracy.
	* benchmark/bm_app_factorial.rb: ditto.
	* benchmark/bm_app_mandelbrot.rb: ditto.
	* benchmark/bm_app_strconcat.rb: ditto.

	* benchmark/bm_io_file_create.rb: ditto.
	* benchmark/bm_io_file_read.rb: ditto.
	* benchmark/bm_io_file_write.rb: ditto.

	* benchmark/bm_so_concatenate.rb: ditto.
	* benchmark/bm_so_lists.rb: ditto.
	* benchmark/bm_so_matrix.rb: ditto.
	* benchmark/bm_so_random.rb: ditto.
	* benchmark/bm_so_sieve.rb: ditto.

	* benchmark/bm_vm_thread_mutex1.rb: ditto.
	* benchmark/bm_vm_thread_mutex2.rb: ditto.
	* benchmark/bm_vm_thread_mutex3.rb: ditto.

	* benchmark/bm_vm1_block.rb: cleanup.
	* benchmark/bm_vm1_const.rb: cleanup.
	* benchmark/bm_vm1_ensure.rb: cleanup.
	* benchmark/bm_vm1_ivar.rb: cleanup.
	* benchmark/bm_vm1_length.rb: cleanup.
	* benchmark/bm_vm1_neq.rb: cleanup.
	* benchmark/bm_vm1_not.rb: cleanup.
	* benchmark/bm_vm1_rescue.rb: cleanup.
	* benchmark/bm_vm1_simplereturn.rb: cleanup.
	* benchmark/bm_vm1_swap.rb: cleanup.

	* benchmark/bm_vm2_array.rb: cleanup.
	* benchmark/bm_vm2_case.rb: cleanup.
	* benchmark/bm_vm2_defined_method.rb: cleanup.
	* benchmark/bm_vm2_eval.rb: cleanup.
	* benchmark/bm_vm2_method.rb: cleanup.
	* benchmark/bm_vm2_mutex.rb: cleanup.
	* benchmark/bm_vm2_poly_method.rb: cleanup.
	* benchmark/bm_vm2_poly_method_ov.rb: cleanup.
	* benchmark/bm_vm2_proc.rb: cleanup.
	* benchmark/bm_vm2_regexp.rb: cleanup.
	* benchmark/bm_vm2_send.rb: cleanup.
	* benchmark/bm_vm2_super.rb: cleanup.
	* benchmark/bm_vm2_unif1.rb: cleanup.
	* benchmark/bm_vm2_zsuper.rb: cleanup.

	* benchmark/bm_vm_thread_alive_check1.rb: cleanup.

Fri Jul  1 15:23:00 2011  Marc-Andre Lafortune  <ruby-core@marc-andre.ca>

	* lib/matrix: Add LUP decomposition

Fri Jul  1 15:21:14 2011  Marc-Andre Lafortune  <ruby-core@marc-andre.ca>

	* lib/matrix.rb: Allow non integer exponents for Matrix#**

Fri Jul  1 15:13:25 2011  Marc-Andre Lafortune  <ruby-core@marc-andre.ca>

	* lib/matrix: Add Eigenvalue Decomposition

Fri Jul  1 15:10:22 2011  Marc-Andre Lafortune  <ruby-core@marc-andre.ca>

	* lib/matrix: Add Matrix#round

Fri Jul  1 11:41:12 2011  NARUSE, Yui  <naruse@ruby-lang.org>

	* string.c (tr_trans): free heap ptr when the str is not embedded.
	  patched by Eric Wong. [Bug #4956] [ruby-core:37708]

Fri Jul  1 11:07:43 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* thread.c (do_select): fix memory leak.
	  Patch by Eric Wong. Thank you! [Bug #4953] [ruby-core:37702]

Fri Jul  1 08:21:28 2011  Koichi Sasada  <ko1@atdot.net>

	* vm_insnhelper.c (vm_getivar): check vm state version
	  to invalidate inline cache (ivar index).
	  fixes Bug #4926.

	* vm_insnhelper.c (vm_setivar): ditto.

Fri Jul  1 08:03:15 2011  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* error.c, thread_pthread.c (WRITE_CONST): suppress warnings
	  `ignoring return value'.

Fri Jul  1 06:41:36 2011  Koichi Sasada  <ko1@atdot.net>

	* thread.c (rb_threadptr_check_signal): only wake up main thread.

	* thread.c (rb_threadptr_execute_interrupts_common): check signal
	  delivery if it is main thread.
	  fixes [ruby-dev:44005] [Ruby 1.9 - Bug #4950]

	* bootstraptest/test_fork.rb: add a test for above.

	* signal.c (rb_get_next_signal): skip if signal_buff is empty.
	  (check signal_buff.size first)

	* vm_core.h: remove unused variable rb_thread_t::exec_signal.

	* thread.c (rb_thread_check_trap_pending): check
	  rb_signal_buff_size() because rb_thread_t::exec_signal
	  is no longer available.

Fri Jul  1 03:28:25 2011  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* class.c (Init_class_hierarchy): should name BasicObject
	  explicitly.

	* variable.c (rb_const_defined_0): should not check for
	  superclasses as const_get.

Fri Jul  1 03:24:03 2011  Tadayoshi Funaba  <tadf@dotrb.org>

	* ext/date/date_core.c: mathn is still alive (should die soon).

Thu Jun 30 23:50:00 2011  Kenta Murata  <mrkn@mrkn.jp>

	* misc/ruby-mode.el (ruby-indent-beg-re): Fix broken regular
	  expression.  Fixes #4546

Thu Jun 30 23:43:30 2011  Martin Bosslet  <Martin.Bosslet@googlemail.com>

	* ext/openssl/ossl.c/.h: Added ossl_x509_name_sk2ary.
	* ext/openssl/ossl.c: Replaced ossl_x509_ary2k by generic macro to
	  simplify future conversions.
	* ext/openssl/ossl_ssl.c: Implement SSLSocket#client_ca.
	* test/openssl/test_ssl.rb: Add test for SSLSocket#client_ca.
	  Thanks to Ippei Obayashi for providing the patch!
	  [ Ruby 1.9 - Feature #4481 ] [ruby-core:35461]

Thu Jun 30 22:38:58 2011  Koichi Sasada  <ko1@atdot.net>

	* benchmark/bm_vm2_defined_method.rb: added to measure performance of
	  bmethod (method defined by define_method()).

Thu Jun 30 22:17:04 2011  Koichi Sasada  <ko1@atdot.net>

	* vm_insnhelper.c (vm_call_bmethod): fix to hook call/return event
	  for methods defined by define_method().  fixes Bug #4613.

	* thread.c (call_trace_proc): Fix to skip if class is not given (0).
	  Note that ID and Class object are passed for call/return event
	  if the called method was defined by define_method().
	  If you are author of tracer/profiler/debugger, this may be an
	  important change.  You should check passed class as zero or
	  non-zero instead of checking the event type.

	* test/ruby/test_settracefunc.rb: add a test for above.

Thu Jun 30 21:18:35 2011  Yutaka Kanemoto  <kanemoto@ruby-lang.org>

	* configure.in: Add warnflags for XL/C on AIX during configure
	  to avoid [Bug #3971]. See [ruby-core:32859]

Thu Jun 30 21:16:04 2011  Tadayoshi Funaba  <tadf@dotrb.org>

	* ext/date/date_core.c (m_ajd): refers a constant.

Thu Jun 30 20:54:25 2011  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	  * ext/io/console/io-console.gemspec: spin-off gem for 1.9.2.

Thu Jun 30 20:36:23 2011  Tadayoshi Funaba  <tadf@dotrb.org>

	* ext/date/date_core.c: trivial changes.

Thu Jun 30 20:12:36 2011  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* test/ruby/test_module.rb: tests for [Bug #3422] and [Bug #3423].

Thu Jun 30 20:03:39 2011  Tadayoshi Funaba  <tadf@dotrb.org>

	* ext/date/date_core.c: modified doc.

Thu Jun 30 19:09:19 2011  Koichi Sasada  <ko1@atdot.net>

	* thread_pthread.c (thread_timer): ignore unknown errno.
	  (we observed that select(2) was canceled by errno=514 on
	  boron == Linux/Xen environment)

Thu Jun 30 17:33:25 2011  Koichi Sasada  <ko1@atdot.net>

	* ext/objspace/objspace.c (ObjectSpace.count_tdata_objects):
	  Fix rdoc.  Fixes Bug #3892.

	* ext/objspace/objspace.c (ObjectSpace.count_tdata_objects):
	  Change key type if the klass of a object is zero (internal object).
	  Read rdoc for details.

	* internal.h: export rb_objspace_data_type_name().

Thu Jun 30 17:25:08 2011  Koichi Sasada  <ko1@atdot.net>

	* thread_pthread.c (ping_signal_thread_list, thread_timer):
	  fix to keep polling state if there are any ping-tasks.

Thu Jun 30 12:25:34 2011  Koichi Sasada  <ko1@atdot.net>

	* thread_pthread.c (rb_thread_create_timer_thread): allocate
	  machine stack for the timer thread at least 12KB.  FreeBSD 8.2
	  AMD64 causes machine stack overflow (SIGSEGV) only with
	  PTHREAD_STACK_MIN (maybe defined as 2KB).

Thu Jun 30 09:36:37 2011  Eric Hodel  <drbrain@segment7.net>

	* lib/weakref.rb:  Attach documentation to WeakRef and add missing
	  documentation

Thu Jun 30 09:30:14 2011  Eric Hodel  <drbrain@segment7.net>

	* lib/yaml.rb:  Document toplevel YAML and YAML::ENGINE to describe
	  Psych vs Syck engines.

Thu Jun 30 09:21:52 2011  Eric Hodel  <drbrain@segment7.net>

	* lib/cmath.rb:  Hide handle_no_method_error from RDoc.
	* error.c:  Document or hide undocumented error classes.

Thu Jun 30 07:49:04 2011  Eric Hodel  <drbrain@segment7.net>

	* hash.c:  Document ENV

Thu Jun 30 06:37:43 2011  Nobuyoshi Nakada  <nobu@ruby-lang.org>

	* ruby.c (ruby_init_loadpath_safe): ensure RUBYLIB_PREFIX stored
	  before RUBYLIB, even if MANGLED_PATH is enabled.  fixed #1679.
	  MANGLED_PATH is disabled by the default and will be removed
	  completely in the future.

Thu Jun 30 06:32:21 2011  Eric Hodel  <drbrain@segment7.net>

	* lib/drb/drb.rb:  Hide deprecated toplevel DRb constants.

Thu Jun 30 06:17:02 2011  NARUSE, Yui  <naruse@ruby-lang.org>

	* lib/cmath.rb (CMath.log): second argument: b can be nil.

Thu Jun 30 06:23:28 2011  Eric Hodel  <drbrain@segment7.net>

	* thread.c (ruby_thread_s_pass):  Fix typo.

Thu Jun 30 06:16:53 2011  Eric Hodel  <drbrain@segment7.net>

	* lib/rdoc:  Update to RDoc 3.8 which contains fixes for documentation
	  in trunk.

Thu Jun 30 02:53:26 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* thread.c (rb_threadptr_execute_interrupts_common): remove
	  meaningless native_thread_yield(). It never close a race.

Thu Jun 30 02:41:47 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* thread.c (rb_thread_schedule_limits): minor optimization.
	  eliminate machine context saving when running time is enough small.

Thu Jun 30 02:28:11 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* thread.c (rb_thread_schedule_rec): move interrupt_flag check to
	  rb_thread_schedule().
	  And also rename to rb_thread_schedule_limits() and remove
	  sched_depth argument. It's no longer called recursive.
	* thread.c (rb_thread_schedule): add to check interrupt_flag as
	  above explained.

	* thread.c (rb_threadptr_execute_interrupts_rec): rename to
	  rb_threadptr_execute_interrupts_common() and remove sched_depth
	  argument. It's no longer called recursive.

	* thread.c (rb_thread_sleep): adapt the renaming.
	* thread.c (rb_threadptr_execute_interrupts): ditto.
	* thread.c (rb_thread_execute_interrupts): ditto.

Thu Jun 30 01:31:33 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* thread.c (thread_s_pass): change RDoc description and remove
	  a sample code. The actual implementation never behave as explained by
	  an example. It's a documentation bug.

Thu Jun 30 00:54:33 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* thread.c (rb_thread_stop): change RDoc sample code. The old
	  example is buggy and may cause deadlock. The patch is
	  suggested by Heesob Park <phasis@gmail.com>. Thank you!
	  [Bug #3606][ruby-core:31454]

Thu Jun 30 00:49:53 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* thread.c (rb_thread_wakeup): change RDoc sample code. The old
	  example is buggy and may not display anything by a race.
	  The patch is suggested by Heesob Park <phasis@gmail.com>.
	  Thank you! [Bug #3606][ruby-core:31454]

Thu Jun 30 00:43:33 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* thread.c (rb_thread_run): change RDoc. The old example is buggy
	  and may cause deadlock. The patch is suggested by Heesob Park
	  <phasis@gmail.com>. Thank you! [Bug #3606][ruby-core:31454]

Thu Jun 30 00:30:15 2011  Keiju Ishitsuka  <keiju@ishitsuka.com>

	* lib/cmath.rb: make same exception for Math. fix [Bug #3137].

Thu Jun 30 00:03:20 2011  Keiju Ishitsuka  <keiju@ishitsuka.com>

	* lib/irb/completion.rb: complement correctly string literal. fix
	  [Bug #1145].

Wed Jun 29 23:42:51 2011  Tadayoshi Funaba  <tadf@dotrb.org>

	* ext/date/date_core.c: avoided using timev.
	* ext/date/date_strftime.c: ditto.
	* ext/date/date_tmx.h: ditto.

Wed Jun 29 23:17:57 2011  WATANABE Hirofumi  <eban@ruby-lang.org>

	* ext/openssl/ossl.h (OPENSSL_SYS_WIN32): support for mingw(msys).

Wed Jun 29 23:09:14 2011  WATANABE Hirofumi  <eban@ruby-lang.org>

	* ext/tk/extconf.rb (intptr_t, uintptr_t): support for the latest ActiveTcl with mingw.

Wed Jun 29 22:49:10 2011  Keiju Ishitsuka  <keiju@ishitsuka.com>

	* lib/irb/cmd/help.rb: support RDoc 3.7. fix [Bug #3760].

Wed Jun 29 22:04:14 2011  CHIKANAGA Tomoyuki  <nagachika00@gmail.com>

	* lib/tracer.rb: Tracer.on only if required by -r command-line option.
	  and consider --disable-gems option.
	* test/test_tracer.rb: add tests for it.

Wed Jun 29 13:55:36 2011  Yukihiro Matsumoto  <matz@ruby-lang.org>

	* variable.c (rb_const_get_0): should not look for superclasses if
	  the second optional argument is given for #const_get().
	  fix [Bug #3422] [Bug #3423]

Wed Jun 29 12:07:27 2011  Eric Hodel  <drbrain@segment7.net>

	* math.c:  Attach documentation for Math.
	* object.c:  Document NIL, TRUE, FALSE.
	* io.c:  Improve grammar in ARGF comment.  Document STDIN/OUT/ERR.
	  Document ARGF global constant.
	* lib/rake:  Hide deprecated toplevel constants from RDoc (import from
	  rake trunk).
	* lib/thwait.rb:  Document ThWait.
	* lib/mathn.rb:  Hide Math redefinition from RDoc
	* lib/sync.rb:  Add a basic comment for Sync_m, Synchronizer_m, Sync,
	  Synchronizer.
	* parse.y:  Document SCRIPT_LINES__.
	* hash.c:  Document ENV class and global constant.
	* vm.c:  Document TOPLEVEL_BINDING.
	* version.c:  Document RUBY_* constants.
	* ruby.c:  Document DATA and ARGV.

Wed Jun 29 10:13:12 2011  Marc-Andre Lafortune  <ruby-core@marc-andre.ca>

	* lib/matrix.rb: Matrix.zero can build rectangular matrices.
	  Vector#r should be called #magnitude

Wed Jun 29 10:11:08 2011  Marc-Andre Lafortune  <ruby-core@marc-andre.ca>

	* lib/matrix.rb: Add Matrix#diagonal?, hermitian?, normal?,
	  orthogonal?
	  permutation?, symmetric?, {lower|upper}triangular?, unitary?, zero?

Wed Jun 29 10:09:35 2011  Marc-Andre Lafortune  <ruby-core@marc-andre.ca>

	* lib/matrix.rb: Specialize Matrix#find_index to return [row, col]
	  and accept the same optional argument as #each

Wed Jun 29 10:07:32 2011  Marc-Andre Lafortune  <ruby-core@marc-andre.ca>

	* lib/matrix.rb: Matrix#each{_with_index} can iterate over a subset
	  of the Matrix

Wed Jun 29 06:21:02 2011  Koichi Sasada  <ko1@atdot.net>

	* thread_pthread.c (native_stop_timer_thread): skip to close
	  communication pipe to avoid timing bug (process termination timing).
	  The communication pipe will closed by OS.

Wed Jun 29 06:09:54 2011  Koichi Sasada  <ko1@atdot.net>

	* error.c (rb_async_bug_errno): async-safe bug report function.
	  In timer thread, signal handler should use it.
	  The patch is contributed by Eric Wong <normalperson@yhbt.net>.
	  Refs: [ruby-core:37644] and [ruby-core:37647]

	* thread_pthread.c: use rb_async_bug_errno().
	  And replace all fprintf() to write().

	* internal.h (rb_async_bug_errno): add decl. of above func.

Tue Jun 28 23:46:08 2011  Keiju Ishitsuka  <keiju@ishitsuka.com>

	* lib/tracer.rb: count only non-internal libraries in stack trace,
	  ignoring custom_require.

Tue Jun 28 21:44:58 2011  Keiju Ishitsuka  <keiju@ishitsuka.com>

	* lib/irb/ruby-lex.rb: recognize '\char' in ruby statement.

Tue Jun 28 20:39:29 2011  Hiroshi Nakamura  <nahi@ruby-lang.org>

	* lib/debug.rb (var_list): Command 'var *' did not work on 1.9(!).
	  global_variables, local_variables, and instance_variables returns
	  Symbols from 1.9 and need to stringify before evaling it.
	  See #4931.

Tue Jun 28 19:23:01 2011  KOSAKI Motohiro  <kosaki.motohiro@gmail.com>

	* signal.c: Now, USE_TRAP_SIGMASK depend on HAVE_PTHREAD_SIGMASK.
	  The code have already depended on pthread_sigmask since r27464.

Tue Jun 28 15:09:21 2011  NARUSE, Yui  <naruse@ruby-lang.org>

	* lib/benchmark.rb: merge eregon/benchmark.
	  https://github.com/eregon/ruby/tree/benchmark
	  patched by Benoit Daloze. [ruby-core:37593] [Bug #4940]

	* lib/benchmark (Benchmark#bmbm): bmbm should be consistent with bm
	  for the return value.

	* test/benchmark: remove preemptive test instead of skipping
	  I removed the preemptive test I wrote for Feature #4197.
	  I'll add it back when the implementation will be able to satisfy it.

	* lib/benchmark (Benchmark#bmbm): remove useless explicit call,
	  #format is an alias of #to_s test/benchmark: add a test for
	  format of long time.

	* lib/benchmark: fix label width: always add 1 to ensure there is a
	  space delimiter even with times over 100s
	  When I asked for Feature #4197, I wanted to make delimiting spaces
	  consistent for #bm and #bmbm.
	  But with times over 100s, the output contains no space between the
	  label and the first time (user).
	  Now both ensure there is always a space, even if that means 3 spaces
	  with times under 10s (because it is formatted as %10.6f)

	* test/benchmark: let labels be a constant
	  lib/benchmark (Benchmark#realtime): avoid creating an unused Proc
	  lib/benchmark (Benchmark#benchmark): use ensure clause to restore
	  STDOUT.sync, as in #bmbm

